/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.action;

import java.util.List;
import java.util.Vector;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gef.GraphicalViewer;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.about.IInstallationPageContainer;

import com.bitctrl.lib.eclipse.emf.gef.commands.SetCommand;
import com.sun.corba.se.spi.orbutil.fsm.Guard.Result;

import de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage;
import de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract;
import de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeQuerschnittModelTypAbstract;
import de.bsvrz.buv.plugin.anlagendarstellung.dav.DaVKommunikationDobj;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypAEditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypBEditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypBlinkerBEditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypBlinkerEditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypC2EditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypCEditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypD2EditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypD3EditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypDEditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypT2EditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypTEditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypW11EditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypW1EditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.AnzeigeTypWEditPart;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.AnzeigeElementFigure;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.AnzeigeInhaltAuswahlDialog;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.AnzeigeInhaltFreiTextDialog;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.fonts.VisuAnzeigeKapsel;
import de.bsvrz.buv.plugin.anlagendarstellung.model.AnzeigeInhaltTyp;
import de.bsvrz.buv.plugin.anlagendarstellung.sonderprogramm.DynamischerWechselText.EnumDynamischerWechseltextTextAusrichtung;
import de.bsvrz.buv.plugin.anlagendarstellung.util.DaVHelper;
import de.bsvrz.buv.plugin.darstellung.editparts.AnsichtEditPart;
import de.bsvrz.buv.plugin.darstellung.model.Ansicht;
import de.bsvrz.buv.plugin.darstellung.model.Ebene;
import de.bsvrz.buv.plugin.darstellung.model.StilisierteDarstellung;
import de.bsvrz.buv.plugin.dobj.model.DoModel;
import de.bsvrz.dav.daf.main.ClientDavConnection;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.Data.ReferenceArray;
import de.bsvrz.dav.daf.main.Data.TextValue;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;

/**
 * Action zur Anzeige der Auswahl fr Anzeigen imm Kontext der Rckmeldungen. 
 * Es kann nichts verndert werden, nur schauen welche Inhalte mglich sind.
 * @author Pittner
 *
 */
public class ActionKontextIstZustandAnzeigeABC implements IWorkbenchWindowActionDelegate
{
  private IWorkbenchPart _workbenchPart;
  private ClientDavInterface _connection;
 
  @Override
  public void dispose()
  {
    // TODO Auto-generated method stub
  }

  @Override
  public void init(IWorkbenchWindow window)
  {
    _workbenchPart = window.getActivePage().getActivePart();
    _connection = DaVKommunikationDobj.getInstanz().holeDaVVerbindung();
  }

  @Override
  public void run(IAction action)
  {
    GraphicalViewer viewer = getViewer();
    if (viewer != null)
    {
      ISelection selection = viewer.getSelection();
      StructuredSelection ss = (StructuredSelection)selection;
      Object obj = ss.getFirstElement();

      AnzeigeModelTypAbstract doModel = null;
      AnzeigeElementFigure figure = null;

      if (obj instanceof AnzeigeTypAEditPart)
      {
        AnzeigeTypAEditPart domep = (AnzeigeTypAEditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypBEditPart)
      {
        AnzeigeTypBEditPart domep = (AnzeigeTypBEditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypBlinkerBEditPart)
      {
        AnzeigeTypBlinkerBEditPart domep = (AnzeigeTypBlinkerBEditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypBlinkerEditPart)
      {
        AnzeigeTypBlinkerEditPart domep = (AnzeigeTypBlinkerEditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypCEditPart)
      {
        AnzeigeTypCEditPart domep = (AnzeigeTypCEditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypC2EditPart)
      {
        AnzeigeTypC2EditPart domep = (AnzeigeTypC2EditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypDEditPart)
      {
        AnzeigeTypDEditPart domep = (AnzeigeTypDEditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypD2EditPart)
      {
        AnzeigeTypD2EditPart domep = (AnzeigeTypD2EditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypD3EditPart)
      {
        AnzeigeTypD3EditPart domep = (AnzeigeTypD3EditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypTEditPart)
      {
        AnzeigeTypTEditPart domep = (AnzeigeTypTEditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypT2EditPart)
      {
        AnzeigeTypT2EditPart domep = (AnzeigeTypT2EditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypWEditPart)
      {
        AnzeigeTypTEditPart domep = (AnzeigeTypTEditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypW1EditPart)
      {
        AnzeigeTypW1EditPart domep = (AnzeigeTypW1EditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }
      else if (obj instanceof AnzeigeTypW11EditPart)
      {
        AnzeigeTypW11EditPart domep = (AnzeigeTypW11EditPart)obj;
        figure = (AnzeigeElementFigure)domep.getFigure();
        doModel = (AnzeigeModelTypAbstract)domep.getModel();
      }

      SystemObject[] fonts = DaVHelper.holeFontsUeberAnzeige(_connection, doModel.getSystemObject());
      if (!(obj instanceof AnzeigeTypDEditPart || obj instanceof AnzeigeTypD3EditPart))
      {
        AnzeigeInhaltAuswahlDialog anzeigeInhaltAuswahlDialog = new AnzeigeInhaltAuswahlDialog(PlatformUI
            .getWorkbench().getDisplay().getActiveShell(), true);
        if (doModel != null && figure != null)
        {
          
          EList<String> inhalte1 = (EList<String>)doModel.getInhalte1();
          if (inhalte1 != null)
          {
//            inhalte1.add(AnzeigeInhaltTyp.BELIEBIG_BI.getType());

            if (obj instanceof AnzeigeTypC2EditPart)
              inhalte1.add(AnzeigeInhaltTyp.FREITEXT_BI.getType());
            
            Object value = doModel.eGet(AnlagendarstellungPackage.Literals.ANZEIGE_MODEL_TYP_ABSTRACT__DATA_UPDATE);
            
            // Informationen fr Zugriff auf gestrte Inhalte bergeben
     
            AnzeigeQuerschnittModelTypAbstract aq = DaVHelper.holeAnzeigeQuerschnittVonAnzeige(_connection, viewer, doModel);

            int kontext = aq.getKontext(); // Kontext aus AQ holen
            
            if (kontext == 0) // Ist-Kontext
            {  
              List<String> listeGestoerteInhalte = new Vector<String>();
              
              SystemObject anzeige = doModel.getSystemObject();
              DataModel dataModel = _connection.getDataModel();
              AttributeGroup atg = dataModel.getAttributeGroup("atg.anzeigeEigenschaftIst");
              AttributeGroup atgWvzInhalt = dataModel.getAttributeGroup("atg.wvzInhalt");
              Aspect asp = dataModel.getAspect("asp.aqZustand");
              
              if ((atg != null) && (asp != null))
              {
                DataDescription dd = new DataDescription(atg, asp);
                
                if (dd != null)
                {
                  ResultData resultData = _connection.getData(anzeige, dd, 0L);
  
                  if ((resultData != null) && (resultData.hasData()))
                  {
                    Data data = resultData.getData();
                    
                    ReferenceArray array = data.getReferenceArray("GestrteInhalte");
                    
                    if (array != null)
                    {
                      if (array.getLength() > 0)
                      {
                        for (int i = 0; i < array.getLength(); i++)
                        {
                          SystemObject wvzInhalt = array.getReferenceValue(i).getSystemObject();
                          
                          Data dataWvzInhalt = wvzInhalt.getConfigurationData(atgWvzInhalt);
                          
                          if (dataWvzInhalt != null)
                          {
                            String bildinhalt = dataWvzInhalt.getTextValue("Bildinhalt").getValueText();
                            
                            listeGestoerteInhalte.add(bildinhalt);
                          }
                        }
                      }
                    }
                  }
                }
              }
              
              anzeigeInhaltAuswahlDialog.setListeGestoerteInhalte(listeGestoerteInhalte);
            }
            
            AnzeigeInhaltTyp inhalt = anzeigeInhaltAuswahlDialog.oeffne(figure.getTyp(), inhalte1);
            
            if (value instanceof AnzeigeInhaltTyp)
            {
              AnzeigeInhaltTyp inhaltAlt = (AnzeigeInhaltTyp)value;
              if (!inhaltAlt.equals(inhalt)){
                doModel.setAbsolutNotwendig(0);
                doModel.setNotwendig(0);
                doModel.setBlinken(0);
                doModel.setBlinktakt("Undefiniert");
                doModel.setPrioritaet("Undefiniert");
              }
            }
                                    
            if (inhalt != null && inhalt.equals(AnzeigeInhaltTyp.FREITEXT_BI))
            {
              AnzeigeInhaltFreiTextDialog freiTextAuswahlDialog = new AnzeigeInhaltFreiTextDialog(PlatformUI
                  .getWorkbench().getDisplay().getActiveShell());

              if (doModel != null && figure != null)
              {
                VisuAnzeigeKapsel kapsel = null;
                if (value instanceof VisuAnzeigeKapsel)
                {
                  kapsel = (VisuAnzeigeKapsel)value;
                }
//                else if (value instanceof ResultData)
//                {
//                  ResultData result = (ResultData)value;
//                  kapsel = DaVHelper.holeDynamischerWechselTextAusDaVData(result);                 
//                }
                else
                {
                  kapsel = new VisuAnzeigeKapsel();
                  kapsel.setAbstand(0);
                  kapsel.setAusrichtung(EnumDynamischerWechseltextTextAusrichtung.Zentriert.toString());                   
                  kapsel.setSchriftart(fonts[0].getPid());
                  kapsel.setPidsZeichen(new String[0]);
                }
                // nur ffnen, nichts tun
//                kapsel = freiTextAuswahlDialog.oeffne(kapsel, doModel.getSystemObject());
              }
            }
          }
        }
      }
      else
      {
        AnzeigeInhaltFreiTextDialog anzeigeInhaltAuswahlDialog = new AnzeigeInhaltFreiTextDialog(PlatformUI
            .getWorkbench().getDisplay().getActiveShell());

        if (doModel != null && figure != null)
        {

          Object value = doModel.eGet(AnlagendarstellungPackage.Literals.ANZEIGE_MODEL_TYP_ABSTRACT__DATA_UPDATE);
          
//          System.out.println("ActionKontextIstZustandAnzeigeABC.run(value): " + value);
          
          VisuAnzeigeKapsel kapsel = null;
          if (value instanceof VisuAnzeigeKapsel)
          {
            kapsel = (VisuAnzeigeKapsel)value;
          }
//          else if (value instanceof ResultData)
//          {
//            ResultData result = (ResultData)value;
//            kapsel = DaVHelper.holeDynamischerWechselTextAusDaVData(result);
//            
//          }
          else{
            kapsel = new VisuAnzeigeKapsel(new String[] {}, fonts[0].getPid(),
                EnumDynamischerWechseltextTextAusrichtung.Linksbndig.toString(), 4);
          }
          // nur ffnen, nichts tun
          
//          System.out.println("ActionKontextIstZustandAnzeigeABC.run(oeffne2!!!)");          
//          anzeigeInhaltAuswahlDialog.oeffne(kapsel, doModel.getSystemObject());
        }
      }

    }
    else
    {
      System.out.println("Viewer ist null");
    }
  }

  @Override
  public void selectionChanged(IAction action, ISelection selection)
  {
  }

  /**
   * @return
   */
  protected IWorkbenchPart getWorkbenchPart()
  {
    return _workbenchPart;
  }

  /**
   * Gibt den {@link GraphicalViewer} des Workbench Parts zurck.
   * 
   * @return der Viewer oder <code>null</code>, wenn es keinen gibt.
   */
  protected GraphicalViewer getViewer()
  {
    return (GraphicalViewer)getWorkbenchPart().getAdapter(GraphicalViewer.class);
  }

  /**
   * 
   * @param workbenchPart
   */
  protected void setWorkbenchPart(IWorkbenchPart workbenchPart)
  {
    _workbenchPart = workbenchPart;
  }

}
