package de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts;

import java.text.SimpleDateFormat;

public class ADefs
{

	public static final int KONTEXT_IST_ZUSTAND = 0;
	public static final int KONTEXT_SOLL_ZUSTAND = 1;
	/**
	 * Kontext Handschaltung.
	 */
	public static final int KONTEXT_HANDSCHALTUNG = 2;
	public static final int KONTEXT_SIMULATION = 3;
	public static final int KONTEXT_TRICHTER = 4;
	public static final int KONTEXT_PARAMETER = 5;
	/**
	 * Kontext Parameter (VM) Verriegelungsmatrix
	 */
	public static final int KONTEXT_PARAMETER_VM = 6;

	public static final int BLINKEN_EIN = 1;
	public static final int BLINKEN_AUS = 0;

	/**
	 * Offset fr eine Textzeile in der Figure.
	 */
	public static final int TEXT_Y_ZEILEN_OFFSET = 15;

	/**
	 * Breite fr das Zeit-Feld
	 */
	public static final int WIDTH_TEXT_ZEIT = 35;

	/**
	 * Hhe des Zeitfeldes
	 */
	public static final int HEIGHT_TEXT_ZEIT = 15;

	/**
	 * AddOn fr die Breite des Rahmens
	 */
	public static final int FRAME_WIDTH_ADD = 4;

	/**
	 * AddOn fr die Hhe des Rahmens.
	 */
	public static final int FRAME_HEIGHT_ADD = 4;

	/**
	 * AddOn fr die Breite des Rahmens der Symbole
	 */
	public static final int SYMBOL_WIDTH_ADD = 4;

	/**
	 * AddOn fr die Hhe des Rahmens der Symbole
	 */
	public static final int SYMBOL_HEIGHT_ADD = 4;

	/**
	 * Offset in X- und Y-Richtung fr die MLK.
	 */
	public static final int MLK_OFFSET = 25;

	/**
	 * Formatierung <code>HH:mm</code>
	 */
	public static final SimpleDateFormat SDF_ZEIT = new SimpleDateFormat("HH:mm");

	/**
	 * Formatierung <code>dd.MM.yyyy HH:mm:ss</code>
	 */
	public static final SimpleDateFormat SDF_DATUM_ZEIT = new SimpleDateFormat(
			"dd.MM.yyyy HH:mm:ss");

	/*
	 * Auswertung von Helligkeit und Betriebsart
	 */
	/**
	 * Typ <code>typ.anzeigeQuerschnitt</code>.
	 */
	public static final String TYP_ANZEIGE_QUERSCHNITT = "typ.anzeigeQuerschnitt";

	/**
	 * ATG <code>atg.anzeigeQuerschnittEigenschaftIst</code>.
	 */
	public static final String ATG_ANZEIGE_QUERSCHNITT_EIGENSCHAFT_IST = "atg.anzeigeQuerschnittEigenschaftIst";

	/**
	 * ASP <code>asp.aqZustand</code>.
	 */
	public static final String ASP_AQ_ZUSTAND = "asp.aqZustand";

	/*
	 * Auswertung von Hand- und Sonderprogramm
	 */
	/**
	 * Typ <code>typ.sbaAnzeigeQuerschnitt</code>.
	 */
	public static final String TYP_SBA_ANZEIGE_QUERSCHNITT = "typ.sbaAnzeigeQuerschnitt";

	/**
	 * ATG <code>atg.sbaAnzeigeQuerschnittStatusProgramm</code>
	 */
	public static final String ATG_SBA_ANZEIGE_QUERSCHNITT_STATUS_PROGRAMM = "atg.sbaAnzeigeQuerschnittStatusProgramm";

	/**
	 * ASP <code>asp.sbaZustand</code>
	 */
	public static final String ASP_SBA_ZUSTAND = "asp.sbaZustand";

	/**
	 * ATG <code>atg.sbaAnzeigeQuerschnitt</code>, Abrufen der Zuordnung von SbaAQ
	 * zu AQ
	 */
	public static final String ATG_SBA_ANZEIGE_QUERSCHNITT = "atg.sbaAnzeigeQuerschnitt";

	/**
	 * ATG <code>atg.sbaAnzeigeQuerschnittStatusHelligkeit</code> zum Abrufen der
	 * Helligkeit/Stufe fr SBA AQs im IST und SOLL.
	 */
	public static final String ATG_SBA_ANZEIGE_QUERSCHNITT_STATUS_HELLIGKEIT = "atg.sbaAnzeigeQuerschnittStatusHelligkeit";

	/**
	 * Auslesen der Helligkeit eines Handeingriffs unter dem Aspekt
	 * {@link ADefs#ASP_SBA_HANDSCHALTUNG_VORGABE}. Wenn Automatik und KEIN
	 * Prozentwert, wird
	 * {@link ADefs#ATG_SBA_ANZEIGE_QUERSCHNITT_STATUS_HELLIGKEIT} verwendet.
	 */
	public static final String ATG_SBA_HANDEINGRIFF_HELLIGKEIT = "atg.sbaHandeingriffHelligkeit";

	/**
	 * Aspekt <code>asp.sbaHandschaltungVorgabe</code>.
	 */
	public static final String ASP_SBA_HANDSCHALTUNG_VORGABE = "asp.sbaHandschaltungVorgabe";

	/**
	 * ATG <code>atg.sbaHelligkeitSteuerungStufe</code>. Hier kann ber Attribut
	 * <code>Steuerung</code> geprft werden, ob die Helligkeitssteuerung
	 * <b>lokal</b> oder ber <code>Stufe</code> statt findet.
	 */
	public static final String ATG_SBA_HELLIGKEIT_STEUERUNG_STUFE = "atg.sbaHelligkeitSteuerungStufe";

	/**
	 * ASP <code>asp.parameterSoll</code>.
	 */
	public static final String ASP_PARAMETER_SOLL = "asp.parameterSoll";

	/**
	 * Liefert den Programmstatus fr den Soll-Zustand unter dem Aspekt
	 * {@link ADefs#ASP_SBA_ZUSTAND}
	 */
	public static final String ATG_SBA_ANZEIGE_QUERSCHNITT_STATUS_BEFEHLE = "atg.sbaAnzeigeQuerschnittStatusBefehle";

	/**
	 * Liefert die Betriebsart (Normalbetrieb/Blindbetrieb) fr den Soll-Zustand
	 * unter dem Aspekt <code>asp.sbaHandschaltungVorgabe</code>.
	 */
	public static final String ATG_SBA_HANDEINGRIFF_BETRIEBSART = "atg.sbaHandeingriffBetriebsart";

	/*
	 * Sonstiges
	 */
	public static final int WIDTH_A = 33;
	public static final int WIDTH_B_C = 41;

	/**
	 * Breite des Rechtselementes (Mit Helligkeit/Programmstatus etc.) bei
	 * Oben/Unten-Darstellung zum Contenpane.
	 */
	public static final int RECHTSELEMENT_BREITE_BEI_OBENUNTEN_DARSTELLUNG = 60;

	/**
	 * Hhe des Rechtselementes (Mit Helligkeit/Programmstatus etc.) bei
	 * Oben/Unten-Darstellung zum Contenpane.
	 */
	public static final int RECHTSELEMENT_HOEHE_BEI_OBENUNTEN_DARSTELLUNG = 30;
}
