package de.bsvrz.buv.plugin.anlagendarstellung.legende;


/**
 * Umfelddaten-Sensor Sichtweitestufedefinition.
 * 
 * @author Pittner
 */
public enum LegendeDefinitionUfdSensorSichtWeite {

	/** Helligkeit */
	SICHT_STOER("nicht ermittelbar/keine Daten", "icons/sicht_stoer.png"),
	/** Helligkeit */
	SICHT_STUFE_0("Sichtweite-Stufe 0", "icons/sicht_0.png"),
	/** Helligkeit */
	SICHT_STUFE_1("Sichtweite-Stufe 1", "icons/sicht_1.png"),
	/** Helligkeit */
	SICHT_STUFE_2("Sichtweite-Stufe 2", "icons/sicht_2.png"),
	/** Helligkeit */
	SICHT_STUFE_3("Sichtweite-Stufe 3", "icons/sicht_3.png"),
	/** Helligkeit */
	SICHT_STUFE_4("Sichtweite-Stufe 4", "icons/sicht_4.png"),
	/** Helligkeit */
	SICHT_STUFE_5("Sichtweite-Stufe 5", "icons/sicht_5.png");
	
	public static final String BEZEICHNUNG = "Sichtweite (SW)";

  /** Name der Funktionsgruppe. */
	private String name;
	
	/** Farbe der Funktionsgruppe. */
	private String path;

	/**
	 * Privater Konstruktor.
	 * 
	 * @param name
	 *            Name des Zustandes
	 */
	private LegendeDefinitionUfdSensorSichtWeite(final String name, String path) {
		this.name = name;
		this.path = path;
	}

	/**
	 * Gibt den Namen der Funktionsgruppe zur&uuml;ck.
	 * 
	 * @return Name des Zustandes
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * Gibt den Namen der Funktionsgruppe zur&uuml;ck.
	 * 
	 * @return Name des Zustandes
	 */
	public String getPfad() {
	  return path;
	}
	
	public String getBezeichnnung()
	{
	  // TODO Auto-generated method stub
	  return BEZEICHNUNG;
	}
}
