/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.model;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Typklasse fr Picker
 * 
 * @author Pittner
 * 
 */
public class PickerTyp
{

  private static List typen = new ArrayList();

  public static PickerTyp PICKER_START = new PickerTyp("PICKER-START");

  public static PickerTyp PICKER_STOP = new PickerTyp("PICKER-STOP");

  private String type;

  private PickerTyp(String type)
  {
    this.type = type;
    String typeToAdd = this.getType();
    typen.add(typeToAdd);
  }

  /**
   * @return Returns the type.
   */
  public String getType()
  {
    return type;
  }

  public static boolean hasType(String type)
  {
    return typen.contains(type.toUpperCase());
  }

  public static String getTypes()
  {
    StringBuffer typeBuffer = new StringBuffer();
    for (Iterator iter = typen.iterator(); iter.hasNext();)
    {
      String element = (String)iter.next();
      typeBuffer.append(element).append(", ");
    }
    if (typen.size() >= 1)
    {
      typeBuffer.delete(typeBuffer.length() - 2, typeBuffer.length());
    }
    return typeBuffer.toString();
  }

  /*
   * (non-Javadoc)
   * 
   * @see de.bsvrz.buv.plugin.anlagendarstellung.status.Status#setStatus(java.lang.String)
   */
  public PickerTyp setTyp(String s)
  {
    // TODO Auto-generated method stub
    PickerTyp ait = null;

    if (s.equals(PICKER_START.getType()))
      ait = PICKER_START;
    else if (s.equals(PICKER_STOP.getType()))
      ait = PICKER_STOP;
    else
    {

    }

    return ait;
  }

}
