package de.bsvrz.buv.plugin.anlagendarstellung.semi;

import de.bsvrz.buv.plugin.anlagendarstellung.sonderprogramm.SonderProgramm;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.SystemObject;

/**
 * Die Klasse speichert die Daten der Attributgruppe atg.massnahmenAnforderungGUI
 * 
 * @author Pittner
 *
 */
public class MassnahmenAnfrageGuiData
{

  private SystemObject ursachenEinheit = null;        
  private boolean spontan = false;
  private boolean loeschen = false;
  
  private long nummer = 0L;
  private String absenderAlgorithmus = null;
  private SystemObject absenderApplikation = null;
  private SystemObject empfaenger = null;
  private int alternative = 0;
  
  private Aspect aspekt = null;
  private SonderProgramm[] schaltbBilder = null;
  
  
  public MassnahmenAnfrageGuiData(SystemObject ursachenEinheit, boolean spontan, boolean loeschen, long nummer,
      String absenderAlgorithmus, SystemObject absenderApplikation, SystemObject empfaenger, int alternative, Aspect aspekt, SonderProgramm[] schaltbBilder)
  {
    this.ursachenEinheit = ursachenEinheit;
    this.spontan = spontan;
    this.loeschen = loeschen;
    this.nummer = nummer;
    this.absenderAlgorithmus = absenderAlgorithmus;
    this.absenderApplikation = absenderApplikation;
    this.empfaenger = empfaenger;
    this.alternative = alternative;
    this.aspekt = aspekt;
    this.schaltbBilder  = schaltbBilder;
  }
  public SystemObject getUrsachenEinheit()
  {
    return ursachenEinheit;
  }
  public void setUrsachenEinheit(SystemObject ursachenEinheit)
  {
    this.ursachenEinheit = ursachenEinheit;
  }
  public boolean isSpontan()
  {
    return spontan;
  }
  public void setSpontan(boolean spontan)
  {
    this.spontan = spontan;
  }
  public boolean isLoeschen()
  {
    return loeschen;
  }
  public void setLoeschen(boolean loeschen)
  {
    this.loeschen = loeschen;
  }
  public long getNummer()
  {
    return nummer;
  }
  public void setNummer(long nummer)
  {
    this.nummer = nummer;
  }
  public String getAbsenderAlgorithmus()
  {
    return absenderAlgorithmus;
  }
  public void setAbsenderAlgorithmus(String absenderAlgorithmus)
  {
    this.absenderAlgorithmus = absenderAlgorithmus;
  }
  public SystemObject getAbsenderApplikation()
  {
    return absenderApplikation;
  }
  public void setAbsenderApplikation(SystemObject absenderApplikation)
  {
    this.absenderApplikation = absenderApplikation;
  }
  public SystemObject getEmpfaenger()
  {
    return empfaenger;
  }
  public void setEmpfaenger(SystemObject empfaenger)
  {
    this.empfaenger = empfaenger;
  }
  public int getAlternative()
  {
    return alternative;
  }
  public void setAlternative(int alternative)
  {
    this.alternative = alternative;
  }
  public Aspect getAspekt()
  {
    return aspekt;
  }
  public void setAspekt(Aspect aspekt)
  {
    this.aspekt = aspekt;
  }
  public SonderProgramm[] getSchaltbBilder()
  {
    return schaltbBilder;
  }
  public void setSchaltbBilder(SonderProgramm[] schaltbBilder)
  {
    this.schaltbBilder = schaltbBilder;
  }
  @Override
  public int hashCode()
  {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((absenderAlgorithmus == null) ? 0 : absenderAlgorithmus.hashCode());
    result = prime * result + ((absenderApplikation == null) ? 0 : absenderApplikation.hashCode());
    result = prime * result + alternative;
    result = prime * result + ((empfaenger == null) ? 0 : empfaenger.hashCode());
    result = prime * result + (loeschen ? 1231 : 1237);
    result = prime * result + (int)(nummer ^ (nummer >>> 32));
    result = prime * result + (spontan ? 1231 : 1237);
    result = prime * result + ((ursachenEinheit == null) ? 0 : ursachenEinheit.hashCode());
    result = prime * result + ((aspekt == null) ? 0 : aspekt.hashCode());
    return result;
  }
  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    MassnahmenAnfrageGuiData other = (MassnahmenAnfrageGuiData)obj;
    if (absenderAlgorithmus == null)
    {
      if (other.absenderAlgorithmus != null)
        return false;
    }
    else if (!absenderAlgorithmus.equals(other.absenderAlgorithmus))
      return false;
    if (absenderApplikation == null)
    {
      if (other.absenderApplikation != null)
        return false;
    }
    else if (!absenderApplikation.equals(other.absenderApplikation))
      return false;
    if (alternative != other.alternative)
      return false;
    if (empfaenger == null)
    {
      if (other.empfaenger != null)
        return false;
    }
    else if (!empfaenger.equals(other.empfaenger))
      return false;
    if (loeschen != other.loeschen)
      return false;
    if (nummer != other.nummer)
      return false;
    if (spontan != other.spontan)
      return false;
    if (ursachenEinheit == null)
    {
      if (other.ursachenEinheit != null)
        return false;
    }
    else if (!ursachenEinheit.equals(other.ursachenEinheit))
      return false;
    if (aspekt == null)
    {
      if (other.aspekt != null)
        return false;
    }
    else if (!aspekt.equals(other.aspekt))
      return false;
    return true;
  }
   
}
