/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/*
 * Rahmenwerk-Plug-in "Baustellen- und Unfalleingabe"
 * Copyright (C) 2009 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.buv.plugin.baueditor.sts;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.BaustellenWrapper;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.EngstellenWrapper;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.SituationsWrapper;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.UnfallWrapper;
import de.bsvrz.buv.plugin.ereigniskal.EreignisKalenderVerwaltung;
import de.bsvrz.buv.plugin.ereigniskal.editors.EreignisEditorInput;
import de.bsvrz.buv.plugin.ereigniskal.editors.VerkehrGueltigkeitsEintrag;
import de.bsvrz.buv.rw.basislib.login.UrlasserDialog.UrlasserDialogInfo;
import de.bsvrz.dav.daf.main.config.ConfigurationChangeException;
import de.bsvrz.sys.funclib.bitctrl.daf.DavTools;
import de.bsvrz.sys.funclib.bitctrl.modell.AnmeldeException;
import de.bsvrz.sys.funclib.bitctrl.modell.DatensendeException;
import de.bsvrz.sys.funclib.bitctrl.modell.DynamischesObjekt;
import de.bsvrz.sys.funclib.bitctrl.modell.ObjektFactory;
import de.bsvrz.sys.funclib.bitctrl.modell.OnlineDatum;
import de.bsvrz.sys.funclib.bitctrl.modell.ParameterDatensatz;
import de.bsvrz.sys.funclib.bitctrl.modell.SystemObjekt;
import de.bsvrz.sys.funclib.bitctrl.modell.att.Feld;
import de.bsvrz.sys.funclib.bitctrl.modell.att.RelativerZeitstempel;
import de.bsvrz.sys.funclib.bitctrl.modell.att.Zeitstempel;
import de.bsvrz.sys.funclib.bitctrl.modell.fachmodellglobal.attribute.AttStreckeMeter;
import de.bsvrz.sys.funclib.bitctrl.modell.fachmodellglobal.attribute.AttZahlPositiv;
import de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdInfo;
import de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.Benutzer;
import de.bsvrz.sys.funclib.bitctrl.modell.tmereigniskalenderglobal.attribute.AtlZusaetzlicheAttribute;
import de.bsvrz.sys.funclib.bitctrl.modell.tmereigniskalenderglobal.objekte.Ereignis;
import de.bsvrz.sys.funclib.bitctrl.modell.tmereigniskalenderglobal.objekte.EreignisTyp;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.attribute.AttFahrStreifenLage;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.attribute.AttVerkehrsStaerkeStunde;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.AeusseresStrassenSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Baustelle;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.InneresStrassenSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Situation;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.StrassenSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Unfall;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.VerkehrsModellNetz;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdSituationsEigenschaften.Daten;
import de.bsvrz.sys.funclib.debug.Debug;
import de.bsvrz.sys.funclib.dynobj.DynObjektException;

/**
 * Diese Hilfsklasse ist zur Verwaltung von Engstellen (Baustellen und Unfllen) zustndig. Sie stellt Methoden zum
 * Erzeugen und Lschen von Engstellen zur Verfgung.
 * 
 * @author BitCtrl Systems GmbH, Andreas Meissner
 * @version $Id: EngstellenVerwaltung.java,v 1.2 2014/11/14 07:29:40 Pittner Exp $
 */
public final class EngstellenVerwaltung
{

  /** Der TimeOut, welcher beim Senden der Daten verwendet werden soll. */
  private static final int TIMEOUT = 15000;

  /** Prfix der PID fr neu angelegte Baustellen. */
  private static final String PID_PREFIX_BAUSTELLE = "baustelle.";

  /** Prfix der PID fr neu angelegte Unflle. */
  private static final String PID_PREFIX_UNFALL = "unfall.";

  /** Prfix der PID fr neu angelegte Ereignisse. */
  private static final String PID_PREFIX_EREIGNIS = "ereignis.";

  /**
   * Privater Default-Konstruktor.
   */
  private EngstellenVerwaltung()
  {
  }

  /**
   * Hilfsmethode zum Speichern von Engstellen.
   * 
   * @param info
   *          die Informationen des zuvor aufgerufenen Urlasser-Dialogs, darf nicht <code>null</code> sein
   * @param wrapper
   *          die Engstelle, welche gespeichert bzw. neu angelegt werden soll, darf nicht <code>null</code> sein
   * @param neuErzeugteObjekte
   *          eine Liste die ggf. die neu erzeugte SystemObjekten enthlt (ggf. die neu erzeugte Engstelle und/oder das
   *          neu erzeugte Ereignis) (Collective Parameter Pattern)
   * 
   * @return den Status ber den Erfolg dieser Funktion
   */
  public static IStatus speicherEngstelle(final UrlasserDialogInfo info, final EngstellenWrapper wrapper,
      final List<DynamischesObjekt> neuErzeugteObjekte)
  {

    assert info != null;
    assert wrapper != null;
    assert wrapper instanceof BaustellenWrapper || wrapper instanceof UnfallWrapper;

    final Benutzer benutzer = getBenutzer(info.getBenutzeer());
    assert benutzer != null;

    if (!info.getEingabeOk())
    {
      return Status.OK_STATUS;
    }

    final Debug debug = Debug.getLogger();

    final ObjektFactory objektFactory = BauEditorPlugin.getDefault().getObjektFactory();
    final VerkehrsModellNetz netz = BauEditorPlugin.getDefault().getNetzCache().getNetz();

    if (objektFactory == null || netz == null)
    {
      return Status.OK_STATUS;
    }

    Situation situation = wrapper.getSituation();

    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdSituationsEigenschaften pdseDaten = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdSituationsEigenschaften.Daten pdseDatum = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdBaustellenEigenschaften pdbeDaten = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdBaustellenEigenschaften.Daten pdbeDatum = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdBaustellenEigenschaftenErweitert pdbeeDaten = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdBaustellenEigenschaftenErweitert.Daten pdbeeDatum = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdBaustellenVerantwortlicher pdbvDaten = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdBaustellenVerantwortlicher.Daten pdbvDatum = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdUnfallEigenschaften pdueDaten = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdUnfallEigenschaften.Daten pdueDatum = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdUnfallEigenschaftenErweitert pdueeDaten = null;
    de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdUnfallEigenschaftenErweitert.Daten pdueeDatum = null;

    // (1) Erzeuge zunchst ein Situation-SystemObjekt, wenn es sich um
    // eine neu anzulegende RDS-Meldung handelt
    String pid = null;
    if (wrapper.isNeuesElement() || situation == null)
    {

      debug.info("Situations-Objekt wird angelegt");

      // (1.1) Bestimme Pid
      final String prefix = wrapper instanceof BaustellenWrapper ? PID_PREFIX_BAUSTELLE : PID_PREFIX_UNFALL;

      final String id = bestimmePid(wrapper.getName(), prefix);
      int i = 2;
      pid = id;
      SystemObjekt objektMitPid = objektFactory.getModellobjekt(pid);
      while (objektMitPid != null)
      {
        pid = id + "." + i;
        objektMitPid = objektFactory.getModellobjekt(pid);
        i++;
      }

      // (1.2) Erzeuge Konfigurations-Datensatz Info
      final KdInfo datensatz = new KdInfo(null, objektFactory);
      final KdInfo.Daten datum = new KdInfo.Daten(datensatz, KdInfo.Aspekte.Eigenschaften);
      datum.setKurzinfo(wrapper.getKurzInfo());
      datum.setBeschreibung(wrapper.getBeschreibung());

      // (1.2) Erzeuge Engstelle
      try
      {

        if (wrapper instanceof BaustellenWrapper)
        {
          situation = objektFactory.createDynamischesObjekt(Baustelle.class, wrapper.getName(), pid, datum);

          // System.out.println("EngstellenVerwaltung.speicherEngstelle(): " + situation + " -> " + datum);

        }
        else
        {
          situation = objektFactory.createDynamischesObjekt(Unfall.class, wrapper.getName(), pid, datum);
        }

      }
      catch (final DynObjektException e)
      {
        final String message = "Engstelle konnte nicht erzeugt werden.";
        BauEditorPlugin.getDefault().getLogger().error(message, e);
        return new Status(IStatus.ERROR, BauEditorPlugin.PLUGIN_ID, message, e);
      }

      debug.info("Situations-Objekt: " + situation.getPid() + " angelegt");

      // (1.3) Fge neu erzeugte Engstelle der entsprechenden Menge hinzu
      debug.info("Situations-Objekt: " + situation.getPid() + " wird zur Menge hinzugefgt");
      try
      {

        if (wrapper instanceof BaustellenWrapper)
        {
          netz.getBaustellen().add((Baustelle)situation);
        }
        else
        {
          netz.getUnfaelle().add((Unfall)situation);
        }

      }
      catch (final IllegalStateException e)
      {

        final String message = "Engstelle konnte der Menge nicht hinzugefgt werden.";
        try
        {
          objektFactory.invalidateDynamischesObjekt(situation);
        }
        catch (final DynObjektException e1)
        {
          BauEditorPlugin.getDefault().getLogger().error("Engstelle konnte nicht invalidiert werden.", e1);
        }
        BauEditorPlugin.getDefault().getLogger().error(message, e);
        return new Status(IStatus.ERROR, BauEditorPlugin.PLUGIN_ID, message, e);
      }

      debug.info("Situations-Objekt: " + situation.getPid() + " wurde zur Menge hinzugefgt");

      // (1.4) Fge neu erzeugte Engstelle dem Collective-Parameter hinzu
      neuErzeugteObjekte.add(situation);

      // (1.5) Erzeuge Daten
      pdseDaten = situation.getPdSituationsEigenschaften();
      pdseDatum = pdseDaten.createDatum();
      if (situation instanceof Baustelle)
      {
        final Baustelle baustelle = (Baustelle)situation;
        pdbeDaten = baustelle.getPdBaustellenEigenschaften();
        pdbeDatum = pdbeDaten.createDatum();
        pdbeeDaten = baustelle.getPdBaustellenEigenschaftenErweitert();
        pdbeeDatum = pdbeeDaten.createDatum();
        pdbvDaten = baustelle.getPdBaustellenVerantwortlicher();
        pdbvDatum = pdbvDaten.createDatum();
      }
      else if (situation instanceof Unfall)
      {
        final Unfall unfall = (Unfall)situation;
        pdueDaten = unfall.getPdUnfallEigenschaften();
        pdueDatum = pdueDaten.createDatum();
        pdueeDaten = unfall.getPdUnfallEigenschaftenErweitert();
        pdueeDatum = pdueeDaten.createDatum();
      }

    }
    else
    {

      pid = situation.getPid();

      pdseDaten = situation.getPdSituationsEigenschaften();
      pdseDatum = pdseDaten.getDatum();
      if (situation instanceof Baustelle)
      {
        final Baustelle baustelle = (Baustelle)situation;
        pdbeDaten = baustelle.getPdBaustellenEigenschaften();
        pdbeDatum = pdbeDaten.getDatum();
        pdbeeDaten = baustelle.getPdBaustellenEigenschaftenErweitert();
        pdbeeDatum = pdbeeDaten.getDatum();
        pdbvDaten = baustelle.getPdBaustellenVerantwortlicher();
        pdbvDatum = pdbvDaten.getDatum();
      }
      else if (situation instanceof Unfall)
      {
        final Unfall unfall = (Unfall)situation;
        pdueDaten = unfall.getPdUnfallEigenschaften();
        pdueDatum = pdueDaten.getDatum();
        pdueeDaten = unfall.getPdUnfallEigenschaftenErweitert();
        pdueeDatum = pdueeDaten.getDatum();
      }

    }

    // (2) Setze ggf. den Namen
    if (!situation.getName().equals(wrapper.getName()))
    {
      try
      {
        situation.getSystemObject().setName(wrapper.getName());
      }
      catch (final ConfigurationChangeException e)
      {
        BauEditorPlugin.getDefault().getLogger().error(e.getLocalizedMessage(), e);
        return new Status(IStatus.ERROR, BauEditorPlugin.PLUGIN_ID, "Engstelle konnte nicht umbenannt werden.", e);
      }
    }

    // (3) Aktualisiere und Sende 'PdSituationsEigenschaften'
    aktualisiereSitationsEigenschaften(wrapper, pdseDatum, benutzer, info.getUrsache(), info.getVeranlasser());
    // System.out.println("0:" + pdseDaten + " -> " + pdseDatum);
    IStatus status = sendeDatum(pdseDaten, pdseDatum, wrapper.isNeuesElement());

    // System.out.println("1:" + status);

    // (4) Aktualisiere und Sende Parameterdatenstze fr eine Baustelle
    if (wrapper instanceof BaustellenWrapper)
    {
      final BaustellenWrapper baustellenWrapper = (BaustellenWrapper)wrapper;

      // (4.1) Aktualisiere und Sende 'PdBaustellenEigenschaften'
      if (status.isOK())
      {
        aktualisiereBaustellenEigenschaften(baustellenWrapper, pdbeDatum, benutzer, info.getUrsache(), info
            .getVeranlasser());
        status = sendeDatum(pdbeDaten, pdbeDatum, wrapper.isNeuesElement());
      }

      // System.out.println("2:" + status);
      // (4.2) Aktualisiere und Sende 'PdBaustellenEigenschaftenErweitert'
      if (status.isOK())
      {
        aktualisiereBaustellenEigenschaftenErweitert(baustellenWrapper, pdbeeDatum, benutzer, info.getUrsache(), info
            .getVeranlasser());
        status = sendeDatum(pdbeeDaten, pdbeeDatum, wrapper.isNeuesElement());
      }

      // System.out.println("3:" + status);
      // (4.3) Aktualisiere und Sende 'PdBaustellenVerantwortlichen'
      if (status.isOK())
      {
        aktualisiereBaustellenVerantwortlichen(baustellenWrapper, pdbvDatum, benutzer, info.getUrsache(), info
            .getVeranlasser());
        status = sendeDatum(pdbvDaten, pdbvDatum, wrapper.isNeuesElement());
      }
      // System.out.println("4:" + status);
    }

    // (5) Aktualisiere und Sende Parameterdatenstze fr einen Unfall
    if (wrapper instanceof UnfallWrapper)
    {
      final UnfallWrapper unfallWrapper = (UnfallWrapper)wrapper;

      // (5.1) Aktualisiere und Sende 'PdUnfallEigenschaften'
      if (status.isOK())
      {
        aktualisiereUnfallEigenschaften(unfallWrapper, pdueDatum, benutzer, info.getUrsache(), info.getVeranlasser());
        status = sendeDatum(pdueDaten, pdueDatum, wrapper.isNeuesElement());
      }

      // (5.2) Aktualisiere und Sende 'PdUnfallEigenschaften'
      if (status.isOK())
      {
        aktualisiereUnfallEigenschaftenErweitert(unfallWrapper, pdueeDatum, benutzer, info.getUrsache(), info
            .getVeranlasser());
        status = sendeDatum(pdueeDaten, pdueeDatum, wrapper.isNeuesElement());
      }
    }

    // (6) Wenn beim Senden der Daten bei einer neu angelegten Engstelle ein
    // Problem aufgetreten ist, entferne die Engstelle aus der Menge und
    // invalidiere die Engstelle.
    if (wrapper.isNeuesElement() && !status.isOK())
    {
      if (wrapper instanceof BaustellenWrapper)
      {
        netz.getBaustellen().remove(situation);
      }
      else
      {
        netz.getUnfaelle().remove(situation);
      }
      try
      {
        objektFactory.invalidateDynamischesObjekt(situation);
      }
      catch (final DynObjektException e)
      {
        BauEditorPlugin.getDefault().getLogger().error("Engstelle konnte nicht invalidiert werden.", e);
      }
    }

    // (7) Erzeuge oder Lsche dazugehriges Ereignis
    if (status.isOK())
    {
      final List<Ereignis> neuAngelegtesEreignis = new ArrayList<Ereignis>();
      status = verwalteEreignisObjekt(wrapper, info, pid, neuAngelegtesEreignis);
      if (neuAngelegtesEreignis != null && !neuAngelegtesEreignis.isEmpty())
      {
        neuErzeugteObjekte.add(neuAngelegtesEreignis.get(0));
      }
    }

    return status;
  }

  /**
   * Aktualisisiert den Paramaterdatensatz 'PdSituationsEigenschaften'.
   * 
   * @param wrapper
   *          die Situtation
   * @param daten
   *          das Datum
   * @param benutzer
   *          die Benutzerreferenz des Urlasser-Dialogs
   * @param ursache
   *          die Ursache des Urlasser-Dialogs
   * @param veranlasser
   *          der Veranlasser des Urlasser-Dialogs
   */
  private static void aktualisiereSitationsEigenschaften(final SituationsWrapper wrapper, final Daten daten,
      final Benutzer benutzer, final String ursache, final String veranlasser)
  {

    // Startzeit + Dauer
    final Zeitstempel startZeitstempel = new Zeitstempel(wrapper.getStartZeit().getTime());
    daten.setStartZeit(startZeitstempel);
    if (wrapper.getDauer() < 0)
    {
      daten.setDauer(new RelativerZeitstempel(0));
    }
    else
    {
      final RelativerZeitstempel dauerZeitstempel = new RelativerZeitstempel(wrapper.getDauer());
      daten.setDauer(dauerZeitstempel);
    }

    // Straensegmente + Lnge
    Long laenge = 0L;
    final Feld<StrassenSegment> strassenSegmenteFeld = daten.getStrassenSegment();
    strassenSegmenteFeld.clear();

    final List<StrassenSegment> strassenSegmente = new ArrayList<StrassenSegment>(wrapper.getStreckenAbschnitt()
        .getStrassenSegmente());
    double startOffset = wrapper.getStreckenAbschnitt().getStartOffset();
    double endOffset = wrapper.getStreckenAbschnitt().getEndOffset();

    // Entferne ggf. das erste uere Straensegment
    final AeusseresStrassenSegment startASS = wrapper.getStreckenAbschnitt().getStartASS();
    if (startASS != null)
    {
      final InneresStrassenSegment startISS = wrapper.getStreckenAbschnitt().getStartISS();
      final double startAssLaenge = wrapper.getStreckenAbschnitt().getLaenge(startASS);
      if (startISS != null && startOffset > startAssLaenge)
      {
        strassenSegmente.remove(startASS);
        startOffset -= startAssLaenge;
      }
    }

    // Entferne ggf. das letzte innere Straensegment
    final AeusseresStrassenSegment endASS = wrapper.getStreckenAbschnitt().getEndASS();
    if (endASS != null)
    {
      final InneresStrassenSegment endISS = wrapper.getStreckenAbschnitt().getEndISS();
      final double endAssLaenge = wrapper.getStreckenAbschnitt().getLaenge(endASS);
      if (endISS != null)
      {
        if (endOffset > endAssLaenge)
        {
          endOffset -= endAssLaenge;
        }
        else
        {
          strassenSegmente.remove(endISS);
        }
      }
    }

    // Setze die Straensegmente
    int i = 1;
    final int anzahl = strassenSegmente.size();
    for (final StrassenSegment segment : strassenSegmente)
    {
      if (!strassenSegmenteFeld.contains(segment))
      {
        strassenSegmenteFeld.add(segment);
        // Akkumuliere die Lnge. Bercksichtige dabei das letzte
        // Segment nicht
        if (i != anzahl)
        {
          final de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.konfigurationsdaten.KdStrassenSegment.Daten datum = segment
              .getKdStrassenSegment().getDatum();
          if (datum != null)
          {
            laenge += datum.getLaenge().longValue();
          }
        }
      }
      i++;
    }

    // Setze Offsets
    daten.setStartOffset(new AttStreckeMeter(Math.round(startOffset * 1000)));
    daten.setEndOffset(new AttStreckeMeter(Math.round(endOffset * 1000)));

    // Setze die um die Offsets bereinigte Lnge
    laenge -= daten.getStartOffset().longValue();
    laenge += daten.getEndOffset().longValue();
    if (laenge < 0)
    {
      laenge = 0L;
    }
    daten.setLaenge(new AttStreckeMeter(laenge));

    // Urlasser
    daten.getUrlasser().setBenutzerReferenz(benutzer);
    daten.getUrlasser().setUrsache(ursache);
    daten.getUrlasser().setVeranlasser(veranlasser);
  }

  /**
   * Aktualisisiert den Paramaterdatensatz 'PdBaustellenEigenschaften'.
   * 
   * @param wrapper
   *          die Baustelle
   * @param daten
   *          das Datum
   * @param benutzer
   *          die Benutzerreferenz des Urlasser-Dialogs
   * @param ursache
   *          die Ursache des Urlasser-Dialogs
   * @param veranlasser
   *          der Veranlasser des Urlasser-Dialogs
   */
  private static void aktualisiereBaustellenEigenschaften(final BaustellenWrapper wrapper,
      final de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdBaustellenEigenschaften.Daten daten,
      final Benutzer benutzer, final String ursache, final String veranlasser)
  {

    daten.setStatus(wrapper.getStatus());
    daten.setVeranlasser(wrapper.getVeranlasser());
    daten.setRestKapazitaet(new AttVerkehrsStaerkeStunde(wrapper.getEngpassKapazitaet()));

    // Urlasser
    daten.getUrlasser().setBenutzerReferenz(benutzer);
    daten.getUrlasser().setUrsache(ursache);
    daten.getUrlasser().setVeranlasser(veranlasser);
  }

  /**
   * Aktualisisiert den Paramaterdatensatz 'PdBaustellenEigenschaftenErweitert'.
   * 
   * @param wrapper
   *          die Baustelle
   * @param daten
   *          das Datum
   * @param benutzer
   *          die Benutzerreferenz des Urlasser-Dialogs
   * @param ursache
   *          die Ursache des Urlasser-Dialogs
   * @param veranlasser
   *          der Veranlasser des Urlasser-Dialogs
   */
  private static void aktualisiereBaustellenEigenschaftenErweitert(
      final BaustellenWrapper wrapper,
      final de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdBaustellenEigenschaftenErweitert.Daten daten,
      final Benutzer benutzer, final String ursache, final String veranlasser)
  {

    daten.setAnzahlGesperrteFahrstreifen(new AttZahlPositiv((long)wrapper.getLageGesperrterFahrstreifen().size()));

    final Feld<AttFahrStreifenLage> gesperrteFahrstreifen = daten.getLageGesperrteFahrstreifen();
    gesperrteFahrstreifen.clear();
    for (final AttFahrStreifenLage lage : wrapper.getLageGesperrterFahrstreifen())
    {
      if (!gesperrteFahrstreifen.contains(lage))
      {
        gesperrteFahrstreifen.add(lage);
      }
    }

    // Urlasser
    daten.getUrlasser().setBenutzerReferenz(benutzer);
    daten.getUrlasser().setUrsache(ursache);
    daten.getUrlasser().setVeranlasser(veranlasser);
  }

  /**
   * Aktualisisiert den Paramaterdatensatz 'PdBaustellenVerantwortlichen'.
   * 
   * @param wrapper
   *          die Baustelle
   * @param daten
   *          das Datum
   * @param benutzer
   *          die Benutzerreferenz des Urlasser-Dialogs
   * @param ursache
   *          die Ursache des Urlasser-Dialogs
   * @param veranlasser
   *          der Veranlasser des Urlasser-Dialogs
   */
  private static void aktualisiereBaustellenVerantwortlichen(final BaustellenWrapper wrapper,
      final de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdBaustellenVerantwortlicher.Daten daten,
      final Benutzer benutzer, final String ursache, final String veranlasser)
  {

    daten.setFirma(wrapper.getVerantwortlicheFirma());
    daten.setTelefonFirma(wrapper.getTelefonFirma());
    daten.setNameBaustellenVerantwortlicher(wrapper.getBaustellenVerantwortlicher());
    daten.setTelefonBaustellenVerantwortlicher(wrapper.getTelefonBaustellenVerantwortlicher());
    daten.setTelefonMobilBaustellenVerantwortlicher(wrapper.getMobilTelefonBaustellenVerantwortlicher());

    // Urlasser
    daten.getUrlasser().setBenutzerReferenz(benutzer);
    daten.getUrlasser().setUrsache(ursache);
    daten.getUrlasser().setVeranlasser(veranlasser);
  }

  /**
   * Aktualisisiert den Paramaterdatensatz 'PdUnfallEigenschaften'.
   * 
   * @param wrapper
   *          der Unfall
   * @param daten
   *          das Datum
   * @param benutzer
   *          die Benutzerreferenz des Urlasser-Dialogs
   * @param ursache
   *          die Ursache des Urlasser-Dialogs
   * @param veranlasser
   *          der Veranlasser des Urlasser-Dialogs
   */
  private static void aktualisiereUnfallEigenschaften(final UnfallWrapper wrapper,
      final de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdUnfallEigenschaften.Daten daten,
      final Benutzer benutzer, final String ursache, final String veranlasser)
  {

    daten.setRestKapazitaet(new AttVerkehrsStaerkeStunde(wrapper.getEngpassKapazitaet()));

    // Urlasser
    daten.getUrlasser().setBenutzerReferenz(benutzer);
    daten.getUrlasser().setUrsache(ursache);
    daten.getUrlasser().setVeranlasser(veranlasser);
  }

  /**
   * Aktualisisiert den Paramaterdatensatz 'PdUnfallEigenschaften'.
   * 
   * @param wrapper
   *          der Unfall
   * @param daten
   *          das Datum
   * @param benutzer
   *          die Benutzerreferenz des Urlasser-Dialogs
   * @param ursache
   *          die Ursache des Urlasser-Dialogs
   * @param veranlasser
   *          der Veranlasser des Urlasser-Dialogs
   */
  private static void aktualisiereUnfallEigenschaftenErweitert(final UnfallWrapper wrapper,
      final de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.parameter.PdUnfallEigenschaftenErweitert.Daten daten,
      final Benutzer benutzer, final String ursache, final String veranlasser)
  {

    daten.setAnzahlGesperrteFahrstreifen(new AttZahlPositiv((long)wrapper.getLageGesperrterFahrstreifen().size()));

    final Feld<AttFahrStreifenLage> gesperrteFahrstreifen = daten.getLageGesperrteFahrstreifen();
    gesperrteFahrstreifen.clear();
    for (final AttFahrStreifenLage lage : wrapper.getLageGesperrterFahrstreifen())
    {
      if (!gesperrteFahrstreifen.contains(lage))
      {
        gesperrteFahrstreifen.add(lage);
      }
    }

    // Urlasser
    daten.getUrlasser().setBenutzerReferenz(benutzer);
    daten.getUrlasser().setUrsache(ursache);
    daten.getUrlasser().setVeranlasser(veranlasser);
  }

  /**
   * Bestimmt die PID fr eine neu erzeugte Engstelle.
   * 
   * @param name
   *          der Name der Engstelle
   * @param prefix
   *          der Prfix der PID
   * 
   * @return die PID fr eine neu erzeugte RDS-Meldung
   */
  private static String bestimmePid(final String name, final String prefix)
  {
    return DavTools.generierePID(name, prefix);
  }

  /**
   * Sendet das gegebene Datum.
   * 
   * @param daten
   *          der Datensatz
   * @param datum
   *          das Datum
   * @param neueMeldung
   *          <code>true</code>, wenn es sich bei dem Datensatz um eine neu erstellte RDS-Meldung handelt, ansonsten
   *          <code>false</code>
   * 
   * @return den Status dieser Methode
   */
  @SuppressWarnings("unchecked")
  private static IStatus sendeDatum(@SuppressWarnings("rawtypes") final ParameterDatensatz daten,
      final OnlineDatum datum, final boolean neueMeldung)
  {
    try
    {
      daten.anmeldenSender();
      daten.sendeDatum(datum, TIMEOUT);
      return Status.OK_STATUS;
    }
    catch (final AnmeldeException e)
    {
      BauEditorPlugin.getDefault().getLogger().error(
          "Die Anmeldung als Sender ist fehlgeschlagen: " + daten.getSystemObjekt().getPid(), e);
      if (neueMeldung)
      {
        loescheEngstelle((Situation)daten.getSystemObjekt());
      }
      return new Status(IStatus.ERROR, BauEditorPlugin.PLUGIN_ID,
          "Es ist ein Fehler bei der Anmeldung als Sender aufgetreten.", e);
    }
    catch (final DatensendeException e)
    {
      BauEditorPlugin.getDefault().getLogger().error(
          "Ein Datum konnte nicht gesendet werden: " + daten.getSystemObjekt().getPid(), e);
      if (neueMeldung)
      {
        loescheEngstelle((Situation)daten.getSystemObjekt());
      }
      return new Status(IStatus.ERROR, BauEditorPlugin.PLUGIN_ID,
          "Es ist ein Fehler beim Senden der Daten aufgetreten.", e);
    }
  }

  /**
   * Lscht eine Engstelle.
   * 
   * @param engstelle
   *          die zu lschende Engstelle, darf nicht <code>null</code> sein
   */
  private static void loescheEngstelle(final Situation engstelle)
  {
    assert engstelle != null;
    final ObjektFactory objektFactory = BauEditorPlugin.getDefault().getObjektFactory();
    if (objektFactory == null)
    {
      return;
    }
    final VerkehrsModellNetz netz = BauEditorPlugin.getDefault().getNetzCache().getNetz();
    if (netz != null)
    {
      if (engstelle instanceof Baustelle)
      {
        netz.getBaustellen().remove(engstelle);
      }
      else if (engstelle instanceof Unfall)
      {
        netz.getUnfaelle().remove(engstelle);
      }
    }
    try
    {
      objektFactory.invalidateDynamischesObjekt(engstelle);
    }
    catch (final DynObjektException e)
    {
      BauEditorPlugin.getDefault().getLogger().error(
          "Die Baustelle konnte nicht gelscht werden: " + engstelle.getPid(), e);
    }
  }

  /**
   * Liefert das zu einem Namen passende Benutzer-Systemobjekt zurck.
   * 
   * @param benutzerName
   *          der Name des Benutzers, darf nicht <code>null</code> sein
   * 
   * @return das zu einem Namen passenden Benutzer-Systemobjekt, kann <code>null</code> sein
   */
  private static Benutzer getBenutzer(final String benutzerName)
  {
    final ObjektFactory objektFactory = BauEditorPlugin.getDefault().getObjektFactory();
    if (objektFactory == null)
    {
      return null;
    }
    final List<? extends SystemObjekt> benutzerListe = objektFactory.bestimmeModellobjekte(Benutzer.PID);

    for (final SystemObjekt systemObjekt : benutzerListe)
    {
      if (systemObjekt instanceof Benutzer)
      {
        if (((Benutzer)systemObjekt).getName().equals(benutzerName))
        {
          return (Benutzer)systemObjekt;
        }
      }
    }
    return null;
  }

  /**
   * Erzeugt bzw. aktualisiert das mit der gegebenen Engstelle verknpfte Ereignis.
   * 
   * @param wrapper
   *          die Engstelle
   * @param info
   *          die Eingabe des Urlasser-Dialogs
   * @param engstellenPid
   *          die Pid der Engstelle
   * @param neuAngelegtesEreignis
   *          eine Liste, die ggf. das neu erzeugte Ereignis enthlt (Collective Parameter Pattern)
   * 
   * @return das ggf. neu erzeugte Ereignis
   */
  private static IStatus verwalteEreignisObjekt(final EngstellenWrapper wrapper, final UrlasserDialogInfo info,
      final String engstellenPid, final List<Ereignis> neuAngelegtesEreignis)
  {

    final String ereignisPid = PID_PREFIX_EREIGNIS + engstellenPid;

    if (wrapper.getEreignis() != null && !wrapper.isVerknuepfeEreignis())
    {

      // (1) Lsche Ereignis-Objekt
      EreignisKalenderVerwaltung.getInstanz().entferneEreignis(wrapper.getEreignis());
      return Status.OK_STATUS;

    }
    else if (wrapper.getEreignis() == null && wrapper.isVerknuepfeEreignis())
    {

      // (2) Erzeuge ein neues Ereignis-Objekt

      // (2.1) Erzeuge Ereignis-EditorInput
      EreignisEditorInput ereignisDaten = null;

      final EreignisTyp ereignisTyp = wrapper.getEreignisTyp();
      if (ereignisTyp == null)
      {
        return Status.OK_STATUS;
      }

      final String beschreibung = (wrapper instanceof BaustellenWrapper ? "Ereignis zur Baustelle '"
          : "Ereignis zum Unfall '")
          + wrapper.getName() + "'";
      ereignisDaten = new EreignisEditorInput(ereignisTyp, wrapper.getName(), ereignisPid, beschreibung);

      // (2.2) Flle Daten
      // (2.2.1) Setze zeitliche Gltigkeit
      ereignisDaten.setBeginnZeitlicheGueltigkeit(wrapper.getStartZeit().getTime());
      ereignisDaten.setEndeZeitlicheGueltigkeit(wrapper.getEndZeit().getTime());

      // (2.2.2) Setze rumliche Gltigkeit
      for (final AeusseresStrassenSegment segment : wrapper.getStreckenAbschnitt().getAeussereStrassenSegmente())
      {
        ereignisDaten.addRaeumlicheGueltigkeit(segment);
      }

      // (2.2.3) Setze verkehrliche Gltigkeit
      ereignisDaten.addVerkehrlicheGueltigkeit(new VerkehrGueltigkeitsEintrag());

      // (2.2.4) Definiere zustzliches Attribut
      final AtlZusaetzlicheAttribute zusaetzlichesAttribut = new AtlZusaetzlicheAttribute();
      zusaetzlichesAttribut.setAttributname(Konstanten.EREIGNIS_EIGENSCHAFTEN_REFERENZ_AUSLOESENDE_SITUATION);
      zusaetzlichesAttribut.setAttributwert(engstellenPid);

      // (2.3) Sicher Ereignis-Daten (legt ein neues Ereignis-Objekt an)
      try
      {
        EreignisKalenderVerwaltung.getInstanz().sichereEreignisOhneUrlasserDialog(info, wrapper.getEreignis(),
            ereignisDaten, zusaetzlichesAttribut);
      }
      catch (final DynObjektException e)
      {
        final String errorMsg = "Es gab ein Problem beim Anlegen des dazugehrigen Ereignisses. Bitte berprfen Sie, ob der entsprechende Konfigurationsbereich an der AOE parametriert ist.";
        wrapper.setVerknuepfeEreignis(false);
        BauEditorPlugin.getDefault().getLogger().error(errorMsg, e);
        return new Status(IStatus.ERROR, BauEditorPlugin.PLUGIN_ID, errorMsg, e);
      }
    }

    // (3) Fge neu erzeugtes Ereignis dem Collective-Parameter hinzu
    final ObjektFactory objektFactory = BauEditorPlugin.getDefault().getObjektFactory();
    if (objektFactory != null && objektFactory.isVerbunden())
    {
      final SystemObjekt result = objektFactory.getModellobjekt(ereignisPid);
      if (result instanceof Ereignis)
      {
        neuAngelegtesEreignis.add((Ereignis)result);
        return Status.OK_STATUS;
      }
    }
    return Status.OK_STATUS;
  }
}
