/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.parameter.tsf;

import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IStartup;
import org.eclipse.ui.IViewReference;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.internal.WorkbenchPage;

import de.bsvrz.buv.rw.rw.menu.ElementRegistrierung;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * {@link IStartup} Implementierung, registriert alle Actions dieses Moduls zwecks Men- und Symbolleistenaufbau bzw.
 * deren Verwaltung.
 * 
 * @author Krause
 * 
 */
public class Starter implements IStartup
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

//  /**
//   * Der Zaehler fr die Views
//   */
//  private int _numViewInstances = 0;

  /**
   * In dieser Methode werden die von diesem Modul bereitgestellten Actions generiert und in der
   * Klasse {@link ElementRegistrierung} ber deren Methode
   * {@link ElementRegistrierung#registriereDeskriptorAktion(de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorAktion)}
   * registriert.
   */
  public void earlyStartup()
  {
//    System.out.println("Modul Automatikprogramme ist geladen.");
 
//    IAction action1 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, HarmonisierungAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action1.setText("Harmonisierung");
//    action1.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaStrgParameterHarmonisierung");
//    
//    DeskriptorAktion deskriptorAktion1 = new DeskriptorAktion(Activator.PLUGIN_ID, action1, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion1);
//
//    
//    IAction action2 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, NaesseGeschwAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action2.setText("NsseGeschwindigkeit");
//    action2.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaStrgParameterNsseGeschwindigkeit");
//    
//    DeskriptorAktion deskriptorAktion2 = new DeskriptorAktion(Activator.PLUGIN_ID, action2, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion2);
//
//    
//    IAction action3 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, NaesseLkwAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action3.setText("NsseLkw");
//    action3.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaStrgParameterNsseLkw");
//    
//    DeskriptorAktion deskriptorAktion3 = new DeskriptorAktion(Activator.PLUGIN_ID, action3, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion3);
//
//    
//    IAction action4 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, NaesseStufeAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action4.setText("NsseStufe");
//    action4.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaStrgParameterNsseStufe");
//    
//    DeskriptorAktion deskriptorAktion4 = new DeskriptorAktion(Activator.PLUGIN_ID, action4, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion4);
//
//    
//    IAction action5 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, SichtklasseStufeAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action5.setText("SichtklasseStufe");
//    action5.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaStrgParameterSichtklasseStufe");
//    
//    DeskriptorAktion deskriptorAktion5 = new DeskriptorAktion(Activator.PLUGIN_ID, action5, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion5);
//
//    
//    IAction action6 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, LkwUeberholverbotAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action6.setText("Lkwberholverbot");
//    action6.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaStrgParameterLkwberholverbot");
//    
//    DeskriptorAktion deskriptorAktion6 = new DeskriptorAktion(Activator.PLUGIN_ID, action6, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion6);
//
//    
//    IAction action7 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, StauBelegungAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action7.setText("StauBelegung");
//    action7.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaStrgParameterStauBelegung");
//    
//    DeskriptorAktion deskriptorAktion7 = new DeskriptorAktion(Activator.PLUGIN_ID, action7, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion7);
//
//    
//    IAction action8 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, StauGeschwAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action8.setText("StauGeschwindigkeit");
//    action8.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaStrgParameterStauGeschwindigkeit");
//    
//    DeskriptorAktion deskriptorAktion8 = new DeskriptorAktion(Activator.PLUGIN_ID, action8, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion8);
//
//    
//    IAction action9 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, StauStoerfallAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action9.setText("StauStrfall");
//    action9.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaStrgParameterStauStrfall");
//    
//    DeskriptorAktion deskriptorAktion9 = new DeskriptorAktion(Activator.PLUGIN_ID, action9, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion9);
//
//    
//    IAction action10 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, UnruheImVerkehrAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action10.setText("UnruheImVerkehr");
//    action10.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaStrgParameterUnruheImVerkehr");
//    
//    DeskriptorAktion deskriptorAktion10 = new DeskriptorAktion(Activator.PLUGIN_ID, action10, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion10);
//
//    
//    IAction action11 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          page.showView(VerwaltungsSicht.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action11.setText("Verwaltung");
//    action11.setId("de.bsvrz.buv.plugin.automatikprogramme.verwaltung.verwaltungsSicht");
//    
//    DeskriptorAktion deskriptorAktion11 = new DeskriptorAktion(Activator.PLUGIN_ID, action11, false);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion11);
//    
//    IAction action12 = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//        
//        try
//        {
//          starteViewParameter(page, SbaUrsachenEinheitAuswahlViewParameter.ID);
//        }
//        catch (PartInitException e)
//        {
//          e.printStackTrace();
//        }
//      }
//    };
//    action12.setText("SbaUrsachenEinheit");
//    action12.setId("de.bsvrz.buv.plugin.automatikprogramme.atg.sbaUrsachenEinheit");
//    
//    DeskriptorAktion deskriptorAktion12 = new DeskriptorAktion(Activator.PLUGIN_ID, action12, false);    
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion12);
    
  }
 
  private void starteViewParameter(IWorkbenchPage page, String id) throws PartInitException
  {
    page.showView(id);
    IViewReference ref = page.findViewReference(id);
    
    ((WorkbenchPage)page).getActivePerspective().getPresentation().detachPart(ref);
    IWorkbenchPart viewPart = ref.getPart(false);
    Shell shell = viewPart.getSite().getShell();
    shell.setSize(600, 300);
  }

}
