/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.parameter.tsf.mqZuordnung;

import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;

import com.sun.corba.se.impl.encoding.CodeSetConversion.BTCConverter;

import de.bsvrz.dav.daf.main.ResultData;

/**
 * Darstellung des Fensters zur Parameternderung ohne ButtonLeiste
 * 
 * @author Krause
 *
 */
public class MqZuweisungCompositeParameter2 extends Composite
{
  private static final boolean _isDebug = false;
  
  private List<String> _listObjGruppe;
  
  private Composite _composite;

  private MyComparator _comp = new MyComparator();
  
  private Group _groupDefinitionen11;

  private Composite _composite0 = null;

  private Composite _composite1 = null;

  private org.eclipse.swt.widgets.List _list1 = null;

  private org.eclipse.swt.widgets.List _list2 = null;
  
  private Button _addButton = null;

  private Button _subButton = null;

  private Label _label = null;
  
  private Label _label1 = null;
  
  private ResultData _resultData;

  private Button _btnInput;
  
  private Map<String, Boolean> _valuesList2 = new HashMap<String, Boolean>();

  MqZuweisungCompositeParameter2(Composite parent, int style, List<String> listObjGruppe,
		  ResultData resultData)
  {
    super(parent, style);
    _listObjGruppe = listObjGruppe;
    _resultData = resultData;
    initialize();
  }
  
  /**
   * Fhrt die Basis-Initialisierung des Composites durch
   */
  private void initialize()
  {
    if ( _isDebug )
      System.out.println(this.getClass().getName() + ":initialize");
    
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.grabExcessVerticalSpace = true;
    gridData1.heightHint = -1;
    gridData1.widthHint = -1;
    gridData1.horizontalIndent = 0;
    gridData1.verticalAlignment = GridData.FILL;
    setLayout(new GridLayout(1, false));
    setLayoutData(gridData1);
    GridLayout gridLayout = new GridLayout();
    gridLayout.makeColumnsEqualWidth = false;
    gridLayout.numColumns = 1;
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.grabExcessVerticalSpace = true;
    gridData2.heightHint = -1;
    gridData2.widthHint = -1;
    gridData2.horizontalIndent = 0;
    gridData2.verticalAlignment = GridData.FILL;

    _composite = new Composite(this, SWT.NONE);
    _composite.setLayoutData(gridData2);
    _composite.setLayout(gridLayout);

    createMessquerschnittAuswahl();
    
    updateData(null);
  }
  
   
  public org.eclipse.swt.widgets.List getList1()
  {
    return _list1;
  }

  public org.eclipse.swt.widgets.List getList2()
  {
    return _list2;
  }

  public void updateData(Map<String, Boolean> valuesList2)
  {
    
    _valuesList2.clear();
    
	  _list1.removeAll();  
    for ( String str : _listObjGruppe )
    {
      _list1.add( str );
    }
    
    String[] items = _list1.getItems();
    java.util.Arrays.sort( items, _comp );
    _list1.setItems( items );

    _list2.removeAll();
    if (valuesList2 != null)
    {
      _valuesList2.putAll(valuesList2);
      
      for (String value : valuesList2.keySet())
      {
        _list2.add(value);
        _list1.remove(value);
      }
      String[] items2 = _list2.getItems();
      java.util.Arrays.sort(items2, _comp);
      _list2.setItems(items2);
    }
  }


  /**
   * Methode erteugt die Darstellung der Auswahl der Messquerschnitte
   * 
   */
  private void createMessquerschnittAuswahl()
  {
    FillLayout fillLayout = new FillLayout();
    fillLayout.type = org.eclipse.swt.SWT.HORIZONTAL;
    
    RowLayout rowLayout3 = new RowLayout();
    rowLayout3.type = org.eclipse.swt.SWT.VERTICAL;
    rowLayout3.justify = false;
    rowLayout3.wrap = false;
    rowLayout3.pack = false;
    rowLayout3.spacing = 25;
    rowLayout3.fill = false;
    
    GridData gridData22 = new GridData();
    gridData22.horizontalAlignment = GridData.CENTER;
    gridData22.grabExcessVerticalSpace = false;
    gridData22.grabExcessHorizontalSpace = false;
    gridData22.verticalAlignment = GridData.CENTER;

    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.grabExcessVerticalSpace = true;
    gridData2.verticalAlignment = GridData.FILL;
    
    _groupDefinitionen11 = new Group(_composite, SWT.NONE);
    _groupDefinitionen11.setText("TSF-UrsachenEinheiten");
    _groupDefinitionen11.setLayout(fillLayout);
    _groupDefinitionen11.setLayoutData(gridData2);
    
    GridData gridData41 = new GridData();
    gridData41.horizontalAlignment = GridData.FILL;
    gridData41.grabExcessHorizontalSpace = true;
    gridData41.verticalAlignment = GridData.FILL;
    gridData41.grabExcessVerticalSpace = true;
    gridData41.widthHint = 200;
    
    GridData gridData21 = new GridData();
    gridData21.horizontalAlignment = GridData.CENTER;
    gridData21.verticalAlignment = GridData.CENTER;
    
    GridData gridData12 = new GridData();
    gridData12.horizontalAlignment = GridData.CENTER;
    gridData12.verticalAlignment = GridData.CENTER;
    
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.FILL;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.FILL;
    gridData3.grabExcessVerticalSpace = true;
    gridData3.widthHint = 200;

    //GridLayout mit Anzahl Spalten
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 3;
    gridLayout.marginHeight = 5;
    gridLayout.marginWidth = 5;
    
    _composite0 = new Composite(_groupDefinitionen11, SWT.NONE);
    _composite0.setLayout(gridLayout);
    _label = new Label(_composite0, SWT.NONE);
    _label.setText("verfgbare TSF-UEs");
    _label.setLayoutData(gridData12);
    new Label(_composite0, SWT.NONE);
    _label1 = new Label(_composite0, SWT.NONE);
    _label1.setText("zugeordnete TSF-UEs");
    _label1.setLayoutData(gridData21);
//    new Label(_composite0, SWT.NONE);
    
    _list1 = new org.eclipse.swt.widgets.List(_composite0, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);
    _list1.setLayoutData(gridData3);

    _composite1 = new Composite(_composite0, SWT.NONE);
    _composite1.setLayoutData(gridData22);
    _composite1.setLayout(rowLayout3);
    _addButton = new Button(_composite1, SWT.NONE);
    _addButton.setText("<");
    _addButton.addMouseListener(new MouseAdapter() {
      @Override
      public void mouseDown(MouseEvent e)
      {
        String[] selection = _list2.getSelection();
        for (String string : selection)
        {
          _list1.add(string);
          _valuesList2.remove(string);
          _list2.remove(string);
        }

        String[] items = _list1.getItems();
        java.util.Arrays.sort(items, _comp);
        _list1.setItems(items);

        String[] items2 = _list2.getItems();
        java.util.Arrays.sort(items2, _comp);
        _list2.setItems(items2);

      }
    });
    _subButton = new Button(_composite1, SWT.NONE);
    _subButton.setText(">");
    _subButton.addMouseListener(new MouseAdapter() {
      @Override
      public void mouseDown(MouseEvent e)
      {
        String[] selection = _list1.getSelection();
        for (String string : selection)
        {
          _list2.add(string);
          _valuesList2.put(string, false);
          _list1.remove(string);
        }

        String[] items = _list2.getItems();
        java.util.Arrays.sort(items, _comp);
        _list2.setItems(items);

        String[] items2 = _list1.getItems();
        java.util.Arrays.sort(items2, _comp);
        _list1.setItems(items2);

      }
    });
    _list2 = new org.eclipse.swt.widgets.List(_composite0, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);
    _list2.setLayoutData(gridData41);
    _list2.addSelectionListener(new SelectionAdapter() {
      
      @Override
      public void widgetSelected(SelectionEvent e)
      {
        
        String[] selection = _list2.getSelection();
        if (selection != null && selection.length > 0)
        {
          Object object = _valuesList2.get(selection[0]);
          if (object instanceof Boolean)
          {
            Boolean verwenden = (Boolean)object;
            System.out.println("{...}.widgetSelected(list2): " + verwenden);
            _btnInput.setSelection(verwenden);            
          }
        }        
      }      
    });    
    
    GridData gridData91 = new GridData();
    gridData91.horizontalAlignment = GridData.FILL;
    gridData91.grabExcessHorizontalSpace = true;
    gridData91.verticalAlignment = GridData.FILL;
    gridData91.grabExcessVerticalSpace = true;
    gridData91.horizontalSpan = 3;
    
    _btnInput = new Button(_composite0, SWT.CHECK);
    _btnInput.setLayoutData(gridData91);
    _btnInput.setText("Als Input verwenden");
    _btnInput.addMouseListener(new MouseAdapter() {
      @Override
      public void mouseDown(MouseEvent e)
      {
        String[] selection = _list2.getSelection();
        if (selection != null && selection.length > 0)
        {
          for (String name : selection)
          {
            _valuesList2.put(name, !_btnInput.getSelection());
          }          
        }
      }
    });
         
    
  }

  /**
   * Interne Klasse zum Vergleich
   * 
   * @author Krause
   * 
   */
  private class MyComparator implements Comparator<String>
  {

    @Override
    public int compare(String o1, String o2)
    {
      int ret = 0;
      
      //String-Sortierung
      if ( o1 != null )
        ret = o1.compareTo( o2 );
     
//      //Integer-Sortierung
//      Integer i1 = new Integer(o1);
//      Integer i2 = new Integer(o2);
//
//      if (i1 < i2)
//        ret = -1;
//      else if (i1 == i2)
//        ret = 0;
//      else if (i1 > i2)
//        ret = 1;
      
      return ret;
      
    }

  }
  
  public ResultData getResultData() {
		return _resultData;
  }
  
  public void setResultData(ResultData resultData) {
		_resultData = resultData;
  }

  public Map<String, Boolean> getValuesList2()
  {
    return _valuesList2;
  }
 
}
