package de.bsvrz.buv.plugin.parameter.ufd.common;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.EditingSupport;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

public abstract class MinMaxColumnEditingSupport extends EditingSupport
{
  private TextCellEditor _cellEditor;
  private long min;
  private long max;
  
  public MinMaxColumnEditingSupport(TableViewer tableViewer, long min, long max) {
    super(tableViewer);
    this.min = min;
    this.max = max;
    _cellEditor = new TextCellEditor((Composite)tableViewer.getTable(), SWT.NONE);
    
    ((Text)_cellEditor.getControl()).addVerifyListener(new VerifyListener() {
      public void verifyText(VerifyEvent e) {
      
        String text = ((Text)_cellEditor.getControl()).getText();
//        System.out.println("TEXT: \"" + text + "\"");
        String leading = text.substring(0, e.start);
//        System.out.println("LEADING: \"" + leading + "\"");
        String trailing = text.substring(e.end);
//        System.out.println("TRAILING: \"" + trailing + "\"");
       
        String result = leading + e.text + trailing;
//        System.out.println("RESULT: \"" + result + "\"");

        if (!"".equals(result)) {
          try {
            long value = Long.parseLong(result);
            if (value < MinMaxColumnEditingSupport.this.min || value > MinMaxColumnEditingSupport.this.max) {
              // Nur Ganzzahlen >= min und <= max
              throw new NumberFormatException();
            }
//            if (!String.valueOf(value).equals(result)) {
//              // Keine fhrenden Nullen etc.
//              throw new NumberFormatException();
//            }
          }
          catch (NumberFormatException ex) {
            e.doit = false;
//            System.out.println("DO IT: " + e.doit);
          }
        }
       }
      });
  }

  @Override
  protected CellEditor getCellEditor(Object element) {
          
    return _cellEditor;
  }

  @Override
  protected boolean canEdit(Object element) {
      return true;  
  }
}
