package de.bsvrz.buv.plugin.parameter.ufd.common;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.EditingSupport;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.CellEditor.LayoutData;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

public abstract class SpinnerColumnEditingSupport extends EditingSupport
{
  private SpinnerCellEditor _cellEditor;
    
  public SpinnerColumnEditingSupport(TableViewer tableViewer, int min, int max) {
    super(tableViewer);
 
    _cellEditor = new SpinnerCellEditor((Composite)tableViewer.getTable(), SWT.NONE) {
      @Override
      public LayoutData getLayoutData() {
        LayoutData result = new LayoutData();
        Control control = getControl();
        if (control != null) {
          result.minimumWidth = SWT.DEFAULT;
        }
        return result;
      }
    };
    _cellEditor.setMinimum(min);
    _cellEditor.setMaximum(max);
  }
  
  @Override
  protected CellEditor getCellEditor(Object element) {
          
    return _cellEditor;
  }

  @Override
  protected boolean canEdit(Object element) {
      return true;  
  }
}
