/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.parameter.ufd.nsparam;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;

import de.bsvrz.buv.plugin.parameter.ufd.common.AbstractDataContainerComposite;
import de.bsvrz.buv.plugin.parameter.ufd.dav.DaVKommunikation;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.Data.Array;
import de.bsvrz.dav.daf.main.config.AttributeType;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.IntegerAttributeType;
import de.bsvrz.dav.daf.main.config.IntegerValueRange;
import de.bsvrz.dav.daf.main.config.IntegerValueState;


/**
 * Darstellung des Fensters fr die Bearbeitung der Parameter "Ursacheneinheit"
 * @author ObertM
 *
 */
public class NSPlausibilisierungComposite extends AbstractDataContainerComposite
{ 
  private List<Long> _niederschlagsArt = new ArrayList<Long>();
  private TableViewer _tvNiederschlagsArt;
  private Label _lbNiederschlagsArt;
  private Combo _cbNiederschlagsArt;
  private Button _btnAddNiederschlagsArt;
  private Button _btnRemoveNiederschlagsArt;
    
  private List<Long> _zustandFahrbahnoberflaeche = new ArrayList<Long>();
  private TableViewer _tvZustandFahrbahnoberflaeche;
  private Label _lbZustandFahrbahnoberflaeche;
  private Combo _cbZustandFahrbahnoberflaeche;
  private Button _btnAddZustandFahrbahnoberflaeche;
  private Button _btnRemoveZustandFahrbahnoberflaeche;
  
  private IntegerAttributeType _attTypNiederschlagsArt = null;
  private IntegerAttributeType _attTypZustandFahrbahnoberflaeche = null;
  
  private List<String> _zustandFahrbahnoberflaecheNamen = new ArrayList<String>();
  private List<String> _niederschlagsArtNamen = new ArrayList<String>();
  
  
  public NSPlausibilisierungComposite(Composite parent, int style) {
    super(parent, style);
  }


  @Override
  public void initialize() {
    
    ClientDavInterface connection = DaVKommunikation.getInstanz().holeDaVVerbindung();
    if (connection != null) {
      DataModel dataModel = connection.getDataModel();
      AttributeType at = dataModel.getAttributeType("att.tlsUfdNiederschlagart");
      if (at instanceof IntegerAttributeType) {
        _attTypNiederschlagsArt = (IntegerAttributeType)at;
        for (IntegerValueState state: _attTypNiederschlagsArt.getStates()) {
          String stateName = state.getName();
          if (stateName != null) {
            Long value = getValue(_attTypNiederschlagsArt, stateName);
            if (value != null) {
              IntegerValueRange range = _attTypNiederschlagsArt.getRange();
              if (value >= range.getMinimum() && value <= range.getMaximum()) {
                _niederschlagsArtNamen.add(stateName);  
              }
            }
          }
        }
      }
      at = dataModel.getAttributeType("att.tlsUfdZustandFahrbahnoberflche");
      if (at instanceof IntegerAttributeType) {
        _attTypZustandFahrbahnoberflaeche = (IntegerAttributeType)at;
        for (IntegerValueState state: _attTypZustandFahrbahnoberflaeche.getStates()) {
          String stateName = state.getName();
          if (stateName != null) {
            Long value = getValue(_attTypZustandFahrbahnoberflaeche, stateName);
            if (value != null) {
              IntegerValueRange range = _attTypZustandFahrbahnoberflaeche.getRange();
              if (value >= range.getMinimum() && value <= range.getMaximum()) {
                _zustandFahrbahnoberflaecheNamen.add(stateName);  
              }
            }
          }
        }
      }
    }
      
    super.initialize();
  }
  
  private static String getState(IntegerAttributeType attTyp, Long value) {
    if (attTyp != null) {
      for (IntegerValueState state: attTyp.getStates()) {
        if (state.getValue() == value.longValue()) {
          return state.getName();
        }
      }
    }
    return null;
    
  }
  
  private static Long getValue(IntegerAttributeType attTyp, String stateName) {
    
    if (attTyp != null) {
      for (IntegerValueState state: attTyp.getStates()) {
        String name = state.getName();
        if (name != null && name.equals(stateName)) {
          return state.getValue();
        }
      }
    }
    return null;
  }
  
  private static Long getValue(IntegerAttributeType attTyp, Combo combo) {
    if (attTyp != null && combo != null) {
      String text = combo.getText().trim();
      Long value = getValue(attTyp, text);
      if (value == null) {
        try {
          value = Long.valueOf(text);
          IntegerValueRange range = attTyp.getRange();
          if (value < range.getMinimum() || value > range.getMaximum()) {
            throw new NumberFormatException();
          }
          return value;
        }
        catch (NumberFormatException e) {
          return null;
        }
      }
      return value;
    }
    return null;
  }

public void setUpdate(Data data) {
  if (!isInitialized())
    return;
  
  Array array = data.getArray("ZustndeNiederschlagsart");
  _niederschlagsArt.clear();
  for (int i = 0; i < array.getLength(); i++) {
    _niederschlagsArt.add(array.getItem(i).asUnscaledValue().longValue());
  }
//  Collections.sort(_niederschlagsArt);
  _tvNiederschlagsArt.refresh();
  
  _zustandFahrbahnoberflaeche.clear();
  array = data.getArray("ZustndeZustandFahrbahnoberflche");
  for (int i = 0; i < array.getLength(); i++) {
    _zustandFahrbahnoberflaeche.add(array.getItem(i).asUnscaledValue().longValue());
  }
//  Collections.sort(_zustandFahrbahnoberflaeche);
  _tvZustandFahrbahnoberflaeche.refresh();
}

public Data getUpdate() {
  if (!isInitialized())
    return null;
  
  Data result = _data.createModifiableCopy();
  Array array = result.getArray("ZustndeNiederschlagsart");
  array.setLength(0);
  for (int i = 0; i < _niederschlagsArt.size(); i++) {
    Long value = _niederschlagsArt.get(i);
    int index = array.getLength();
    array.setLength(index + 1);
    array.getItem(index).asUnscaledValue().set(value.longValue());
  }
  array = result.getArray("ZustndeZustandFahrbahnoberflche");
  array.setLength(0);
  for (int i = 0; i < _zustandFahrbahnoberflaeche.size(); i++) {
    Long value = _zustandFahrbahnoberflaeche.get(i);
    int index = array.getLength();
    array.setLength(index + 1);
    array.getItem(index).asUnscaledValue().set(value.longValue());
  }
  return result;
}

  /**
   * This method initializes createGroupDefinition
   * 
   */
  protected void createControls()
  {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.verticalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
  
    Group groupParameter = new Group(this, SWT.NONE);
    groupParameter.setLayout(new GridLayout(4, false));
    groupParameter.setLayoutData(gridData);
    groupParameter.setText("Nssestufe Plausibilisierung");

    createCompositeNiederschlagsArt(groupParameter);
    createTableNiederschlagsArt(groupParameter);
    createCompositeZustandFahrbahnoberflaeche(groupParameter);
    createTableZustandFahrbahnoberflaeche(groupParameter);
    
    enableDisableButtons();
  }
   
  private void createCompositeNiederschlagsArt(Composite parent) {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.verticalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
    
    Composite composite = new Composite(parent, SWT.NONE);
    composite.setLayout(new GridLayout());
    composite.setLayoutData(gridData);
    
    GridData gridDataControl = new GridData();
    gridDataControl.horizontalAlignment = GridData.FILL;
    gridDataControl.grabExcessHorizontalSpace = true;
    
    _lbNiederschlagsArt = new Label(composite, SWT.NONE);
    _lbNiederschlagsArt.setLayoutData(gridDataControl);
    _lbNiederschlagsArt.setText("Niederschlagsart:");
    _cbNiederschlagsArt = new Combo(composite, SWT.NONE);
    _cbNiederschlagsArt.setLayoutData(gridDataControl);
    _cbNiederschlagsArt.setItems((String[])_niederschlagsArtNamen.toArray(
        new String[_niederschlagsArtNamen.size()]));
    _cbNiederschlagsArt.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        enableDisableButtons();
      }
    });    
        
    new Label(composite, SWT.NONE);
    
    GridData gridDataButton = new GridData();
    gridDataButton.horizontalAlignment = GridData.END;
    
    _btnAddNiederschlagsArt = new Button(composite, SWT.PUSH);
    _btnAddNiederschlagsArt.setLayoutData(gridDataButton);
    _btnAddNiederschlagsArt.setText("Hinzufgen >>");
    _btnAddNiederschlagsArt.addSelectionListener(new SelectionAdapter() {

      @Override
      public void widgetSelected(SelectionEvent e)
      {
        actionAddNiederschlagsArt();
      }
      
    });
    
    _btnRemoveNiederschlagsArt = new Button(composite, SWT.PUSH);
    _btnRemoveNiederschlagsArt.setLayoutData(gridDataButton);
    _btnRemoveNiederschlagsArt.setText("Entfernen <<");
    _btnRemoveNiederschlagsArt.addSelectionListener(new SelectionAdapter() {

      @Override
      public void widgetSelected(SelectionEvent e)
      {
        actionRemoveNiederschlagsArt();
      }
      
    });
  }
  
  private void createCompositeZustandFahrbahnoberflaeche(Composite parent) {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.verticalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
    
    Composite composite = new Composite(parent, SWT.NONE);
    composite.setLayout(new GridLayout());
    composite.setLayoutData(gridData);
    
    GridData gridDataControl = new GridData();
    gridDataControl.horizontalAlignment = GridData.FILL;
    gridDataControl.grabExcessHorizontalSpace = true;
    
    _lbZustandFahrbahnoberflaeche = new Label(composite, SWT.NONE);
    _lbZustandFahrbahnoberflaeche.setText("Zustand FB-Oberflche:");
    _lbZustandFahrbahnoberflaeche.setLayoutData(gridDataControl);
    _cbZustandFahrbahnoberflaeche = new Combo(composite, SWT.NONE);
    _cbZustandFahrbahnoberflaeche.setLayoutData(gridDataControl);
    _cbZustandFahrbahnoberflaeche.setItems(_zustandFahrbahnoberflaecheNamen.toArray(
        new String[_zustandFahrbahnoberflaecheNamen.size()]));
    _cbZustandFahrbahnoberflaeche.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        enableDisableButtons();
      }
    });    
    
    new Label(composite, SWT.NONE);

    GridData gridDataButton = new GridData();
    gridDataButton.horizontalAlignment = GridData.END;
        
    _btnAddZustandFahrbahnoberflaeche = new Button(composite, SWT.PUSH);
    _btnAddZustandFahrbahnoberflaeche.setLayoutData(gridDataButton);
    _btnAddZustandFahrbahnoberflaeche.setText("Hinzufgen >>");
    _btnAddZustandFahrbahnoberflaeche.addSelectionListener(new SelectionAdapter() {

      @Override
      public void widgetSelected(SelectionEvent e)
      {
        actionAddZustandFahrbahnoberflaeche();
      }
      
    });
    
    _btnRemoveZustandFahrbahnoberflaeche = new Button(composite, SWT.PUSH);
    _btnRemoveZustandFahrbahnoberflaeche.setLayoutData(gridDataButton);
    _btnRemoveZustandFahrbahnoberflaeche.setText("Entfernen <<");
    _btnRemoveZustandFahrbahnoberflaeche.addSelectionListener(new SelectionAdapter() {

      @Override
      public void widgetSelected(SelectionEvent e)
      {
        actionRemoveZustandFahrbahnoberflaeche();
      }
      
    });
  }
  
  private void createTableNiederschlagsArt(Composite parent) {
    _tvNiederschlagsArt = new TableViewer(parent, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
    _tvNiederschlagsArt.setContentProvider(new ArrayContentProvider());
    
    TableViewerColumn column = new TableViewerColumn(_tvNiederschlagsArt, SWT.NONE);
    column.setLabelProvider(new ColumnLabelProvider() {

      @Override
      public String getText(Object element)
      {
        if (element instanceof Long) {
          String state = getState(_attTypNiederschlagsArt, (Long)element);
          if (state != null) {
            return state;
          }
          return (String.valueOf(element));
        }
        return null;
      }
      
    });
    
    column.getColumn().setWidth(140);
    column.getColumn().setText("Zustnde");
    column.getColumn().setMoveable(false);
    column.getColumn().setResizable(true);
    
    Table table = _tvNiederschlagsArt.getTable();
    table.setLinesVisible(true);
    table.setHeaderVisible(true);
    
    GridData gridData = new GridData(SWT.DEFAULT, 
        10 * table.getItemHeight() + table.getHeaderHeight());
    gridData.horizontalAlignment = GridData.FILL;
    gridData.verticalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
    table.setLayoutData(gridData);
    
    _tvNiederschlagsArt.addSelectionChangedListener(new ISelectionChangedListener() {

      @Override
      public void selectionChanged(SelectionChangedEvent event)
      {
        enableDisableButtons();
      }
    });
    
    _tvNiederschlagsArt.setInput(_niederschlagsArt);
  }
  
  private void createTableZustandFahrbahnoberflaeche(Composite parent) {
    _tvZustandFahrbahnoberflaeche = new TableViewer(parent, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
    _tvZustandFahrbahnoberflaeche.setContentProvider(new ArrayContentProvider());
    
    TableViewerColumn column = new TableViewerColumn(_tvZustandFahrbahnoberflaeche, SWT.NONE);
    column.setLabelProvider(new ColumnLabelProvider() {

      @Override
      public String getText(Object element)
      {
        if (element instanceof Long) {
          String state = getState(_attTypZustandFahrbahnoberflaeche, (Long)element);
          if (state != null) {
            return state;
          }
          return (String.valueOf(element));
        }
        return null;
      }
      
    });
    
    column.getColumn().setWidth(110);
    column.getColumn().setText("Zustnde");
    column.getColumn().setMoveable(false);
    column.getColumn().setResizable(true);
    
    Table table = _tvZustandFahrbahnoberflaeche.getTable();
    table.setLinesVisible(true);
    table.setHeaderVisible(true);
    
    GridData gridData = new GridData(SWT.DEFAULT, 
        10 * table.getItemHeight() + table.getHeaderHeight());
    gridData.horizontalAlignment = GridData.FILL;
    gridData.verticalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
    table.setLayoutData(gridData);
    
    _tvZustandFahrbahnoberflaeche.addSelectionChangedListener(new ISelectionChangedListener() {

      @Override
      public void selectionChanged(SelectionChangedEvent event)
      {
        enableDisableButtons();
      }
    });
    
    _tvZustandFahrbahnoberflaeche.setInput(_zustandFahrbahnoberflaeche);
  }
   
   
  private void actionAddNiederschlagsArt() {
    Long value = getValue(_attTypNiederschlagsArt, _cbNiederschlagsArt);
    if (value != null && !_zustandFahrbahnoberflaeche.contains(value)) {
      _niederschlagsArt.add(value);
      Collections.sort(_niederschlagsArt);
      _tvNiederschlagsArt.refresh();
      _tvNiederschlagsArt.setSelection(new StructuredSelection(new Long[] { value } ), true);
      enableDisableButtons();
    }
  }
  
  @SuppressWarnings("unchecked")
  private void actionRemoveNiederschlagsArt() {
    ISelection sel = _tvNiederschlagsArt.getSelection();
    if (sel instanceof IStructuredSelection) {
      Iterator it = ((IStructuredSelection)sel).iterator();
      while (it.hasNext()) {
        _niederschlagsArt.remove(it.next());
      }
    }
    _tvNiederschlagsArt.refresh();
    enableDisableButtons();
  }
  
  private void actionAddZustandFahrbahnoberflaeche() {
    Long value = getValue(_attTypZustandFahrbahnoberflaeche, _cbZustandFahrbahnoberflaeche);
    if (value != null && !_zustandFahrbahnoberflaeche.contains(value)) {
      _zustandFahrbahnoberflaeche.add(value);
      Collections.sort(_zustandFahrbahnoberflaeche);
      _tvZustandFahrbahnoberflaeche.refresh();
      _tvZustandFahrbahnoberflaeche.setSelection(new StructuredSelection(new Long[] { value } ), true);
      enableDisableButtons();
    }
  }
  
  @SuppressWarnings("unchecked")
  private void actionRemoveZustandFahrbahnoberflaeche() {
    ISelection sel = _tvZustandFahrbahnoberflaeche.getSelection();
    if (sel instanceof IStructuredSelection) {
      Iterator it = ((IStructuredSelection)sel).iterator();
      while (it.hasNext()) {
        _zustandFahrbahnoberflaeche.remove(it.next());
      }
    }
    _tvZustandFahrbahnoberflaeche.refresh();
    enableDisableButtons();
  }

  private void enableDisableButtons() {
    
    boolean enabled = false;
    Long value = getValue(_attTypNiederschlagsArt, _cbNiederschlagsArt);
    if (value != null && !_niederschlagsArt.contains(value)) {
      enabled = true;
    }
    _btnAddNiederschlagsArt.setEnabled(enabled);
    
    enabled = false;
    ISelection sel = _tvNiederschlagsArt.getSelection();
    if (sel instanceof IStructuredSelection) {
      if (!((IStructuredSelection)sel).isEmpty()) {
        enabled = true;
      }
      _btnRemoveNiederschlagsArt.setEnabled(enabled);
    }
    
    enabled = false;
    value = getValue(_attTypZustandFahrbahnoberflaeche, _cbZustandFahrbahnoberflaeche);
    if (value != null && !_zustandFahrbahnoberflaeche.contains(value)) {
      enabled = true;
    }
    _btnAddZustandFahrbahnoberflaeche.setEnabled(enabled);
    
    enabled = false;
    sel = _tvZustandFahrbahnoberflaeche.getSelection();
    if (sel instanceof IStructuredSelection) {
      if (!((IStructuredSelection)sel).isEmpty()) {
        enabled = true;
      }
      _btnRemoveZustandFahrbahnoberflaeche.setEnabled(enabled);
    }
  }
  
}
