/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.pua.basis;

import org.eclipse.ui.IStartup;

import de.bsvrz.buv.plugin.pua.basis.font.VisuAnzeigeFonts;
import de.bsvrz.buv.rw.rw.menu.ElementRegistrierung;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * {@link IStartup} Implementierung, registriert alle Actions dieses Moduls zwecks Men- und Symbolleistenaufbau bzw.
 * deren Verwaltung.
 * 
 * @version $Revision: 1.4 $ / $Date: 2012/12/21 09:56:26 $ / ($Author: Pittner $)
 * 
 * @author HofmannJ
 * 
 */
public class Starter implements IStartup
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  /**
   * In dieser Methode werden die vom Modul Betriebsmeldungsverwaltung bereitgestellten Actions generiert und in der
   * Klasse {@link ElementRegistrierung} ber deren Methode
   * {@link ElementRegistrierung#registriereDeskriptorAktion(de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorAktion)}
   * registriert.
   */
  public void earlyStartup()
  {
     System.out.println("Starter.earlyStartup() -> Modul PuA-Basis ist geladen.");
     VisuAnzeigeFonts.getInstanz();
  }
}
