/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.pua.basis.pua.daten;
/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */

//package de.bsvrz.buv.plugin.pua.pua.daten;
//
//import java.util.HashMap;
//import java.util.Iterator;
//import java.util.List;
//import java.util.NoSuchElementException;
//import java.util.Set;
//import java.util.StringTokenizer;
//import java.util.Vector;
//
//import de.bsvrz.dav.daf.main.ClientDavInterface;
//import de.bsvrz.dav.daf.main.Data;
//import de.bsvrz.dav.daf.main.Data.NumberValue;
//import de.bsvrz.dav.daf.main.Data.ReferenceArray;
//import de.bsvrz.dav.daf.main.Data.ReferenceValue;
//import de.bsvrz.dav.daf.main.Data.TimeValue;
//import de.bsvrz.dav.daf.main.config.Attribute;
//import de.bsvrz.dav.daf.main.config.AttributeGroup;
//import de.bsvrz.dav.daf.main.config.AttributeListDefinition;
//import de.bsvrz.dav.daf.main.config.AttributeType;
//import de.bsvrz.dav.daf.main.config.DataModel;
//import de.bsvrz.dav.daf.main.config.DoubleAttributeType;
//import de.bsvrz.dav.daf.main.config.IntegerAttributeType;
//import de.bsvrz.dav.daf.main.config.IntegerValueRange;
//import de.bsvrz.dav.daf.main.config.SystemObject;
//import de.bsvrz.pua.prot.client.dataobject.Column;
//import de.bsvrz.pua.prot.client.dataobject.ProtocolAdministrationData;
//import de.bsvrz.pua.prot.client.dataobject.Column.ColumnType;
//import de.bsvrz.pua.prot.util.ExpressionResult;
//import de.bsvrz.pua.prot.util.ResultValue;
//
///**
// * Klasse fr das Bereitstellen von Auswertungs-Informationen wie z. B. SystemObjekte fr die die Auswertung
// * durchgefhrt wurde und den teilweise skalierten Zugriff auf Attribute (reale Attribute). Dabei muss bei der
// * Instanziierung angegeben werden, ob die realen Attribute mit oder ohne Einheit angezeigt werden sollen.
// * 
// * @version $Revision: 1.3 $ / $Date: 2012/12/21 09:56:28 $ / ($Author: Pittner $)
// * 
// * @author Dambach-Werke GmbH
// * @author Thomas Drapp
// * 
// */
//public class AuswertungsInformationen
//{
//  /**
//   * Datenverteilerverbindung.
//   */
//  protected ClientDavInterface m_connection;
//
//  /**
//   * Datenmodell.
//   */
//  protected DataModel m_dataModel;
//
//  /**
//   * bergebene administrative Daten.
//   */
//  protected ProtocolAdministrationData m_adminData;
//
//  /**
//   * Kennung, ob die Ausgabe der realen Attribute mit oder ohne Einheit erfolgen soll.
//   */
//  protected boolean m_mitEinheit;
//
//  /**
//   * Anzahl der Objekte fr die Ergebnisse in der Auswertung vorhanden sind.
//   * <p/>
//   * Wird z. B. eine Auswertung ber 4 Pseudoobjekte durchgefhrt, so ist die enthaltene Information 4 Objekte.
//   */
//  protected int m_anzahlAusgewerteteObjekte;
//
//  /**
//   * Objekte fr die Ergebnisse in der Auswertung vorhanden sind und zwar in der Reihenfolge, in der die Ergebnisse pro
//   * Spalte vorhanden sind.
//   * <p/>
//   * Wird z. B. eine Auswertung ber 4 Pseudoobjekte durchgefhrt, so sind die 4 Objekte in der Reihenfolge enthalten.
//   */
//  protected Vector<SystemObject> m_ausgewerteteObjekte = new Vector<SystemObject>();
//
//  /**
//   * Fr die Abarbeitung bentigte Informationen pro Spalte.
//   */
//  protected Vector<SpaltenInformationen> m_spaltenInformationen = new Vector<SpaltenInformationen>();
//
//  /**
//   * Data's aller bentigten AttributGruppen.
//   */
//  protected HashMap<Long, Data> m_datas = new HashMap<Long, Data>();
//
//  /**
//   * Alle bentigten AttributGruppen.
//   */
//  protected HashMap<Long, AttributeGroup> m_atgs = new HashMap<Long, AttributeGroup>();
//
//  /**
//   * Konstruktor mit impliziter Angabe mit Einheiten anzeigen.
//   * 
//   * @param connection
//   *          Datenverteilerverbindung.
//   * @param adminData
//   *          Administrative Daten der Auswertung.
//   */
//  public AuswertungsInformationen(ClientDavInterface connection, ProtocolAdministrationData adminData)
//  {
//    this(connection, adminData, true);
//  }
//
//  /**
//   * Konstruktor mit der Mglichkeit zu whlen, ob die Einheiten angezeigt werden sollen.
//   * 
//   * @param connection
//   *          Datenverteilerverbindung.
//   * @param adminData
//   *          Administrative Daten der Auswertung.
//   * @param mitEinheit
//   *          wenn <code>true</code>, dann werden die Einheiten (bei realen Attributen) mit angezeigt, sondt nicht.
//   */
//  public AuswertungsInformationen(ClientDavInterface connection, ProtocolAdministrationData adminData,
//      boolean mitEinheit)
//  {
//    m_connection = connection;
//    m_adminData = adminData;
//    m_mitEinheit = mitEinheit;
//
//    m_dataModel = m_connection.getDataModel();
//
//    initialisierung();
//  }
//
//  /**
//   * Auswertung der bergebenen administrativen Daten und Bereitstellung der notwendigen Informationen.
//   */
//  private void initialisierung()
//  {
//    HashMap<Integer, SystemObject> objekteAusDids = new HashMap<Integer, SystemObject>();
//
//    Vector<SystemObject> objekteAusDidsEindeutig = new Vector<SystemObject>();
//
//    HashMap<Integer, SystemObject> objektZuSpalte = new HashMap<Integer, SystemObject>();
//
//    for (int i = 0; i < m_adminData.dids.length; i++)
//    {
//      SystemObject so = m_connection.getDataModel().getObject(m_adminData.dids[i][0]);
//
//      objekteAusDids.put(i, so);
//
//      if (!objekteAusDidsEindeutig.contains(so))
//      {
//        objekteAusDidsEindeutig.add(so);
//      }
//    }
//
//    Set<Integer> tree = objekteAusDids.keySet();
//
//    Iterator<Integer> it = tree.iterator();
//
//    // for (Integer id : tree)
//    // {
//    // System.out.println("ObjekteAusDids " +
//    // objekteAusDids.get(id).getPidOrNameOrId());
//    // }
//
//    // for (int i = 0; i < objekteAusDidsEindeutig.size(); i++)
//    // {
//    // System.out.println("ObjekteAusDidsEindeutig " +
//    // objekteAusDidsEindeutig.get(i).getPidOrNameOrId());
//    // }
//
//    // Objekt zu Spalte
//
//    for (int i = 0; i < m_adminData.columnToDataId.length; i++)
//    {
//      objektZuSpalte.put(i, objekteAusDids.get(m_adminData.columnToDataId[i]));
//    }
//
//    // for (int i = 0; i < m_adminData.columnToDataId.length; i++)
//    // {
//    // System.out.println("ObjektZuSpalte " + i + " "+
//    // objektZuSpalte.get(i).getPidOrNameOrId());
//    // }
//
//    // Anzahl ausgewertete Objekte bestimmen
//
//    int anzahl = 0;
//    int anzahlAkt = 0;
//    String text = "";
//
//    for (int i = 0; i < m_adminData.columns.length; i++)
//    {
//      if (text.length() == 0)
//      {
//        text = m_adminData.columns[i].getCaption();
//
//        anzahlAkt++;
//      }
//      else
//      {
//        if (m_adminData.columns[i].getCaption().equals(text))
//        {
//          anzahlAkt++;
//        }
//        else
//        {
//          if (anzahl == 0)
//          {
//            anzahl = anzahlAkt;
//          }
//          else
//          {
//            if (anzahl > anzahlAkt)
//            {
//              anzahl = anzahlAkt;
//            }
//          }
//
//          text = m_adminData.columns[i].getCaption();
//
//          anzahlAkt = 1;
//        }
//      }
//    }
//
//    m_anzahlAusgewerteteObjekte = anzahl;
//
//    // System.out.println("AnzahlAusgewerteteObjekte " +
//    // m_anzahlAusgewerteteObjekte);
//
//    // ausgewertete Objekte bestimmen
//
//    for (int i = 0; i < anzahl; i++)
//    {
//      m_ausgewerteteObjekte.add(objekteAusDids.get(m_adminData.columnToDataId[i]));
//    }
//
//    // for (int i = 0; i < m_ausgewerteteObjekte.size(); i++)
//    // {
//    // System.out.println("Objekte " +
//    // m_ausgewerteteObjekte.get(i).getPidOrNameOrId());
//    // }
//
//    // SpaltenInformationen bestimmen
//
//    for (int i = 0; i < m_adminData.columns.length; i++)
//    {
//      // System.out.println("i " + i);
//
//      Column col = m_adminData.columns[i];
//
//      long id = col.getReference();
//      SystemObject so = m_connection.getDataModel().getObject(id);
//      Attribute att = null;
//
//      if ((so != null) && (so instanceof Attribute))
//      {
//        att = (Attribute)so;
//        String attr = col.getAttributeName();
//        String typ = att.getAttributeType().getPidOrNameOrId();
//        String name = col.getCaption();
//        Data data = null;
//
//        // System.out.println("SUCHE " + typ + " ATT " + att.getName() + " ATT-Name " + attr);
//
//        int index = m_adminData.columnToDataId[i];
//        long idAtg = m_adminData.dids[index][1];
//
//        data = dataErstellenBzwHolen(idAtg);
//
//        // System.out.println("data " + data);
//
//        // System.out.println("data " + data);
//
//        AttributeGroup atg = atgHolen(idAtg);
//
//        List<Attribute> liste = atg.getAttributes();
//
//        for (Attribute m_attribute : liste)
//        {
//          // System.out.println("Liste " + m_attribute + " ATTRIBUTTYP " +
//          // m_attribute.getAttributeType() + " ARRAY " + m_attribute.isArray()
//          // + " TYPE " + m_attribute.getType());
//
//          if (m_attribute.getAttributeType().getType().getPid().equals("typ.attributListenDefinition"))
//          {
//            if (m_attribute.getAttributeType().getPid().equals(typ))
//            {
//              // System.out.println("-------------------- gefunden");
//
//              data = data.getItem(m_attribute.getName());
//
//              break;
//            }
//
//            // System.out.println("ist AttributListe");
//
//            Data input = data;
//
//            Data output = rekursivAlt(m_attribute.getAttributeType(), typ, input);
//
//            if (output != null)
//            {
//              data = output;
//            }
//          }
//        }
//
//        // System.out.println("erg data " + data);
//
//        ColumnType colTyp = col.getType();
//
//        SpaltenInformationen spinfo = new SpaltenInformationen(attr, typ, name, colTyp, data);
//
//        // System.out.println("Spalte " + spinfo);
//
//        m_spaltenInformationen.add(spinfo);
//      }
//      else
//      {
//        String name = col.getCaption();
//        ColumnType colTyp = col.getType();
//
//        SpaltenInformationen spinfo = new SpaltenInformationen(null, null, name, colTyp, null);
//
//        // System.out.println("Spalte " + spinfo);
//
//        m_spaltenInformationen.add(spinfo);
//      }
//    }
//
//    // System.out.println("FERTIG1");
//  }
//
//  private Data rekursivAlt(AttributeType attributeType, String typ, Data data)
//  {
//    AttributeListDefinition atl = (AttributeListDefinition)attributeType;
//
//    List<Attribute> att = atl.getAttributes();
//
//    for (Attribute m_attribute2 : att)
//    {
//      // System.out.println("Liste " + m_attribute2 + " ATTRIBUTTYP " +
//      // m_attribute2.getAttributeType() + " ARRAY " + m_attribute2.isArray() +
//      // " TYPE " + m_attribute2.getType());
//
//      if (m_attribute2.getAttributeType().getType().getPid().equals("typ.attributListenDefinition"))
//      {
//        if (m_attribute2.getAttributeType().getPid().equals(typ))
//        {
//          // System.out.println("-------------------- gefunden");
//
//          data = data.getItem(m_attribute2.getName());
//
//          return data;
//        }
//
//        // System.out.println("ist AttributListe");
//
//        Data input = data;
//
//        Data output = rekursivAlt(m_attribute2.getAttributeType(), typ, input);
//
//        if (output != null)
//        {
//          return output;
//        }
//      }
//    }
//
//    return null;
//  }
//
//  /**
//   * @param idAtg
//   * @return
//   */
//  private AttributeGroup atgHolen(long idAtg)
//  {
//    AttributeGroup atg = null;
//
//    atg = m_atgs.get(idAtg);
//
//    if (atg == null)
//    {
//      atg = (AttributeGroup)m_dataModel.getObject(idAtg);
//
//      m_atgs.put(idAtg, atg);
//    }
//
//    return atg;
//  }
//
//  /**
//   * @param idAtg
//   * @return
//   */
//  private Data dataErstellenBzwHolen(long idAtg)
//  {
//    Data data = null;
//
//    data = m_datas.get(idAtg);
//
//    if (data == null)
//    {
//      AttributeGroup atg = atgHolen(idAtg);
//      data = m_connection.createData(atg);
//
//      m_datas.put(idAtg, data);
//    }
//
//    return data;
//  }
//
//  /**
//   * @return the anzahlAusgewerteteObjekte
//   */
//  public int getAnzahlAusgewerteteObjekte()
//  {
//    return m_anzahlAusgewerteteObjekte;
//  }
//
//  /**
//   * @return the ausgewerteteObjekte
//   */
//  public final Vector<SystemObject> getAusgewerteteObjekte()
//  {
//    return m_ausgewerteteObjekte;
//  }
//
//  /**
//   * @return the ausgewerteteObjekte
//   */
//  public String getSpaltenName(int index)
//  {
//    if ((index >= 0) && (index < m_spaltenInformationen.size()))
//    {
//      return m_spaltenInformationen.get(index).getColumnName();
//    }
//
//    return null;
//  }
//
//  public String getSpaltenInhalt(int index, ResultValue resultValue)
//  {
//    String attributTypMeldung = "";
//
//    if (resultValue.isAtomar())
//    {
//      ExpressionResult ex = resultValue.getValue();
//
//      try
//      {
//        if (ex.getType().equals(ExpressionResult.ResultType.NONE))
//        {
//          // kein Wert vorhanden
//          if (resultValue.toString().contains("Es liegt kein Ergebnis vor"))
//            return new String(" keine Daten (potentielle Datenlcke) ");
//          else
//            return resultValue.toString();
//        }
//      }
//      catch (NullPointerException npe)
//      {
//        npe.printStackTrace();
//      }
//
//      if ((index >= 0) && (index < m_spaltenInformationen.size()))
//      {
//        SpaltenInformationen spinfo = m_spaltenInformationen.get(index);
//
//        if (!spinfo.getColumnTyp().equals(ColumnType.REAL_ATTRIBUTE)) // kein
//        // reales
//        // Attribut
//        {
//          return resultValue.toString();
//        }
//        else
//        // reales Attribut
//        {
//          String attributName = spinfo.getAttributName();
//          String attributTyp = spinfo.getAttributTyp();
//          Data data = spinfo.getData();
//
//          attributTypMeldung = attributTyp;
//          if (attributTyp.equals("att.objektReferenz"))
//          {
//            ReferenceValue unscaledValue = null;
//
//            String[] attributNameTeile = attributName.split("\\[");
//
//            if (attributNameTeile.length > 1)
//            {
//              ReferenceArray arr = data.getReferenceArray(attributNameTeile[0]);
//              arr.setLength(1);
//              unscaledValue = arr.getReferenceValue(0);
//            }
//            else
//            {
//              unscaledValue = data.getReferenceValue(attributNameTeile[0]);
//            }
//
//            unscaledValue.setSystemObject(m_dataModel.getObject(resultValue.getValue().getLong()));
//
//            SystemObject so = null;
//
//            if (attributNameTeile.length > 1)
//            {
//              so = data.getReferenceArray(attributNameTeile[0]).getReferenceValue(0).getSystemObject();
//            }
//            else
//            {
//              so = data.getReferenceValue(attributNameTeile[0]).getSystemObject();
//            }
//
//            if (so != null)
//            {
//              return so.getNameOrPidOrId();
//            }
//            else
//            {
//              return "<undefiniert>";
//            }
//          }
//          else if (attributTyp.equals("att.text"))
//          {
//            return resultValue.toString();
//          }
//          else if (attributTyp.equals("att.zahlPositiv"))
//          {
//            return resultValue.toString();
//          }
//          else
//          {
//            try
//            {
//              NumberValue unscaledValue = data.getUnscaledValue(attributName);
//
//              unscaledValue.set(resultValue.getValue().getLong());
//
//              if (m_mitEinheit)
//              {
//                return data.getScaledValue(attributName).getText();
//              }
//              else
//              {
//                return data.getScaledValue(attributName).getValueText();
//              }
//            }
//            catch (NoSuchElementException e)
//            {
//              return resultValue.toString();
//            }
//            catch (UnsupportedOperationException e)
//            {
//              try
//              {
//                TimeValue timeValue = data.getTimeValue(attributName);
//
//                timeValue.setMillis(resultValue.getValue().getLong());
//
//                if (m_mitEinheit)
//                {
//                  return data.getTimeValue(attributName).getText();
//                }
//                else
//                {
//                  return data.getTimeValue(attributName).getValueText();
//                }
//              }
//              catch (NoSuchElementException e1)
//              {
//                return resultValue.toString();
//              }
//              catch (UnsupportedOperationException e1)
//              {
//              }
//
//              return resultValue.toString();
//            }
//          }
//        }
//      }
//    }
//    else
//    {
//      StringBuffer sb = new StringBuffer();
//
//      int zae = 0;
//
//      for (ResultValue rv : resultValue.getChildren())
//      {
//        if (rv.isAtomar())
//        {
//          if (zae == 0)
//            sb.append(rv.getValue());
//          else
//            sb.append(", " + rv.getValue());
//
//          zae++;
//        }
//        else
//        {
//          sb.append(rv.toString() + ", ");
//        }
//      }
//
//      return sb.toString();
//    }
//
//    return "<noch nicht implementiert (" + attributTypMeldung + ")>";
//  }
//
//  /**
//   * Liefert den Spalteninhalt als {@link Integer}.
//   * 
//   * @param index
//   *          Index der Spalte.
//   * @param resultValue
//   *          {@link ResultValue}.
//   * @return Spalteninhalt als {@link Integer} oder <code>null</code>, wenn kein {@link Integer} bestimmt werden konnte.
//   */
//  public Integer getSpaltenInhaltAlsInteger(int index, ResultValue resultValue)
//  {
//    Integer re = null;
//
//    ExpressionResult ex = resultValue.getValue();
//
//    if (ex.getType().equals(ExpressionResult.ResultType.NONE))
//    {
//      re = null;
//    }
//
//    if ((index >= 0) && (index < m_spaltenInformationen.size()))
//    {
//      SpaltenInformationen spinfo = m_spaltenInformationen.get(index);
//
//      if (!spinfo.getColumnTyp().equals(ColumnType.REAL_ATTRIBUTE)) // kein
//      // reales
//      // Attribut
//      {
//        //
//      }
//      else
//      // reales Attribut
//      {
//        String attributName = spinfo.getAttributName();
//        String attributTyp = spinfo.getAttributTyp();
//        Data data = spinfo.getData();
//
//        if (attributTyp.equals("att.zahlPositiv"))
//        {
//          if (spinfo.isIntegerWert())
//          {
//            re = (int)resultValue.getValue().getLong();
//          }
//        }
//        else
//        {
//          try
//          {
//            NumberValue unscaledValue = data.getUnscaledValue(attributName);
//
//            unscaledValue.set(resultValue.getValue().getLong());
//
//            if (spinfo.isIntegerWert())
//            {
//              re = data.getScaledValue(attributName).intValue();
//            }
//
//          }
//          catch (NoSuchElementException e)
//          {
//            //
//          }
//        }
//      }
//    }
//
//    return re;
//  }
//
//  /**
//   * Liefert den Spalteninhalt als Double.
//   * 
//   * @param index
//   *          Index der Spalte.
//   * @param resultValue
//   *          {@link ResultValue}.
//   * @return Spalteninhalt als {@link Double} oder <code>null</code>, wenn kein {@link Double} bestimmt werden konnte.
//   */
//  public Double getSpaltenInhaltAlsDouble(int index, ResultValue resultValue)
//  {
//    Double re = null;
//
//    ExpressionResult ex = resultValue.getValue();
//
//    if (ex.getType().equals(ExpressionResult.ResultType.NONE))
//    {
//      //
//    }
//
//    if ((index >= 0) && (index < m_spaltenInformationen.size()))
//    {
//      SpaltenInformationen spinfo = m_spaltenInformationen.get(index);
//
//      if (!spinfo.getColumnTyp().equals(ColumnType.REAL_ATTRIBUTE)) // kein
//      // reales
//      // Attribut
//      {
//        //
//      }
//      else
//      // reales Attribut
//      {
//        String attributName = spinfo.getAttributName();
//        String attributTyp = spinfo.getAttributTyp();
//        Data data = spinfo.getData();
//
//        if (attributTyp.equals("att.zahlPositiv"))
//        {
//          if (spinfo.isDoubleWert())
//          {
//            re = resultValue.getValue().getDouble();
//          }
//        }
//        else
//        {
//          try
//          {
//            NumberValue unscaledValue = data.getUnscaledValue(attributName);
//
//            unscaledValue.set(resultValue.getValue().getLong()); // TODO prfen,
//            // ob hier
//            // nicht
//            // besser auf
//            // getDouble
//            // zurckgegriffen
//            // wird.
//
//            if (spinfo.isDoubleWert())
//            {
//              re = data.getScaledValue(attributName).doubleValue();
//            }
//
//          }
//          catch (NoSuchElementException e)
//          {
//            //
//          }
//        }
//      }
//    }
//
//    return re;
//  }
//
//  /**
//   * Liefert die Anzahl der {@link SpaltenInformationen}.
//   * 
//   * @return Anzahl der {@link SpaltenInformationen}.
//   */
//  public int getAnzahlSpaltenInformationen()
//  {
//    int re = 0;
//
//    if (m_spaltenInformationen != null)
//    {
//      re = m_spaltenInformationen.size();
//    }
//
//    return re;
//  }
//
//  /**
//   * Liefert die {@link SpaltenInformationen} fr eine bestimmte Spalte.
//   * 
//   * @param idxSpalte
//   *          Index der Spalte, deren {@link SpaltenInformationen} geliefert werden sollen.
//   * @return {@link SpaltenInformationen} der Spalte oder <code>null</code>, wenn zu der angegebenen Spalte keine
//   *         {@link SpaltenInformationen} existieren.
//   */
//  public SpaltenInformationen getSpaltenInformation(int idxSpalte)
//  {
//    SpaltenInformationen re = null;
//
//    if (idxSpalte < m_spaltenInformationen.size())
//    {
//      re = m_spaltenInformationen.get(idxSpalte);
//    }
//
//    return re;
//  }
//
//  public class SpaltenInformationen
//  {
//    /**
//     * Data-Objekt der Attributgruppe, in der das Attribut verwendet wird.
//     */
//    private Data m_data;
//
//    /**
//     * Name des Attributs in der Attributgruppe.
//     */
//    private String m_attributName;
//
//    /**
//     * Typ des Attributs (im Modell).
//     */
//    private String m_attributTyp;
//
//    /**
//     * Name der Spalte.
//     */
//    private String m_columnName;
//
//    /**
//     * Typ der Daten in der Spalte.
//     */
//    private ColumnType m_columnTyp;
//
//    /**
//     * Einheit der Daten in der Spalte.
//     */
//    private String m_einheit = "";
//
//    /**
//     * Wert ist Integer-Wert.
//     */
//    private boolean m_integerWert = false;
//
//    /**
//     * Wert ist Double-Wert.
//     */
//    private boolean m_doubleWert = false;
//
//    public SpaltenInformationen(String attributName, String attributTyp, String columnName, ColumnType columnTyp,
//        Data data)
//    {
//      StringTokenizer zerleger = new StringTokenizer(attributName, ".");
//      Data dataZeiger = data;
//      while(zerleger.hasMoreTokens())
//      {
//        String attributEbene = zerleger.nextToken().split("\\[")[0]; // bei Feldern, den Index vernachlssigen
//        dataZeiger = dataZeiger.getItem(attributEbene);
//      }
//
//      m_attributTyp = attributTyp;
//      m_columnName = columnName;
//      m_columnTyp = columnTyp;
//      m_data = data;
//
//      // String attributNameTeil = m_attributName.split("\\[")[0]; // bei Feldern, den Index vernachlssigen
//
//      // AttributeType atr1 = m_data.getItem(attributNameTeil).getAttributeType();
//      
//      AttributeType atr1 = dataZeiger.getAttributeType();
//
//      if (atr1 instanceof IntegerAttributeType)
//      {
//        m_integerWert = true;
//
//        IntegerValueRange integerValueRange = ((IntegerAttributeType)atr1).getRange();
//
//        if (integerValueRange != null)
//        {
//          m_einheit = integerValueRange.getUnit();
//        }
//      }
//      else if (atr1 instanceof DoubleAttributeType)
//      {
//        m_doubleWert = true;
//
//        m_einheit = ((DoubleAttributeType)atr1).getUnit();
//      }
//    }
//
//    /**
//     * @return the einheit
//     */
//    public String getEinheit()
//    {
//      return m_einheit;
//    }
//
//    /**
//     * @return the data
//     */
//    protected Data getData()
//    {
//      return m_data;
//    }
//
//    /**
//     * @return the attributName
//     */
//    protected String getAttributName()
//    {
//      return m_attributName;
//    }
//
//    /**
//     * @return the attributTyp
//     */
//    protected String getAttributTyp()
//    {
//      return m_attributTyp;
//    }
//
//    /**
//     * @return the columnName
//     */
//    public String getColumnName()
//    {
//      return m_columnName;
//    }
//
//    /**
//     * @return the columnTyp
//     */
//    protected ColumnType getColumnTyp()
//    {
//      return m_columnTyp;
//    }
//
//    /*
//     * (non-Javadoc)
//     * 
//     * @see java.lang.Object#toString()
//     */
//    @Override
//    public String toString()
//    {
//      StringBuffer sb = new StringBuffer("SpaltenInformationen");
//
//      sb.append(" AttributName: " + m_attributName);
//      sb.append(" AttributTyp: " + m_attributTyp);
//      sb.append(" ColumnName: " + m_columnName);
//      sb.append(" ColumnTyp: " + m_columnTyp);
//      sb.append(" Data: " + m_data);
//
//      return sb.toString();
//    }
//
//    /**
//     * Prft, ob es sich zum einen Integer-Wert handelt.
//     * 
//     * @return Liefert <code>true</code>, wenn es sich um einen Integer-Wert handelt, sonst <code>false</code>.
//     */
//    public boolean isIntegerWert()
//    {
//      return m_integerWert;
//    }
//
//    /**
//     * Prft, ob es sich zum einen Double-Wert handelt.
//     * 
//     * @return Liefert <code>true</code>, wenn es sich um einen Double-Wert handelt, sonst <code>false</code>.
//     */
//    public boolean isDoubleWert()
//    {
//      return m_doubleWert;
//    }
//  }
//}
