/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.pua.basis.pua.daten;

/**
 * Klasse fr das Speichern der SkriptInformationen.
 * 
 * @version $Revision: 1.3 $ / $Date: 2012/12/21 09:56:28 $ / ($Author: Pittner $)
 * 
 * @author Dambach-Werke GmbH
 * @author Thomas Drapp
 * 
 */
public class SkriptInformationen
{
  /**
   * 
   */
  private String m_pid = "";

  /**
   * 
   */
  private String m_name = "";

  /**
   * 
   */
  private String m_beschreibung = "";

  /**
   * 
   */
  private String m_autor = "";

  /**
   * 
   */
  private String m_status = "";

  /**
   * 
   */
  private String m_datum = "";

  /**
   * 
   */
  private String m_skriptDatei = "";

  /**
   * @param pid
   * @param name
   * @param beschreibung
   * @param autor
   * @param status
   * @param datum
   * @param skriptDatei
   *          Dateiname der Skript-Datei.
   */
  public SkriptInformationen(String pid, String name, String beschreibung, String autor, String status, String datum,
      String skriptDatei)
  {
    if (pid != null)
      m_pid = pid;

    if (name != null)
      m_name = name;

    if (beschreibung != null)
      m_beschreibung = beschreibung;

    if (autor != null)
      m_autor = autor;

    if (status != null)
      m_status = status;

    if (datum != null)
      m_datum = datum;

    if (skriptDatei != null)
      m_skriptDatei = skriptDatei;
  }

  /*
   * (non-Javadoc)
   * 
   * @see java.lang.Object#toString()
   */
  @Override
  public String toString()
  {
    StringBuffer sb = new StringBuffer();

    sb.append("Pid: " + getPid() + ", ");
    sb.append("Name: " + getName() + ", ");
    sb.append("Beschreibung: " + getBeschreibung() + ", ");
    sb.append("Autor: " + getAutor() + ", ");
    sb.append("Status: " + getStatus() + ", ");
    sb.append("Datum: " + getDatum() + ", ");
    sb.append("SkriptDatei: " + getSkriptDatei() + ", ");

    return sb.toString();
  }

  /**
   * @return the pid
   */
  public String getPid()
  {
    return m_pid;
  }

  /**
   * @return the name
   */
  public String getName()
  {
    return m_name;
  }

  /**
   * @return the beschreibung
   */
  public String getBeschreibung()
  {
    return m_beschreibung;
  }

  /**
   * @return the autor
   */
  public String getAutor()
  {
    return m_autor;
  }

  /**
   * @return the status
   */
  public String getStatus()
  {
    return m_status;
  }

  /**
   * @return the datum
   */
  public String getDatum()
  {
    return m_datum;
  }

  /**
   * Holt den Dateinamen der Skript-Datei.
   * 
   * @return Dateiname der Skript-Datei.
   */
  public String getSkriptDatei()
  {
    return m_skriptDatei;
  }
}
