/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.diagram;

import java.awt.Dimension;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.DirectColorModel;
import java.awt.image.IndexColorModel;
import java.awt.image.WritableRaster;
import java.util.Hashtable;
import java.util.List;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.PaletteData;
import org.eclipse.swt.graphics.RGB;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Activator;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilKonfigurationData;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.type.StreckenProfilElementTyp;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.type.StreckenProfilInhaltTyp;

public class StreckenProfilBildverwaltung
{
  private static String BILDVERZEICHNIS = null;
  private final static Hashtable BILDER_CACHE = new Hashtable();

  static
  {           
    StreckenProfilBildverwaltung.BILDVERZEICHNIS = Platform.getBundle(Activator.PLUGIN_ID).getEntry("icons").getFile().toString();    
  }
  
  public static Dimension getMaximaleBildgroesse(StreckenProfilElementTyp elementTyp, List inhaltTypen, List fahrtRichtungen)
  {
    Dimension ret = new Dimension(0, 0);

    if(elementTyp != null && inhaltTypen != null)
    {
      for(int i = 0; i < inhaltTypen.size(); i++)
      {
        if(fahrtRichtungen != null && fahrtRichtungen.size() > 0)
        {
          for(int j = 0; j < fahrtRichtungen.size(); j++)
          {
            String pfad = StreckenProfilBildverwaltung.getBildPfad(elementTyp, (StreckenProfilInhaltTyp)inhaltTypen.get(i), (StreckenProfilKonfigurationData.BezeichnungFahrtRichtung)fahrtRichtungen.get(j));
            if(pfad != null)
            {
              Image bild = StreckenProfilBildverwaltung.getBild(pfad);
              if(bild != null)
              {
                ret.width = Math.max(ret.width, bild.getWidth(null));
                ret.height = Math.max(ret.height, bild.getHeight(null));
              }else{
                System.out.println("Bild ist null: " + pfad);
              }
              
            }else{
              System.out.println("Pfad ist null");
            }
          }
        }
        else
        {                    
          String pfad = StreckenProfilBildverwaltung.getBildPfad(elementTyp, (StreckenProfilInhaltTyp)inhaltTypen.get(i), null);
          if(pfad != null)
          {
            Image bild = StreckenProfilBildverwaltung.getBild(pfad);
            if(bild != null)
            {
              ret.width = Math.max(ret.width, bild.getWidth(null));
              ret.height = Math.max(ret.height, bild.getHeight(null));
            }else{
              System.out.println("Bild ist null 2: " + pfad);
            }
          }else{
            System.out.println("Pfad ist null 2");
          }
        }
      }
    }
    
    return (ret);
  }
    
  public static String getBildPfad(StreckenProfilElementTyp elementTyp, StreckenProfilInhaltTyp inhaltTyp, StreckenProfilKonfigurationData.BezeichnungFahrtRichtung fahrtRichtung)
  {       
    String bildname = null;
    
    if(elementTyp != null && inhaltTyp != null)
    {      
      if(elementTyp.equals(StreckenProfilElementTyp.WZG_A_STATISCH))
      {
  	    // TODO staBes: #3 Hier wurde die Suche fuer die Bilder des WZG-A-Statisch erweitert. Der else-Fall deckt ab, falls
    	//              ein unbekannter Inhaltstyp angezeigt werden soll. Bei Bedarf bitte anpassen.
        if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_10))
        {
          bildname = "e1_10_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_20))
        {
          bildname = "e1_20_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_30))
        {
          bildname = "e1_30_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40))
        {
          bildname = "e1_40_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50))
        {
          bildname = "e1_50_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60))
        {
          bildname = "e1_60_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_70))
        {
          bildname = "e1_70_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80))
        {
          bildname = "e1_80_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100))
        {
          bildname = "e1_100_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120))
        {
          bildname = "e1_120_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130))
        {
          bildname = "e1_130_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_10))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_20))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_30))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_40))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_50))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_60))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_70))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_80))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_100))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_120))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_130))
        {
          bildname = "e1_ende_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE))
        {
          bildname = "e1_ende_statisch.png";
        }
        else
        {
          bildname = "a1_unbekannt.png";
        }
      }
      else if(elementTyp.equals(StreckenProfilElementTyp.WZG_A_STATISCH_UV))
      {
    	// TODO staBes: #4 Hier wurde die Suche fuer die Bilder des WZG-A-Statisch-UV erweitert. Der else-Fall deckt 
    	//              ab, falls ein unbekannter Inhaltstyp angezeigt werden soll. Bei Bedarf bitte anpassen.
        if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_ALLGEMEIN))
        {
          bildname = "e1_uv_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_NAESSE))
        {
          bildname = "e1_uv_naesse_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_LKW))
        {
          bildname = "e1_uv_lkw_statisch.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE))
        {
          bildname = "e1_ende_statisch.png";
        }
        else
        {
          bildname = "a1_unbekannt.png";
        }
      }
      else if(elementTyp.equals(StreckenProfilElementTyp.WZG_A))
      {
        if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_DUNKEL))
        {
          bildname = "a1_leer.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_GESTOERT))
        {
          bildname = "a1_stoer.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_INAKTIV))
        {
          bildname = "a1_inaktiv.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_GESPERRT))
        {
          bildname = "a1_111.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_GESPERRT_MARKIERT))
        {
          bildname = "a1_111_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_WECHSELN_NACH_LINKS))
        {
          if(fahrtRichtung != null && fahrtRichtung.equals(StreckenProfilKonfigurationData.BezeichnungFahrtRichtung.NO))
          {
            bildname = "a1_113.png";
          }
          else
          {
            bildname = "a1_114.png";
          }
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS))
        {
          if(fahrtRichtung != null && fahrtRichtung.equals(StreckenProfilKonfigurationData.BezeichnungFahrtRichtung.NO))
          {
            bildname = "a1_114.png";
          }
          else
          {
            bildname = "a1_113.png";
          }
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40))
        {
          bildname = "e1_22.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_40_MARKIERT))
        {
          bildname = "e1_22_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50))
        {
          bildname = "e1_23.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_50_MARKIERT))
        {
          bildname = "e1_23_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60))
        {
          bildname = "e1_24.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_60_MARKIERT))
        {
          bildname = "e1_24_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80))
        {
          bildname = "e1_26.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_80_MARKIERT))
        {
          bildname = "e1_26_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100))
        {
          bildname = "e1_27.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_100_MARKIERT))
        {
          bildname = "e1_27_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120))
        {
          bildname = "e1_28.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_120_MARKIERT))
        {
          bildname = "e1_28_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130))
        {
          bildname = "e1_33.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ZULAESSIGE_HOECHST_130_MARKIERT))
        {
          bildname = "e1_33_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_40))
        {
          bildname = "e1_42.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_50))
        {
          bildname = "e1_43.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_60))
        {
          bildname = "e1_44.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_80))
        {
          bildname = "e1_46.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_100))
        {
          bildname = "e1_48.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_120))
        {
          bildname = "e1_50.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ZULAESSIGE_HOECHST_130))
        {
          bildname = "e1_54.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE))
        {
          bildname = "e1_99.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_FAHRSTREIFEN_HALTEN))
        {
          bildname = "a1_112.png";
        }
        else
        {
          bildname = "a1_unbekannt.png";
        }
      }
      else if(elementTyp.equals(StreckenProfilElementTyp.WZG_B))
      {
        if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_DUNKEL))
        {
          bildname = "b1_leer.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_GESTOERT))
        {
          bildname = "b1_stoer.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_INAKTIV))
        {
          bildname = "b1_inaktiv.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_GEFAHRENSTELLE))
        {
          bildname = "b1_1.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_GEFAHRENSTELLE_MARKIERT))
        {
          bildname = "b1_1_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_STAU))
        {
          bildname = "b1_9.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_STAU_MARKIERT))
        {
          bildname = "b1_9_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_GLAETTEGEFAHR))
        {
          bildname = "b1_3.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_GLAETTEGEFAHR_MARKIERT))
        {
          bildname = "b1_3_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_SCHLEUDERGEFAHR))
        {
          bildname = "b1_4.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_SCHLEUDERGEFAHR_MARKIERT))
        {
          bildname = "b1_4_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_ALLGEMEIN))
        {
          bildname = "b1_31.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_ALLGEMEIN_MARKIERT))
        {
          bildname = "b1_31_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_LKW))
        {
          bildname = "b1_32.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_UEBERHOLVERBOT_LKW_MARKIERT))
        {
          bildname = "b1_32_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_BAUSTELLE))
        {
          bildname = "b1_8.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_BAUSTELLE_MARKIERT))
        {
          bildname = "b1_8_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE))
        {
          bildname = "b1_53.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_ALLER_STRECKENVERBOTE_MARKIERT))
        {
          bildname = "b1_53_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN))
        {
          bildname = "b1_51.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN_MARKIERT))
        {
          bildname = "b1_51_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_LKW))
        {
          bildname = "b1_52.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_ENDE_UEBERHOLVERBOT_LKW_MARKIERT))
        {
          bildname = "b1_52_m.png";
        }
        else
        {
          bildname = "b1_unbekannt.png";
        }
      }
      else if(elementTyp.equals(StreckenProfilElementTyp.WZG_C))
      {
        if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_DUNKEL))
        {
          bildname = "c1_leer.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_GESTOERT))
        {
          bildname = "c1_stoer.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_INAKTIV))
        {
          bildname = "c1_inaktiv.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_NEBEL))
        {
          bildname = "c1_64.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_NEBEL_MARKIERT))
        {
          bildname = "c1_64_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_NAESSE))
        {
          bildname = "c1_65.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_NAESSE_MARKIERT))
        {
          bildname = "c1_65_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_UNFALL))
        {
          bildname = "c1_66.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_UNFALL_MARKIERT))
        {
          bildname = "c1_66_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_SMOG))
        {
          bildname = "c1_69.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_SMOG_MARKIERT))
        {
          bildname = "c1_69_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_STAU))
        {
          bildname = "c1_62.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_STAU_MARKIERT))
        {
          bildname = "c1_62_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_STAU_GEFAHR))
        {
          bildname = "c1_63.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_STAU_GEFAHR_MARKIERT))
        {
          bildname = "c1_63_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_SICHT))
        {
          bildname = "c1_70.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_SICHT_MARKIERT))
        {
          bildname = "c1_70_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AS_GLAETTE))
        {
          bildname = "c1_203.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AS_GLAETTE_MARKIERT))
        {
          bildname = "c1_203_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AS_OELSPUR))
        {
          bildname = "c1_204.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AS_OELSPUR_MARKIERT))
        {
          bildname = "c1_204_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_7KOMMA5TONNEN))
        {
          bildname = "c1_102.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_7KOMMA5TONNEN_MARKIERT))
        {
          bildname = "c1_102_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_500M))
        {
          bildname = "c1_81.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_500M_MARKIERT))
        {
          bildname = "c1_81_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_1000M))
        {
          bildname = "c1_67.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_1000M_MARKIERT))
        {
          bildname = "c1_67_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_1500M))
        {
          bildname = "c1_83.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_1500M_MARKIERT))
        {
          bildname = "c1_83_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_2000M))
        {
          bildname = "c1_68.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_2000M_MARKIERT))
        {
          bildname = "c1_68_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_2500M))
        {
          bildname = "c1_85.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_2500M_MARKIERT))
        {
          bildname = "c1_85_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_500M))
        {
          bildname = "c1_91.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_500M_MARKIERT))
        {
          bildname = "c1_91_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_1000M))
        {
          bildname = "c1_92.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_1000M_MARKIERT))
        {
          bildname = "c1_92_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_1500M))
        {
          bildname = "c1_93.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_1500M_MARKIERT))
        {
          bildname = "c1_93_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_2000M))
        {
          bildname = "c1_94.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_2000M_MARKIERT))
        {
          bildname = "c1_94_m.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_2500M))
        {
          bildname = "c1_95.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_AUF_2500M_MARKIERT))
        {
          bildname = "c1_95_m.png";
        }
        else
        {
          bildname = "c1_unbekannt.png";
        }
      }
      else if(elementTyp.equals(StreckenProfilElementTyp.WZG_BLINKER_B))
      {
        if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_DUNKEL))
        {
          bildname = "b2_1.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_GESTOERT))
        {
          bildname = "b2_3.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.BI_TLS_GELBES_BLINKLICHT))
        {
          bildname = "b2_2.png";
        }
      }
      else if(elementTyp.equals(StreckenProfilElementTyp.UFD_HELLIGKEIT))
      {
        if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_1))
        {
          bildname = "helligkeit_1.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_2))
        {
          bildname = "helligkeit_2.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_3))
        {
          bildname = "helligkeit_3.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_4))
        {     
          bildname = "helligkeit_4.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_5))
        {
          bildname = "helligkeit_5.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_6))
        {
          bildname = "helligkeit_6.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_7))
        {
          bildname = "helligkeit_7.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_8))
        {
          bildname = "helligkeit_8.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_9))
        {
          bildname = "helligkeit_9.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_STUFE_10))
        {
          bildname = "helligkeit_10.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_GESTOERT))
        {
          bildname = "helligkeit_stoer.png";
        }      
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_HELLIGKEIT_UNDEFINIERT))
        {
          bildname = "helligkeit_stoer.png";
        }      
      }
      else if(elementTyp.equals(StreckenProfilElementTyp.UFD_SICHTWEITE))
      {
        if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_1))
        {
          bildname = "sicht_0.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_2))
        {
          bildname = "sicht_1.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_3))
        {
          bildname = "sicht_2.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_4))
        {     
          bildname = "sicht_3.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_5))
        {
          bildname = "sicht_4.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_SICHTWEITE_STUFE_6))
        {
          bildname = "sicht_5.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_SICHTWEITE_GESTOERT))
        {
          bildname = "sicht_stoer.png";
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_SICHTWEITE_UNDEFINIERT))
        {
          bildname = "sicht_stoer.png";
        }
      }
      else if(elementTyp.equals(StreckenProfilElementTyp.UFD_NIEDERSCHLAG))
      {
        if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_TROCKEN))
        {
          bildname = "nass_0.png";         
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_NASS_1))
        {
          bildname = "nass_1.png";         
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_NASS_2))
        {
          bildname = "nass_2.png";        
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_NASS_3))
        {
          bildname = "nass_3.png";        
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_NASS_4))
        {
          bildname = "nass_4.png";        
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_NASS_5))
        {     
          bildname = "nass_5.png";      
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_GESTOERT))
        {
          bildname = "nass_stoer.png";        
        }
        else if(inhaltTyp.equals(StreckenProfilInhaltTyp.UFD_NIEDERSCHLAG_UNDEFINIERT))
        {
          bildname = "nass_stoer.png";       
        }      
      }
    }
    
//    String pfad = BILDVERZEICHNIS + IPath.SEPARATOR + bildname;
    String pfad = "icons" + "/" + bildname;
    
//    System.out.println("StreckenProfilBildverwaltung.getBildPfad(): " + pfad);
    
    return (pfad);
  }
  
//  public static Image getBild(File bilddatei)
//  {
//    Image ret = null;
//    
//    if(bilddatei != null)
//    {
////      System.out.println("RET: " + bilddatei.getAbsolutePath());
//      ret = (Image)StreckenProfilBildverwaltung.BILDER_CACHE.get(bilddatei.getAbsolutePath()); 
//      
////      System.out.println("RET: " + ret);
//      if(ret == null && bilddatei.exists() && bilddatei.isFile())
//      try
//      {
//        ImageIcon icon = new ImageIcon(bilddatei.getAbsolutePath());
//        ret = icon.getImage();
//        
//        
//        if(ret != null)
//        {
//          StreckenProfilBildverwaltung.BILDER_CACHE.put(bilddatei.getAbsolutePath(), ret);
//        }
//      }
//      catch(Throwable t)
//      {
//        t.printStackTrace();
//      }
//    }
//    
//    return (ret);
//  }
  
  public static Image getBild(String pfad)
  {
    Image ret = null;
    
    if(pfad != null)
    {

      ret = (Image)StreckenProfilBildverwaltung.BILDER_CACHE.get(pfad); 
      
      if(ret == null)
        try
      {
          
          ImageDescriptor id = Activator.getDefault().getImageDescriptor(pfad);
          if (id != null){
            BufferedImage bi = StreckenProfilBildverwaltung.convertToAWT(id.getImageData());
            
            ret = Toolkit.getDefaultToolkit().createImage(bi.getSource());
            
            
//            org.eclipse.swt.graphics.Image swtImage = id.createImage();
////          org.eclipse.swt.graphics.Image swtImage = new org.eclipse.swt.graphics.Image(null, pfad);
//            
//            System.out.println("swtImage: " + swtImage.getImageData());
//            
//            ImageIcon icon = new ImageIcon(swtImage.getImageData().data);
//            
////          ImageIcon icon = new ImageIcon(pfad);
//            ret = icon.getImage();
            
            if(ret != null)
            {
              StreckenProfilBildverwaltung.BILDER_CACHE.put(pfad, ret);
            }            
          }
      }
      catch(Throwable t)
      {
        t.printStackTrace();
      }
    }
    
    return (ret);
  }
  
  static BufferedImage convertToAWT(ImageData data) {
    ColorModel colorModel = null;
    PaletteData palette = data.palette;
    if (palette.isDirect) {
      colorModel = new DirectColorModel(data.depth, palette.redMask, palette.greenMask, palette.blueMask);
  	  // TODO staBes: #13 Bugfix, hier ging vorher die Transparenz der PNG-Bilder verloren.
      BufferedImage tmp = new BufferedImage(colorModel, colorModel.createCompatibleWritableRaster(data.width, data.height), false, null);
      BufferedImage bufferedImage = new BufferedImage(tmp.getWidth(), tmp.getHeight(), BufferedImage.TYPE_INT_ARGB);
      for (int y = 0; y < data.height; y++) {
        for (int x = 0; x < data.width; x++) {
          int alpha = data.getAlpha(x, y);
          int pixel = data.getPixel(x, y);
          RGB rgb = palette.getRGB(pixel);
          tmp.setRGB(x, y,  rgb.red << 16 | rgb.green << 8 | rgb.blue);
          bufferedImage.setRGB(x, y, (alpha << 24) | (tmp.getRGB(x, y) & 0xffffff));
        }
      }
      return bufferedImage;
    } else {
      RGB[] rgbs = palette.getRGBs();
      byte[] red = new byte[rgbs.length];
      byte[] green = new byte[rgbs.length];
      byte[] blue = new byte[rgbs.length];
      for (int i = 0; i < rgbs.length; i++) {
        RGB rgb = rgbs[i];
        red[i] = (byte)rgb.red;
        green[i] = (byte)rgb.green;
        blue[i] = (byte)rgb.blue;
      }
      if (data.transparentPixel != -1) {
        colorModel = new IndexColorModel(data.depth, rgbs.length, red, green, blue, data.transparentPixel);
      } else {
        colorModel = new IndexColorModel(data.depth, rgbs.length, red, green, blue);
      }   
      BufferedImage bufferedImage = new BufferedImage(colorModel, colorModel.createCompatibleWritableRaster(data.width, data.height), false, null);
      WritableRaster raster = bufferedImage.getRaster();
      int[] pixelArray = new int[1];
      for (int y = 0; y < data.height; y++) {
        for (int x = 0; x < data.width; x++) {
          int pixel = data.getPixel(x, y);
          pixelArray[0] = pixel;
          raster.setPixel(x, y, pixelArray);
        }
      }
      return bufferedImage;
    }
  }

  static ImageData convertToSWT(BufferedImage bufferedImage) {
    if (bufferedImage.getColorModel() instanceof DirectColorModel) {
      DirectColorModel colorModel = (DirectColorModel)bufferedImage.getColorModel();
      PaletteData palette = new PaletteData(colorModel.getRedMask(), colorModel.getGreenMask(), colorModel.getBlueMask());
      ImageData data = new ImageData(bufferedImage.getWidth(), bufferedImage.getHeight(), colorModel.getPixelSize(), palette);
      for (int y = 0; y < data.height; y++) {
        for (int x = 0; x < data.width; x++) {
          int rgb = bufferedImage.getRGB(x, y);
          int pixel = palette.getPixel(new RGB((rgb >> 16) & 0xFF, (rgb >> 8) & 0xFF, rgb & 0xFF)); 
          data.setPixel(x, y, pixel);
          if (colorModel.hasAlpha()) {
            data.setAlpha(x, y, (rgb >> 24) & 0xFF);
          }
        }
      }
      return data;    
    } else if (bufferedImage.getColorModel() instanceof IndexColorModel) {
      IndexColorModel colorModel = (IndexColorModel)bufferedImage.getColorModel();
      int size = colorModel.getMapSize();
      byte[] reds = new byte[size];
      byte[] greens = new byte[size];
      byte[] blues = new byte[size];
      colorModel.getReds(reds);
      colorModel.getGreens(greens);
      colorModel.getBlues(blues);
      RGB[] rgbs = new RGB[size];
      for (int i = 0; i < rgbs.length; i++) {
        rgbs[i] = new RGB(reds[i] & 0xFF, greens[i] & 0xFF, blues[i] & 0xFF);
      }
      PaletteData palette = new PaletteData(rgbs);
      ImageData data = new ImageData(bufferedImage.getWidth(), bufferedImage.getHeight(), colorModel.getPixelSize(), palette);
      data.transparentPixel = colorModel.getTransparentPixel();
      WritableRaster raster = bufferedImage.getRaster();
      int[] pixelArray = new int[1];
      for (int y = 0; y < data.height; y++) {
        for (int x = 0; x < data.width; x++) {
          raster.getPixel(x, y, pixelArray);
          data.setPixel(x, y, pixelArray[0]);
        }
      }
      return data;
    }
    return null;
  }
}
