/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/* Segment 13 Bedienung und Visualisierung, Plug-In Streckenprofil 
 * Copyright (C) 2009-2010 BitCtrl Systems GmbH
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information: 
 * BitCtrl Systems GmbH 
 * Weienfelser Strae 67 
 * 04229 Leipzig 
 * Phone: +49 341-490670 
 * mailto: info@bitctrl.de
 */
/**
 * Menge von EAdapter Listenern zwischen {@link org.eclipse.emf.ecore.EObject}s.<br />
 * 
 * Dependencies in the following table:
 * <table border="1">
 * <tr>
 * <td></td>
 * <td rowspan="2">{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#SYSTEM_OBJEKT_CONTAINER__MODELL_OBJEKT
 * modellObject}</td>
 * <td colspan="2">
 * {@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#ALTERNATIVE_STRECKEN_ABSCHNITTE__AKTIVER_STRECKEN_ABSCHNITT
 * aktiverStreckenAbschnitt}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#STRECKEN_EINTRAEGE_CONTAINER__STRECKEN_EINTRAEGE
 * streckenEintraege}</td>
 * </tr>
 * <tr>
 * <td></td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#NAMED__NAME .name}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#STRECKEN_ZUG_EINTRAG__LAENGE .laenge}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#STRECKEN_ZUG_EINTRAG__LAENGE .laenge}</td>
 * </tr>
 * <tr>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Strecke}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#NAMED__NAME name}</td>
 * <td>&nbsp;</td>
 * <td>&nbsp;</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#STRECKEN_ZUG_EINTRAG__LAENGE laenge}</td>
 * </tr>
 * <tr>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenKnoten}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#NAMED__NAME name}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#NAMED__NAME name}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#STRECKEN_ZUG_EINTRAG__LAENGE laenge}</td>
 * <td>&nbsp;</td>
 * </tr>
 * <tr>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.InnererStreckenAbschnitt}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#NAMED__NAME name},&nbsp;
 * {@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#STRECKEN_ZUG_EINTRAG__LAENGE laenge}</td>
 * <td>&nbsp;</td>
 * <td>&nbsp;</td>
 * <td>&nbsp;</td>
 * </tr>
 * <tr>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AeussererStreckenAbschnitt}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#NAMED__NAME name},&nbsp;
 * {@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#STRECKEN_ZUG_EINTRAG__LAENGE laenge}</td>
 * <td>&nbsp;</td>
 * <td>&nbsp;</td>
 * <td>&nbsp;</td>
 * </tr>
 * <tr>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AlternativeStreckenAbschnitte}</td>
 * <td>&nbsp;</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#NAMED__NAME name}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#STRECKEN_ZUG_EINTRAG__LAENGE laenge}</td>
 * <td>&nbsp;</td>
 * </tr>
 * <tr>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.MessQuerschnitt}</td>
 * <td>{@link de.bsvrz.buv.plugin.streckenprofil.model.StreckenprofilPackage#Literals#NAMED__NAME name}</td>
 * <td>&nbsp;</td>
 * <td>&nbsp;</td>
 * <td>&nbsp;</td>
 * </tr>
 * </table>
 * 
 * @author BitCtrl Systems GmbH, Enrico Schnepel
 * @version $Id: package-info.java,v 1.3 2014/04/17 15:51:19 Pittner Exp $
 */
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.adapter;

