/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.ursacheneinheit.luftschadstoffe;

import java.util.Observable;
import java.util.Observer;

import org.eclipse.swt.widgets.Composite;
/**
 * TabellenModell fr Parameter
 * 
 * @author Krause
 *
 */
public class TableModel extends Observable implements Observer
{
  private Composite _bezeichnung;
  private Composite _attribut;
  private Composite _einheit;


  public TableModel(Composite bezeichnung, Composite attribut, Composite einheit)
  {
    this._bezeichnung = bezeichnung;
    this._attribut = attribut;
    this._einheit = einheit;
    
    
  }

  public Composite getBezeichnung()
  {
    return _bezeichnung;
  }

  public Composite getAttribut()
  {
    return _attribut;
  }
 
  public Composite getEinheit()
  {
    return _einheit;
  }
  
  @Override
  public void update(Observable o, Object arg)
  {
//    System.out.println("Update: TableModel");
    fireEvent();
  }

  public void fireEvent()
  {
    setChanged();
    notifyObservers();
  }

}
