/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.ursacheneinheit.verwaltung;

import java.util.EventObject;
import java.util.List;

/**
 * Die Klasse {@link ListeUrsachenEinheiten} reprsentiert die Liste der Eintrge der UraschenEinheiten,
 * die in der Tabelle im Dialog {@link VerwaltungsSicht} dargestellt wird. <br>
 * 
 * @author Krause
 *
 */
public class ListeUrsachenEinheiten extends EventObject
{
  private static final long serialVersionUID = 1365256169927819794L;

  /**
   * Liste der ListeUrsachenEinheiten
   */
  private List<EintragUrsachenEinheit> _eintraege = null;

  /**
   * Konstruktor
   * 
   * @param quelle
   *          Quelle des Events.
   * @param eintraege
   *          ListeUrsachenEinheiten.
   */
  public ListeUrsachenEinheiten(Object quelle, List<EintragUrsachenEinheit> eintraege)
  {
    super(quelle);
    this._eintraege = eintraege;
  }

  /**
   * Liefert die empfangenen ListeUrsachenEinheiten zurck.
   * 
   * @return ListeUrsachenEinheiten.
   */
  public List<EintragUrsachenEinheit> getUrsachenEinheitenEintraege()
  {
    return this._eintraege;
  }

}
