package de.bsvrz.sba.plugin.actions.parameter;

/**
 * Dieses Interface beschreibt einen Parameter bestehend aus einer eindeutigen
 * Kennung (ID) und einem Wert (Value).
 * 
 * @author HofmannJ
 * 
 */
public interface IParameter
{
	/**
	 * Liefert die eindeutige Kennung (ID) des Parameters zurck.
	 * 
	 * @return ID des Parameters.
	 */
	public String getId();

	/**
	 * Liefert den Wert des Parameters (Value) zurck.
	 * 
	 * @return Wert des Parameters.
	 */
	public Object getValue();
	
	/**
	 * Setzt den Wert eines Parameters.
	 * @param value Wert
	 */
	public void setValue(Object value);

	/**
	 * Liefert Informationen zum Parameter.
	 * 
	 * @return Informationen zum Parameter.
	 * 
	 */
	public String getParameterInfo();
}
