package de.bsvrz.sba.plugin.ausgabefenster.treeviewer.test;

import java.util.LinkedList;

import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.part.ViewPart;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;

import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.ausgabefenster.treeviewer.OpenViewAusgabefenster;
import de.bsvrz.sba.plugin.ausgabefenster.treeviewer.ViewAusgabefenster;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class ViewAusgabefensterTest extends ViewPart
{

	public static final String ID = "de.bsvrz.sba.plugin.ausgabefenster.treeviewer.ViewAusgabefensterTest"; // TODO
																																																					// Needs
																																																					// to
																																																					// be
																																																					// whatever
																																																					// is
																																																					// mentioned
																																																					// in
																																																					// plugin.xml
	private Composite top = null;
	private Group groupAktionen = null;
	private Button buttonTest1 = null;
	private Button buttonTest2 = null;
	private Group groupDirektEingabe = null;
	private Label labelObjPid = null;
	private Label labelAtg = null;
	private Label labelAsp = null;
	private Text textSysObjPid = null;
	private Text textAtgPid = null;
	private Text textAspPid = null;
	private Button buttonOk = null;

	private void actionTest1()
	{
		ClientDavInterface con = DaVVerbindung.getInstanz().getDaVVerbindung();
		SystemObject obj1 = con.getDataModel().getObject("mq.MQ_3071793_HFB1_NO");
		LinkedList<SystemObject> li = new LinkedList<SystemObject>();
		li.add(obj1);
		SystemObject obj2 = con.getDataModel().getObject("mq.MQ_3071793_HFB1_SW");
		li.add(obj2);

		String pidAtg = "atg.verkehrsDatenKurzZeitMq";
		String pidAsp = "asp.analyse";

		short simVar = 0;
		ViewAusgabefenster openView = OpenViewAusgabefenster.openView(pidAtg,
				pidAsp, simVar, li);
		openView.darstellungAufbauen(li, pidAtg, pidAsp, simVar);
	}

	private void actionTest2()
	{
		ClientDavInterface con = DaVVerbindung.getInstanz().getDaVVerbindung();
		// SystemObject obj1 =
		// con.getDataModel().getObject("mq.MQ_3071793_HFB1_NO");
		SystemObject obj1 = con.getDataModel().getObject("mq.MQ_1.010_AB_NO_R");
		LinkedList<SystemObject> li = new LinkedList<SystemObject>();
		li.add(obj1);
		// SystemObject obj2 =
		// con.getDataModel().getObject("mq.MQ_3071793_HFB1_SW");
		SystemObject obj2 = con.getDataModel().getObject("mq.MQ_1.010_AB_SW_R");
		li.add(obj2);

		String pidAtg = "atg.strfallZustand";
		String pidAsp = "asp.strfallVerfahrenMARZ";

		short simVar = 0;
		ViewAusgabefenster openView = OpenViewAusgabefenster.openView(pidAtg,
				pidAsp, simVar, li);
		openView.darstellungAufbauen(li, pidAtg, pidAsp, simVar);
	}

	@Override
	public void createPartControl(Composite parent)
	{
		top = new Composite(parent, SWT.NONE);
		top.setLayout(new GridLayout());
		createGroupAktionen();
		createGroupDirektEingabe();
	}

	@Override
	public void setFocus()
	{
	}

	/**
	 * This method initializes groupAktionen
	 * 
	 */
	private void createGroupAktionen()
	{
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = false;
		gridData.verticalAlignment = GridData.CENTER;
		groupAktionen = new Group(top, SWT.NONE);
		groupAktionen.setLayoutData(gridData);
		groupAktionen.setLayout(gridLayout);
		groupAktionen.setText("Aktionen");
		buttonTest1 = new Button(groupAktionen, SWT.NONE);
		buttonTest1.setText("Test1");
		buttonTest1
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter()
				{
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e)
					{
						actionTest1();
					}
				});
		buttonTest2 = new Button(groupAktionen, SWT.NONE);
		buttonTest2.setText("Test2");
		buttonTest2
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter()
				{
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e)
					{
						actionTest2();
					}
				});
	}

	/**
	 * This method initializes groupDirektEingabe
	 * 
	 */
	private void createGroupDirektEingabe()
	{
		GridData gridData5 = new GridData();
		gridData5.horizontalAlignment = GridData.END;
		gridData5.verticalAlignment = GridData.CENTER;
		GridData gridData4 = new GridData();
		gridData4.horizontalAlignment = GridData.FILL;
		gridData4.grabExcessHorizontalSpace = true;
		gridData4.verticalAlignment = GridData.CENTER;
		GridData gridData3 = new GridData();
		gridData3.horizontalAlignment = GridData.FILL;
		gridData3.grabExcessHorizontalSpace = true;
		gridData3.verticalAlignment = GridData.CENTER;
		GridData gridData2 = new GridData();
		gridData2.horizontalAlignment = GridData.FILL;
		gridData2.grabExcessHorizontalSpace = true;
		gridData2.verticalAlignment = GridData.CENTER;
		GridLayout gridLayout1 = new GridLayout();
		gridLayout1.numColumns = 2;
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.grabExcessVerticalSpace = true;
		gridData1.verticalAlignment = GridData.FILL;
		groupDirektEingabe = new Group(top, SWT.NONE);
		groupDirektEingabe.setLayoutData(gridData1);
		groupDirektEingabe.setLayout(gridLayout1);
		groupDirektEingabe.setText("Direkt Eingabe");
		labelObjPid = new Label(groupDirektEingabe, SWT.NONE);
		labelObjPid.setText("SystemObjekt Pid:");
		textSysObjPid = new Text(groupDirektEingabe, SWT.BORDER);
		textSysObjPid.setText("mq.MQ_1.010_AB_NO_R");
		textSysObjPid.setLayoutData(gridData2);
		labelAtg = new Label(groupDirektEingabe, SWT.NONE);
		labelAtg.setText("Atg Pid:");
		textAtgPid = new Text(groupDirektEingabe, SWT.BORDER);
		textAtgPid.setText("atg.strfallZustand");
		textAtgPid.setLayoutData(gridData3);
		labelAsp = new Label(groupDirektEingabe, SWT.NONE);
		labelAsp.setText("Asp Pid:");
		textAspPid = new Text(groupDirektEingabe, SWT.BORDER);
		textAspPid.setText("asp.strfallVerfahrenMARZ");
		textAspPid.setLayoutData(gridData4);
		new Label(groupDirektEingabe, SWT.NONE);
		buttonOk = new Button(groupDirektEingabe, SWT.NONE);
		buttonOk.setText("OK");
		buttonOk.setLayoutData(gridData5);
		buttonOk.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter()
		{
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e)
			{
				aktionOk();
			}
		});
	}

	private void aktionOk()
	{
		ClientDavInterface con = DaVVerbindung.getInstanz().getDaVVerbindung();
		SystemObject obj1 = con.getDataModel().getObject(textSysObjPid.getText());
		LinkedList<SystemObject> li = new LinkedList<SystemObject>();
		li.add(obj1);

		String pidAtg = textAtgPid.getText();
		String pidAsp = textAspPid.getText();

		short simVar = 0;
		ViewAusgabefenster openView = OpenViewAusgabefenster.openView(pidAtg,
				pidAsp, simVar, li);
		openView.darstellungAufbauen(li, pidAtg, pidAsp, simVar);
	}

}
