/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.sba.plugin.dynobj.configurationAreas;

import org.eclipse.jface.preference.PreferenceStore;

/**
 * Definition der Parameterbezeichnungen des hier verwendeten
 * {@link PreferenceStore}s fr die Zuordnung von Konfigurationsbereichen zu
 * Objekttypen.
 * 
 * @author HofmannJ
 * 
 */
public class DefsPrefStore
{
	/**
	 * Einmalig vorkommender Parameter, definiert die Anzahl der Eintrge im
	 * {@link PreferenceStore}.
	 */
	public static final String P_COUNT = "AnzahlEintrge";

	/**
	 * Prefix fr Elemente der Zuordnung ObjektTyp - KonfigurationsBereich. Wird
	 * durch eine Zahl ergnzt.
	 */
	public static final String P_ELEMENT_PREFIX = "ObjTypConfArea#";
}
