/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.sba.plugin.navigator.navigatoreinstellungen;

/**
 * Definitionen fr die Namen von XML-Elementen und Attribugen
 * @author HofmannJ
 *
 */
public class DefsXml
{
	/**
	 * Wurzelelemente
	 */
	public static final String ELE_PREFERENCES_BASIS = "preferences";
	
	/**
	 * Element, reprsentiert einen "PreferenceStore"-Eintrag
	 */
	public static final String ELE_ELEMENT = "element";
	
	/**
	 * Attribut Schlssel
	 */
	public static final String ATT_KEY = "key";
	
	/**
	 * Attribut Typ
	 */
	public static final String ATT_TYP = "typ";
	
	/**
	 * Attribut Wert
	 */
	public static final String ATT_WERT = "wert";
	
	
	/**
	 * XML-Dateicodierung
	 */
	public static final String xmlCodierung = "ISO-8859-1";

	/**
	 * XML DocTyp PublicID
	 */
	public static final String xmlDocTypePublicId = "-//sba//DTD Dokument//DE";

	/**
	 * XML DocTypeElement
	 */
	public static final String xmlDocTypeElementName = ELE_PREFERENCES_BASIS;

	/**
	 * XML DTD Doctype
	 */
	public static final String xmlDocSystemId = "preferences.dtd";
}
