/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.sba.plugin.navigator.navigatoreinstellungen;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.PreferencePage;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import de.bsvrz.sba.plugin.navigator.Activator;

public class Navigatoreinstellungen extends PreferencePage implements IWorkbenchPreferencePage
{

  public Navigatoreinstellungen()
  {
    System.out.println("Navigatoreinstellungen.enclosing_method()");
  }

  public Navigatoreinstellungen( String title )
  {
    super( title );
  }

  public Navigatoreinstellungen( String title, ImageDescriptor image )
  {
    super( title, image );
  }

  @Override
  protected Control createContents( Composite parent )
  {
    return null;
  }

  @Override
  public void init( IWorkbench workbench )
  {
  }
  
  @Override
  protected void performDefaults() {    
    System.out.println("Navigatoreinstellungen.performDefaults()");    
    actionLoadDefaultsFromPreferenceStore();
    super.performDefaults();
  }
  
  /**
   * Stellt die Default-Einstellungen aus den Prferenzen wieder her.
   */
  private void actionLoadDefaultsFromPreferenceStore() {
    System.out.println("Navigatoreinstellungen.actionLoadDefaultsFromPreferenceStore()");    
    IPreferenceStore preferences = Activator.getDefault()
        .getPreferenceStore();    
  }

}
