package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.abhaengigkeiten;

import java.util.Vector;

import de.bsvrz.dav.daf.main.config.SystemObject;

/**
 * Klasse enthlt ein Feld (Liste) mit Parametern
 * @author Dambach Werke GmbH
 */
public class ListeMitRegeln
{
  /**
   * Liste mit den Parametern
   */
  private Vector<Abhaengigkeiten> m_parameter = new Vector<Abhaengigkeiten> ();

  /**
   * Parameterloser Konstruktor der Klasse
   */
  public ListeMitRegeln ()
  {
  }
  
  /**
   * Methode liefert die Variable parameter zurck
   * @return Variable parameter
   */
  public Vector<Abhaengigkeiten> getParameter()
  {
    Vector<Abhaengigkeiten> v = new Vector<Abhaengigkeiten>();
    synchronized (m_parameter)
    {
      for (Abhaengigkeiten r : m_parameter)
        v.add( r );
    }
    return v;
  }

  /**
   * Methode fgt eine Regel hinzu
   * @param hauptAnzeige Hauptanzeige
   * @param abhaengigeAnzeige Abhngige Anzeige
   */
  public void addRegel (SystemObject hauptAnzeige, SystemObject abhaengigeAnzeige)
  {
    synchronized (m_parameter)
    {
      Abhaengigkeiten r = new Abhaengigkeiten(hauptAnzeige, abhaengigeAnzeige);
      m_parameter.add( r );
    }
  }

  /**
   * Methode liefert den Inahlt der Klasse als String
   */
  public String toString ()
  {
    String s = "";
    
    synchronized (m_parameter)
    {
      s += "Regeln:\n";
      for (Abhaengigkeiten r : m_parameter)
        s += r.toString() + "\n";
    }
    
    return s;
  }

  /**
   * Methode setzt die Variable parameter
   * @param parameter Wert fr parameter
   */
  public void setParameter(Vector<Abhaengigkeiten> parameter)
  {
    synchronized (m_parameter)
    {
      m_parameter.clear();
      
      for (Abhaengigkeiten r : parameter)
      {
        m_parameter.add(r);
      }
    } 
  }
}
