package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.bedienung;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.AnzeigeQuerschnittMitTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.ESpezialWVZInhalt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.AnzeigeTypEigenschaften;

/**
 * Klasse kapselt die Parameter fr die Bedienung
 * @author ObertM
 *
 */
public class ParameterBedienung
{
	/**
	 * Mgliche Schaltgrnde
	 */
	private Vector<SystemObject> _moeglicheSchaltgruende = new Vector<SystemObject>();
	
	/**
	 * Spezial WVZ-Inhalte
	 */
	private HashMap<ESpezialWVZInhalt, SystemObject> _spezialWVZInhalte = new HashMap<ESpezialWVZInhalt, SystemObject>();

	/**
	 * Mgliche Anzeigequerschnitte
	 */
	private List<AnzeigeQuerschnittMitTyp> _moeglicheAnzeigeQuerschnitte = new ArrayList<AnzeigeQuerschnittMitTyp>();
	
	/**
	 * Anzeigetypen mit WVZ-Inhalten
	 */
	private Vector<AnzeigeTypEigenschaften> _anzeigeTypen = new Vector<AnzeigeTypEigenschaften>();
	
	/**
   * Methode liefert moeglicheSchaltgruende zurck
   * @return moeglicheSchaltgruende
   */
  public Vector<SystemObject> getMoeglicheSchaltgruende()
  {
  	return _moeglicheSchaltgruende;
  }

	/**
   * Methode setzt die Variable moeglicheSchaltgruende
   * @param moeglicheSchaltgruende zu bernehmender Wert fr moeglicheSchaltgruende
   */
  public void setMoeglicheSchaltgruende(
      Vector<SystemObject> moeglicheSchaltgruende)
  {
  	_moeglicheSchaltgruende = moeglicheSchaltgruende;
  }

	/**
   * Methode liefert spezialWVZInhalte zurck
   * @return spezialWVZInhalte
   */
  public HashMap<ESpezialWVZInhalt, SystemObject> getSpezialWVZInhalte()
  {
  	return _spezialWVZInhalte;
  }

	/**
   * Methode setzt die Variable spezialWVZInhalte
   * @param spezialWVZInhalte zu bernehmender Wert fr spezialWVZInhalte
   */
  public void setSpezialWVZInhalte(
      HashMap<ESpezialWVZInhalt, SystemObject> spezialWVZInhalte)
  {
  	_spezialWVZInhalte = spezialWVZInhalte;
  }

	/**
   * Methode liefert moeglicheAnzeigeQuerschnitte zurck
   * @return moeglicheAnzeigeQuerschnitte
   */
  public List<AnzeigeQuerschnittMitTyp> getMoeglicheAnzeigeQuerschnitte()
  {
  	return _moeglicheAnzeigeQuerschnitte;
  }

	/**
   * Methode setzt die Variable moeglicheAnzeigeQuerschnitte
   * @param moeglicheAnzeigeQuerschnitte zu bernehmender Wert fr moeglicheAnzeigeQuerschnitte
   */
  public void setMoeglicheAnzeigeQuerschnitte(
      List<AnzeigeQuerschnittMitTyp> moeglicheAnzeigeQuerschnitte)
  {
  	_moeglicheAnzeigeQuerschnitte = moeglicheAnzeigeQuerschnitte;
  }

	/**
   * Methode liefert anzeigeTypen zurck
   * @return anzeigeTypen
   */
  public Vector<AnzeigeTypEigenschaften> getAnzeigeTypen()
  {
  	return _anzeigeTypen;
  }

	/**
   * Methode setzt die Variable anzeigeTypen
   * @param anzeigeTypen zu bernehmender Wert fr anzeigeTypen
   */
  public void setAnzeigeTypen(Vector<AnzeigeTypEigenschaften> anzeigeTypen)
  {
  	_anzeigeTypen = anzeigeTypen;
  }
}
