package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.lueckenfuellen;

import java.util.List;
import java.util.Vector;

import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.Richtung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.WVZInhalt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.Richtung.ArbeitsRichtungVN;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.AnzeigeElementFigure;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.AnzeigeInhaltTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.VerwaltungWvzInhalte;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.AnzeigeElementTyp;

/**
 * Klasse zum Erzeugen der Defaultwerte fr die Regel "Lcken fllen"
 * @author ObertM
 *
 */
public class DefaultWerte
{
	/**
	 * Anzahl Bilder pro zeile
	 */
  private int _anzBilderProZeile;

	/**
   * Methode generiert automatisch alle Regeln fr eine 20km/h Geschwindigkeitsdiffernze
   */
  public Vector<RegelLueckenFuellen> getDefaultWerte (int anzBilderProZeile)
  {
  	_anzBilderProZeile = anzBilderProZeile;
  	
  	AnzeigeInhaltTyp km40    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_40;
  	AnzeigeInhaltTyp km50    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_50;
  	AnzeigeInhaltTyp km60    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_60;
  	AnzeigeInhaltTyp km80    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_80;
  	AnzeigeInhaltTyp km100   = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_100;
  	AnzeigeInhaltTyp km120   = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_120;
  	AnzeigeInhaltTyp km130   = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_130;

  	AnzeigeInhaltTyp endeKm40    = AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_40;
  	AnzeigeInhaltTyp endeKm50    = AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_50;
  	AnzeigeInhaltTyp endeKm60    = AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_60;
  	AnzeigeInhaltTyp endeKm80    = AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_80;
  	AnzeigeInhaltTyp endeKm100   = AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_100;
  	AnzeigeInhaltTyp endeKm120   = AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_120;
  	AnzeigeInhaltTyp endeKm130   = AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_130;

  	AnzeigeInhaltTyp kreuz   = AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_GESPERRT;
  	AnzeigeInhaltTyp pfl     = AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_WECHSELN_NACH_LINKS;
  	AnzeigeInhaltTyp pfr     = AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS;
  	AnzeigeInhaltTyp stau    = AnzeigeInhaltTyp.TLS_STAU;

		Vector<RegelLueckenFuellen> regeln = new Vector<RegelLueckenFuellen>();
	  
	  List<AnzeigeInhaltTyp> moeglicheBilder = AnzeigeElementFigure.createAnzeigeInhalte(AnzeigeElementTyp.WZG_A);
	  
	  /*
	   * 40 km/h
	   */
	  moeglicheBilder.remove(kreuz);
	  moeglicheBilder.remove(pfl);
	  moeglicheBilder.remove(pfr);
	  moeglicheBilder.remove(stau);
	  
	  moeglicheBilder.remove(km40);

	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km40, km40, km40));

	  /*
	   * 50 km/h
	   */
	  moeglicheBilder.remove(endeKm40);
	  moeglicheBilder.remove(km50);
	  
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km50, km50, km50));

	  /*
	   * 60 km/h
	   */
	  moeglicheBilder.remove(endeKm50);
	  moeglicheBilder.remove(km60);
	  
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km60, km60, km60));

	  /*
	   * 80 km/h
	   */
	  moeglicheBilder.remove(endeKm60);
	  moeglicheBilder.remove(km80);
	  
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km80, km80, km80));

	  /*
	   * 100 km/h
	   */
	  moeglicheBilder.remove(endeKm80);
	  moeglicheBilder.remove(km100);
	  
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km100, km100, km100));

	  /*
	   * 120 km/h
	   */
	  moeglicheBilder.remove(endeKm100);
	  moeglicheBilder.remove(km120);
	  
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km120, km120, km120));

	  /*
	   * 130 km/h
	   */
	  moeglicheBilder.remove(endeKm120);
	  moeglicheBilder.remove(km130);
	  
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km130, km130, km130));

	  return regeln;
  }

  private Vector<RegelLueckenFuellen> erzeugeRegeln(
      List<AnzeigeInhaltTyp> moeglicheBilder, AnzeigeInhaltTyp inhaltX, AnzeigeInhaltTyp inhaltY,
      AnzeigeInhaltTyp inhaltA)
  {
  	Aspect schaltgrund = VerwaltungParaLueckenFuellen.getInstance().getSchaltgrundAllgemein();
  	ArbeitsRichtungVN richtung = Richtung.ArbeitsRichtungVN.NACHFOLGER;

	  Vector<RegelLueckenFuellen> regeln = new Vector<RegelLueckenFuellen>();
	  
	  VerwaltungWvzInhalte verw = VerwaltungWvzInhalte.getInstance();
	  
	  WVZInhalt x = verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, inhaltX.getBildInhalt());
	  WVZInhalt a = verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, inhaltA.getBildInhalt());
	  
	  if (x == null || a == null)
	  	return regeln;
	  
    List<WVZInhalt>	 xyz = new Vector<WVZInhalt>();
	  for (AnzeigeInhaltTyp ait : moeglicheBilder)
	  {
	  	WVZInhalt tmp = verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, ait.getBildInhalt());
	  	if (tmp != null)
	  	  xyz.add(tmp);
	  }

	  while (xyz.size() > 0)
	  {
	    List<WVZInhalt>	 xyzTmp = new Vector<WVZInhalt>();
	    for (int i=0; i<_anzBilderProZeile && i<xyz.size(); ++i)
	    	xyzTmp.add(xyz.get(i));
	    
	    for (WVZInhalt inhalt : xyzTmp)
	    	xyz.remove(inhalt);
	    	
	    List<WVZInhalt>	uvw = new Vector<WVZInhalt>();
	    uvw.add(verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, inhaltY.getBildInhalt()));
	    
		  RegelLueckenFuellen r = new RegelLueckenFuellen(schaltgrund, richtung, x, xyzTmp, uvw, a);
		  regeln.add(r);
	  }
	  
	  return regeln;
  }

}
