package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.vorgaengerNachfolger;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.VorgaengerNachfolgerArt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.Konfig;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.VerwaltungAnzeigeTypen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.EAnzeigeQuerschnittTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.tools.Tools;

/**
 * Darstellung des Fensters zur Versorgung der Parameter
 */
public class CompositeParameterLaengs extends Composite
{
	/**
	 * Aktuelles Composite
	 */
  private Composite _composite;

  /**
   * Composite fr die Buttons
   */
	private Composite _compositeButtons;

	/**
	 * Defaultbutton
	 */
	private Button _buttonDefault;

	/**
	 * Liste mglicher Anzeigequerschnitte
	 */
	private List<SystemObject> _listeMoeglicherAQs;

	/**
	 * Auswahl AQ
	 */
	private AuswahlObjekt _aq;

	/**
	 * Auswahl Anzeige
	 */
	private AuswahlObjekt _anzeige;

	/**
	 * Auswahl direkter Vorgnger
	 */
	private AuswahlObjekt _direkterVorgaenger;

	/**
	 * Auswahl Vorgnger gleichen Typs
	 */
	private AuswahlObjekt _vorgngerGleichenTyps;

	/**
	 * Auswahl direkter Nachfolger
	 */
	private AuswahlObjekte _direkteNachfolger;

	/**
	 * Auswahl Nachfolger gleichen Typs
	 */
	private AuswahlObjekte _nachfolgerGleichenTyps;

	/**
	 * Liste mglicher Anzeigen
	 */
	private List<SystemObject> _listeMoeglicherAnzeigen;

	/**
	 * Aktuell angewhlte Anzeige
	 */
	private SystemObject _aktuelleAnzeige;

	/**
	 * Aktuell angewhlter Anzeigequerschnitt
	 */
	private SystemObject _aktuellerAnzeigeQuerschnitt;

	/**
	 * Mgliche Objekte Vorgnger gleicher Typ
	 */
	private List<String> _objekteVGT;

	/**
	 * Mgliche Objekte Nachfolger gleicher Typ
	 */
	private List<String> _objekteNGT;

	/**
	 * Mgliche Objekte direkte Vorgnger
	 */

	private List<String> _objekteDV;

	/**
	 * Mgliche Objekte direkte Nachfolger
	 */

	private List<String> _objekteDN;

	private ParameterVorgaengerNachfolger _parameter;

	private AuswahlObjekt _filterNachfolger;

	protected SystemObject _aktuellerNachfolgeQuerschnitt;

	private AuswahlObjekt _filterVorgaenger;

  /**
   * Konstruktor der Klasse
   * @param parent Parent Composite
   * @param style Stil des Fenstern
   * @param parameter 
   * @param aktuell Aktuelle Parameter
   * @param fahrtrichtung Fahrtrichtung
   */
  CompositeParameterLaengs (Composite parent, int style, ParameterVorgaengerNachfolger parameter)
  {
    super (parent, style);
   
    _parameter = parameter;
    
    initialize();
  }

  /**
   * Fhrt die Basis-Initialisierung des Composites durch
   */
  private void initialize()
  {
    if ( _listeMoeglicherAQs == null )
    	_listeMoeglicherAQs = Konfig.getInstance().getAnzeigeQuerschnitte();

    if ( _listeMoeglicherAnzeigen == null )
    	_listeMoeglicherAnzeigen = Konfig.getInstance().getAnzeigen();
    
    /*
     * Composite anlegen
     */
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.grabExcessVerticalSpace = true;
    gridData1.heightHint = -1;
    gridData1.widthHint = -1;
    gridData1.horizontalIndent = 0;
    gridData1.verticalAlignment = GridData.FILL;
    
    setLayout(new GridLayout(1, false));
    setLayoutData(gridData1);
    
//    _composite = new ScrolledComposite(this, SWT.NONE | SWT.H_SCROLL | SWT.V_SCROLL);
    _composite = new Composite(this, SWT.NONE);
    _composite.setLayout(new GridLayout(1, false));
    _composite.setLayoutData(gridData1);
 
    /*
     * Auswahl Anzeigequerschnitt
     */
    _aq = new AuswahlObjekt(_composite, "Anzeigequerschnitt");
    _aq.setMoeglicheObjekte(ToolsVN.bestimmeObjektNamen(_listeMoeglicherAQs, false));

    /*
     * Auswahl Anzeige
     */
    _anzeige = new AuswahlObjekt(_composite, "zu betrachtende Anzeige");

    /*
     * Vorgnger
     */
    erzeugeVorgaengerElemente(_composite);

    /*
     * Nachfolger
     */
    erzeugeNachfolgerElemente(_composite);

    /*
     * nderung bei den Anzeigen
     */
    _anzeige.addPropertyChangeListener(new PropertyChangeListener()
		{
			@Override
			public void propertyChange(PropertyChangeEvent evt)
			{
				leseAktuelleEinstellungen();
				
				bestimmeMoeglicheWerte ();
				updateData();
			}
		});

    /*
     * nderungen bei den Anzeigequerschnitten
     */
    _aq.addPropertyChangeListener(new PropertyChangeListener()
		{
			@Override
			public void propertyChange(PropertyChangeEvent arg0)
			{
				leseAktuelleEinstellungen();
				
				String name = _aq.getAusgewaehltesObjekt();
				
				if (name != null)
				{
					leseAktuelleEinstellungen();
					
					SystemObject aq = ToolsVN.bestimmeObjekt (name, _listeMoeglicherAQs);
					
					_aktuellerAnzeigeQuerschnitt = aq;
					
					if (aq != null)
					{
						bestimmeAnzeigenAktuellerAQ (aq);
						bestimmeMoeglicheNachfolger(aq);
						bestimmeMoeglicheVorgaenger(aq);
						
						bestimmeMoeglicheWerte();
						bestimmeZustandDefaultButton();
						updateData();
					}
				}
			}

		});

    _filterNachfolger.addPropertyChangeListener(new PropertyChangeListener()
		{
			@Override
			public void propertyChange(PropertyChangeEvent arg0)
			{
				String name = _filterNachfolger.getAusgewaehltesObjekt();
				
				if (name != null)
				{
					bestimmeMoeglicheWerte();
					
					leseAktuelleEinstellungen();

					_aktuellerNachfolgeQuerschnitt = Konfig.getInstance().getAnzeigeQuerschnittByName(name); 

					bestimmeZustandDefaultButton ();
					updateData();
				}
			}

		});

    _filterVorgaenger.addPropertyChangeListener(new PropertyChangeListener()
		{
			@Override
			public void propertyChange(PropertyChangeEvent arg0)
			{
				String name = _filterVorgaenger.getAusgewaehltesObjekt();
				
				if (name != null)
				{
					bestimmeMoeglicheWerte();
					
					leseAktuelleEinstellungen();
					
					updateData();
			  }
			}
		});

  }

  /**
   * Methode erzeugt die Eingabeelemente fr die Vorgngerbeziehung
   * @param parent Parentcomposite
   */
  private void erzeugeVorgaengerElemente (Composite parent)
  {
    GridData gridDataGroup = new GridData();
    gridDataGroup.horizontalAlignment = GridData.FILL;
    gridDataGroup.grabExcessHorizontalSpace = true;

    Group gruppe = new Group(parent, SWT.NONE);
    gruppe.setText("Vorgnger in Lngsrichtung");
    gruppe.setLayout(new GridLayout(1, false));
    gruppe.setLayoutData(gridDataGroup);

    _filterVorgaenger = new AuswahlObjekt(gruppe, "Filter");

    _direkterVorgaenger = new AuswahlObjekt(gruppe, "direkter Vorgnger");

    _vorgngerGleichenTyps = new AuswahlObjekt(gruppe, "Vorgnger gleichen Typs");
  }

  /**
   * Methode erzeugt die Eingabeelemente fr die Nachfolgerbeziehung
   * @param parent Parentcomposite
   */
  private void erzeugeNachfolgerElemente (Composite parent)
  {
    GridData gridDataGroup = new GridData();
    gridDataGroup.horizontalAlignment = GridData.FILL;
    gridDataGroup.grabExcessHorizontalSpace = true;

    Group gruppe = new Group(parent, SWT.NONE);
    gruppe.setText("Nachfolger in Lngsrichtung");
    gruppe.setLayout(new GridLayout(1, false));
    gruppe.setLayoutData(gridDataGroup);

    _filterNachfolger = new AuswahlObjekt(gruppe, "Filter");
    
    _direkteNachfolger = new AuswahlObjekte(gruppe, "direkte Nachfolger");

    _nachfolgerGleichenTyps = new AuswahlObjekte(gruppe, "Nachfolger gleichen Typs");
    
    /*
     * Buttons
     */
    createButtons(gruppe);
  }

  /**
   * Methode bestimmt den Zustand des Default-Buttons
   */
	protected void bestimmeZustandDefaultButton()
  {
		boolean moeglich = false;
		
		EAnzeigeQuerschnittTyp typ = VerwaltungAnzeigeTypen.getInstance().getTyp(_aktuellerAnzeigeQuerschnitt);
		
		if (_aktuellerNachfolgeQuerschnitt != null)
		{
			EAnzeigeQuerschnittTyp typN = VerwaltungAnzeigeTypen.getInstance().getTyp(_aktuellerNachfolgeQuerschnitt);
			if (typ == typN)
				moeglich = true;
			
//			System.out
//          .println("CompositeParameterLaengs.bestimmeZustandDefaultButton() " + 
//          		"Aktuell: " + typ + " Selektiert: " + typN);
		}
		
		if (_buttonDefault != null)
		  _buttonDefault.setEnabled(moeglich);
  }

	/**
	 * Methode bestimmt die Anzeigen eines Anzeigequerschnitts
	 * @param aq Querschnitt
	 */
	private void bestimmeAnzeigenAktuellerAQ(SystemObject aq)
  {
		List<SystemObject> anzeigenDesQuerschnitts = ToolsVN.bestimmeAnzeigenZuAq(aq);
	  _anzeige.setMoeglicheObjekte(ToolsVN.bestimmeObjektNamen(anzeigenDesQuerschnitts, false));
  }

	/**
	 * Methode bestimmt die mglichen Anzeigequerschnitte in Lngsrichtung
	 * @param aq Querschnitt zu betrachtender Anzeigequerschnitt
	 */
	private void bestimmeMoeglicheNachfolger(SystemObject aq)
  {
		String richtung = Konfig.getInstance().getRichtung(aq);
		
		List<SystemObject> moeglicheNachfolger = new ArrayList<SystemObject>();
		
		if (_listeMoeglicherAQs != null)
		{
			for (SystemObject so : _listeMoeglicherAQs)
			{
				if (so == aq)
					continue;
				
				if (Konfig.getInstance().getRichtung(so) == richtung)
				  moeglicheNachfolger.add(so);
			}
			
		  _filterNachfolger.setMoeglicheObjekte(ToolsVN.bestimmeObjektNamen(moeglicheNachfolger, true));
		}
  }

	/**
	 * Methode bestimmt die mglichen Anzeigequerschnitte in Lngsrichtung
	 * @param aq Querschnitt zu betrachtender Anzeigequerschnitt
	 */
	private void bestimmeMoeglicheVorgaenger(SystemObject aq)
  {
		String richtung = Konfig.getInstance().getRichtung(aq);
		
		List<SystemObject> moeglicheNachfolger = new ArrayList<SystemObject>();
		
		if (_listeMoeglicherAQs != null)
		{
			for (SystemObject so : _listeMoeglicherAQs)
			{
				if (so == aq)
					continue;
				
				if (Konfig.getInstance().getRichtung(so) == richtung)
				  moeglicheNachfolger.add(so);
			}
			
		  _filterVorgaenger.setMoeglicheObjekte(ToolsVN.bestimmeObjektNamen(moeglicheNachfolger, true));
		}
  }

	/**
	 * Methode bestimmt die mglichen Auswahlwerte die abhngig von einer Anzeige sind
	 */
	private void bestimmeMoeglicheWerte()
  {
		/*
		 * Aktuelle Anzeige bestimmen
		 */
		String name = _anzeige.getAusgewaehltesObjekt();
		if (name == null)
		{
			_aktuelleAnzeige = null;
			return;
		}

		SystemObject anzeige = ToolsVN.bestimmeObjekt (name, _listeMoeglicherAnzeigen);
		_aktuelleAnzeige = anzeige;

		if (anzeige != null)
		{
		  SystemObject typ = Konfig.getInstance().getWzgTypVonAnzeige(anzeige.getPid());
		  
		  /*
		   * Bestimmen der mglichen Vorgngerobjekte (= alle Anzeigen ausseer der eigenen)
		   */
		  List<SystemObject> listeMoeglicherVorgaenger = new ArrayList<SystemObject>();
		  List<SystemObject> listeMoeglicherVorgaengerGleicherTyp = new ArrayList<SystemObject>();
		  
			/*
			 * Vorgnger bestimmen
			 */
			name = _filterVorgaenger.getAusgewaehltesObjekt();
			if (name != null && !name.equals(ToolsVN._undefiniert))
			{
				SystemObject vorgaenger = ToolsVN.bestimmeObjekt (name, _listeMoeglicherAQs);
				listeMoeglicherVorgaenger = ToolsVN.bestimmeAnzeigenZuAq(vorgaenger);
			}
			else
			{
			  for (SystemObject so : _listeMoeglicherAnzeigen)
			  {
			  	if (so != anzeige)
			  		listeMoeglicherVorgaenger.add(so);
			  }
			}

		  for (SystemObject so : listeMoeglicherVorgaenger)
		  {
	  	  SystemObject typSo = Konfig.getInstance().getWzgTypVonAnzeige(so.getPid());
	  	  
	  	  if (typSo == null)
	  	  	listeMoeglicherVorgaengerGleicherTyp.add(so);
	  	  else
	  	  {
			  	if (typ == typSo)
			  		listeMoeglicherVorgaengerGleicherTyp.add(so);
	  	  }
		  }

		  _objekteVGT = ToolsVN.bestimmeObjektNamen(listeMoeglicherVorgaengerGleicherTyp, true);
		  _objekteDV  = ToolsVN.bestimmeObjektNamen(listeMoeglicherVorgaenger, true);
		  
		  /*
		   * Bestimmen der mglichen Nachfolgerobjekte (abhngig ob NachfolgerAQ ausgewhlt wurde)
		   */
		  List<SystemObject> listeMoeglicherNachfolger = new ArrayList<SystemObject>();
		  List<SystemObject> listeMoeglicherNachfolgerGleicherTyp = new ArrayList<SystemObject>();

			/*
			 * Nachfolger bestimmen
			 */
			name = _filterNachfolger.getAusgewaehltesObjekt();
			if (name != null && !name.equals(ToolsVN._undefiniert))
			{
				SystemObject nachfolger = ToolsVN.bestimmeObjekt (name, _listeMoeglicherAQs);
				listeMoeglicherNachfolger = ToolsVN.bestimmeAnzeigenZuAq(nachfolger);
			}
			else
			{
			  for (SystemObject so : _listeMoeglicherAnzeigen)
			  {
			  	if (so != anzeige)
			  		listeMoeglicherNachfolger.add(so);
			  }
			}

		  for (SystemObject so : listeMoeglicherNachfolger)
		  {
	  	  SystemObject typSo = Konfig.getInstance().getWzgTypVonAnzeige(so.getPid());
	  	  
	  	  if (typSo == null)
	  	  	listeMoeglicherNachfolgerGleicherTyp.add(so);
	  	  else
	  	  {
			  	if (typ == typSo)
			  		listeMoeglicherNachfolgerGleicherTyp.add(so);
	  	  }
		  }

		  /*
		   * Bisher angewhlte Objekte bleiben auch nach Filternderung erhalten+
		   */
		  _objekteNGT = ToolsVN.bestimmeObjektNamen(listeMoeglicherNachfolgerGleicherTyp, false);
		  _objekteDN  = ToolsVN.bestimmeObjektNamen(listeMoeglicherNachfolger, false);
		}		
  }

  /**
   * Methode bernimmt die Daten und zeigt diese in der Tabelle an
   */
  private void updateData ()
  {
  	if (_aktuelleAnzeige == null)
  		return;

  	/*
  	 * Direkter Vorgnger
  	 */
  	SystemObject dv  =_parameter.getVorgaengerInLaengsRichtung(_aktuelleAnzeige, VorgaengerNachfolgerArt.DIREKT );
    if (dv == null)
    	_direkterVorgaenger.setAngewaehltesObjekt(_objekteDV, ToolsVN._undefiniert);
    else
    	_direkterVorgaenger.setAngewaehltesObjekt(_objekteDV, ToolsVN.bestimmeBezeichnung(dv));

  	/*
  	 * Vorgnger gleichen Typs
  	 */
  	SystemObject vgt = _parameter.getVorgaengerInLaengsRichtung(_aktuelleAnzeige, VorgaengerNachfolgerArt.GLEICHERTYP );
    if (vgt == null)
    	_vorgngerGleichenTyps.setAngewaehltesObjekt(_objekteVGT, ToolsVN._undefiniert);
    else
    	_vorgngerGleichenTyps.setAngewaehltesObjekt(_objekteVGT, ToolsVN.bestimmeBezeichnung(vgt));

  	/*
  	 * Direkter Nachfolger
  	 */
  	SystemObject[] dn  = _parameter.getNachfolgerInLaengsRichtung(_aktuelleAnzeige, VorgaengerNachfolgerArt.DIREKT );
    _direkteNachfolger.setAngewaehlteObjekte (_objekteDN, ToolsVN.bestimmeObjektNamen (dn, false));

  	/*
  	 * Nachfolger gleichen Typs
  	 */
  	SystemObject[] ngt = _parameter.getNachfolgerInLaengsRichtung(_aktuelleAnzeige, VorgaengerNachfolgerArt.GLEICHERTYP );
    _nachfolgerGleichenTyps.setAngewaehlteObjekte (_objekteNGT, ToolsVN.bestimmeObjektNamen (ngt, false));
  }

  /**
   * Methode erzeugt das Composite mit den Buttons
   */
  private void createButtons(Composite parent)
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    
    _compositeButtons = new Composite( parent, SWT.NONE );
    _compositeButtons.setLayoutData( gridData3 );
    _compositeButtons.setLayout( rowLayout );
    
    _buttonDefault = new Button( _compositeButtons, SWT.NONE );
    _buttonDefault.setText( "Zuordnung automatisch ermitteln" );
    _buttonDefault.setEnabled(false);
    _buttonDefault.addMouseListener( new MouseAdapter()
    {
      @Override
      public void mouseDown( MouseEvent e )
      {
        aktionDefault ();
      }
    } );
  }
  
  /**
   * Methode generiert automatisch alle B/C Kombinationen
   */
  protected void aktionDefault()
  {
  	setzeLaengsBeziehung (_aktuellerAnzeigeQuerschnitt, _aktuellerNachfolgeQuerschnitt);
  }

	public void leseAktuelleEinstellungen()
  {
  	if (_aktuelleAnzeige != null)
  	{
  		SystemObject so = null;
  		
  		/*
  		 * Direkter Vorgnger
  		 */
  		String name = _direkterVorgaenger.getAusgewaehltesObjekt();
  		if (name.equals(ToolsVN._undefiniert))
  		  so = null;
  		else
  			so = ToolsVN.bestimmeObjekt(name, _listeMoeglicherAnzeigen);
  		
  		_parameter.setDirektenVorgaengerLaengsrichtung(_aktuelleAnzeige, so);

  		/*
  		 * Vorgnger gleichen Typs
  		 */
  		name = _vorgngerGleichenTyps.getAusgewaehltesObjekt();
  		if (name.equals(ToolsVN._undefiniert))
  		  so = null;
  		else
  			so = ToolsVN.bestimmeObjekt(name, _listeMoeglicherAnzeigen);
  		
  		_parameter.setVorgaengerGleichenTypsLaengsrichtung(_aktuelleAnzeige, so);
  		
  		/*
  		 * Direkte Nachfolger
  		 */
  		SystemObject[] nachfolger = ToolsVN.bestimmeSystemObjekteAusListe(_direkteNachfolger.getZugeordneteObjekte(), _listeMoeglicherAnzeigen);
  		_parameter.setDirekteNachfolgerLaengsrichtung(_aktuelleAnzeige, nachfolger);
  		
  		/*
  		 * Nachfolger gleichen typs
  		 */
  		nachfolger = ToolsVN.bestimmeSystemObjekteAusListe(_nachfolgerGleichenTyps.getZugeordneteObjekte(), _listeMoeglicherAnzeigen);
  		_parameter.setNachfolgerGleichenTypsLaengsrichtung(_aktuelleAnzeige, nachfolger);
  	}
  }
	
	/**
	 * Methode setzt die Querbeziehungen innerhalb eines Anzeigequerschnitts vom Typ<br>
	 * @param anzeigeQuerschnitt Anzeigequerschnitt
	 */
  public void setzeLaengsBeziehung (SystemObject anzeigeQuerschnitt, SystemObject nachfolger)
  {
  	SystemObject[] aq = Tools.getSystemObjekteAnzeigen(anzeigeQuerschnitt);
  	SystemObject[] nf = Tools.getSystemObjekteAnzeigen(nachfolger);
  	
  	if (aq != null && nf != null && aq.length == nf.length)
  	  erzeugeRegeln(aq, nf);

    updateData();
  }

  /**
   * Methode erzeugt die Vorgnger/Nachfolger Beziehung fr einen Anzeigequerschnitt
   * @param reihenfolge Reihenfolge der Anzeigen innerhalb des Anzeigequerschnitts in
   * der Reihenfolge von links nach rechts und von oben nach unten. 
   */
  private void erzeugeRegeln(SystemObject[] anzeigenAQ, SystemObject [] anzeigenNF)
  {
  	ParameterVorgaengerNachfolger v = _parameter;
  	
  	for (int i=0; i<anzeigenAQ.length; ++i)
  	{
  		v.setDirekteNachfolgerLaengsrichtung      (anzeigenAQ [i], new SystemObject [] {anzeigenNF [i]});
  		v.setNachfolgerGleichenTypsLaengsrichtung (anzeigenAQ [i], new SystemObject [] {anzeigenNF [i]});
  		
  		v.setDirektenVorgaengerLaengsrichtung       (anzeigenNF[i], anzeigenAQ [i]);
  		v.setVorgaengerGleichenTypsLaengsrichtung   (anzeigenNF[i], anzeigenAQ [i]);
  	}
  }

}
