/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf;

import java.util.Timer;
import java.util.TimerTask;

import org.eclipse.ui.IStartup;
import org.eclipse.ui.PlatformUI;

import de.sts.buv.plugin.workflow.tsf.dav.DaVKomTSFSteuerung;
import de.sts.buv.plugin.workflow.tsf.dav.DaVKomTSFWeiterSchalten;
import de.sts.buv.plugin.workflow.tsf.dav.DaVKomTSFWorkflow;
import de.sts.buv.plugin.workflow.tsf.jface.DialogTest;

/**
 * Startet die fr den Workflow notwendigen Klassen zu DaV-Kommunikation.
 * 
 * @author HofmannJ
 * 
 */
public class StartWorkflow implements IStartup
{
	@Override
	public void earlyStartup()
	{
		TimerTask task = new TimerTask()
		{

			@Override
			public void run()
			{
				/*
				 * Muss vor Workflow aktiv sein da sonst nicht rechtzeitig geprft
				 * werden kann, ob die Steuerung fr einen Abschnitt und ein bestimmtes
				 * Programm fertig ist.
				 */
				DaVKomTSFSteuerung.getInstance();
				DaVKomTSFWorkflow.getInstance();			 
				DaVKomTSFWeiterSchalten.getInstance();
			}
		};
		Timer timer = new Timer("Workflow Startup");
		timer.schedule(task, 5000l);

	}
}
