/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.dav;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import de.bsvrz.dav.daf.main.ClientDavConnection;
import de.bsvrz.dav.daf.main.ClientDavParameters;
import de.bsvrz.dav.daf.main.CommunicationError;
import de.bsvrz.dav.daf.main.ConnectionException;
import de.bsvrz.dav.daf.main.InconsistentLoginException;
import de.bsvrz.dav.daf.main.MissingParameterException;
import de.sts.buv.plugin.workflow.tsf.dav.GUIModelTSFAbschnittBefehl.WrapperListenerBenachrichtigung;

public class Test
{

	private static ClientDavConnection _con;

	public Test()
	{
		// TestTFSWorkflow();
		TestTFSAbschnittBefehl();
		// TestTFSWeiterSchalten();
		// DaVKomTSFWorkflow.getInstance(getDaVConnection()).getGuiwfDialogManager();

		// DaVKomTSFSteuerung.getInstance(getDaVConnection());
	}

	/**
	 * Test <code>atg.tsfWorkflow</code> lesen.
	 */
	public void TestTFSWorkflow()
	{
		DaVKomTSFWorkflow.getInstance(getDaVConnection());
	}

	/**
	 * Test <code>atgtfsAbschnittBefehl</code> lesend/schreibend.
	 */
	public void TestTFSAbschnittBefehl()
	{
		final boolean debug = false;
		final String zuBetrachtenderAsp = Defs.ASP_TSF_ZUSTAND;
		DaVKomTSFAbschnittBefehl daVKomTSFAbschnittBefehl = DaVKomTSFAbschnittBefehl
				.getInstance(getDaVConnection());

		PropertyChangeListener pcl = new PropertyChangeListener()
		{

			@Override
			public void propertyChange(PropertyChangeEvent evt)
			{

				if (evt.getPropertyName().equals(GUIModelTSFAbschnittBefehl.PROP_INIT))
				{
					if ((evt.getNewValue() != null)
							&& (evt.getNewValue() instanceof WrapperListenerBenachrichtigung[]))
					{
						WrapperListenerBenachrichtigung[] array = (WrapperListenerBenachrichtigung[]) evt
								.getNewValue();
						for (WrapperListenerBenachrichtigung wrapperListenerBenachrichtigung : array)
						{
							if (wrapperListenerBenachrichtigung.getPidAsp().equals(
									zuBetrachtenderAsp))
							{
								if (debug)
								{
									if (wrapperListenerBenachrichtigung.getPidAsp().equals(
											Defs.ASP_TSF_ZUSTAND))
									{
										System.out.println("INIT=>");
										System.out.println(wrapperListenerBenachrichtigung
												.getAbschnittBefehl());
									}
								}
							}
						}
					}
				} else if (evt.getPropertyName().equals(
						GUIModelTSFAbschnittBefehl.PROP_ADDED))
				{
					if ((evt.getNewValue() != null)
							&& (evt.getNewValue() instanceof WrapperListenerBenachrichtigung))
					{
						WrapperListenerBenachrichtigung wrapperListenerBenachrichtigung = (WrapperListenerBenachrichtigung) evt
								.getNewValue();
						if (wrapperListenerBenachrichtigung.getAbschnittBefehl() != null)
						{
							if (debug)
							{
								if (wrapperListenerBenachrichtigung.getPidAsp().equals(
										Defs.ASP_TSF_ZUSTAND))
								{
									System.out.println("ADD=>");
									System.out.println(wrapperListenerBenachrichtigung
											.getAbschnittBefehl());
								}
							}
						}
					}
				} else if (evt.getPropertyName().equals(
						GUIModelTSFAbschnittBefehl.PROP_REMOVED))
				{
					if ((evt.getOldValue() != null)
							&& (evt.getOldValue() instanceof WrapperListenerBenachrichtigung))
					{
						WrapperListenerBenachrichtigung wrapperListenerBenachrichtigungEntfernt = (WrapperListenerBenachrichtigung) evt
								.getOldValue();
						if (wrapperListenerBenachrichtigungEntfernt.getAbschnittBefehl() != null)
						{
							if (debug)
							{
								if (wrapperListenerBenachrichtigungEntfernt.getPidAsp().equals(
										Defs.ASP_TSF_ZUSTAND))
								{
									System.out.println("REMOVED=>");
									System.out.println(wrapperListenerBenachrichtigungEntfernt
											.getAbschnittBefehl());
								}
							}
						}
					}
				}

			}
		};
		daVKomTSFAbschnittBefehl.getModel().addListener(pcl);

	}

	public void TestTFSWeiterSchalten()
	{
		DaVKomTSFWeiterSchalten.getInstance(getDaVConnection());
	}

	protected static ClientDavConnection getDaVConnection()
	{
		if (_con == null)
		{
			String ip = "192.0.1.234";
			int port = 8083;
			String user = "Tester";
			String password = "geheim";

			try
			{
				_con = new ClientDavConnection();
				ClientDavParameters par = _con.getClientDavParameters();
				par.setDavCommunicationAddress(ip);
				par.setDavCommunicationSubAddress(port);
				par.setConfigurationPath("C:/temp/");
				try
				{
					_con.connect();
					try
					{
						_con.login(user, password);
						System.out.println("=>Verbindung aufgebaut, Benutzer angemeldet.");
					} catch (InconsistentLoginException e)
					{
						e.printStackTrace();
					}

				} catch (CommunicationError e)
				{
					e.printStackTrace();
				} catch (ConnectionException e)
				{
					e.printStackTrace();
				}

			} catch (MissingParameterException e)
			{
				e.printStackTrace();
			}
		}

		return _con;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		new Test();
	}

}
